// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from DiagLogSettings.idl.

package com.raritan.idl.diag;

import com.raritan.idl.*;
import com.raritan.util.AsyncRequest;

public interface DiagLogSettings {
  static public final TypeInfo typeInfo = new TypeInfo("diag.DiagLogSettings:1.0.0", null);

  public enum LogLevel {
    LOG_LEVEL_NONE,
    LOG_LEVEL_ERR,
    LOG_LEVEL_WARN,
    LOG_LEVEL_INFO,
    LOG_LEVEL_DEBUG,
    LOG_LEVEL_TRACE;
  }

  static public class LogLevelEntry implements Cloneable {
    public String ctxName = new String();
    public com.raritan.idl.diag.DiagLogSettings.LogLevel logLevel = com.raritan.idl.diag.DiagLogSettings.LogLevel.values()[0];

    public Object clone() {
      LogLevelEntry copy = new LogLevelEntry();

      copy.ctxName = this.ctxName;
      copy.logLevel = this.logLevel;

      return copy;
    }

  }

  public static final int ERR_NONE = 0;

  public static final int ERR_UNKNOWN_LOG_CONTEXT_NAME = 1;

  public static final int ERR_UNKNOWN_LOG_LEVEL = 2;
  Void resetLogLevelsForAllCtxNames() throws Exception;

  AsyncRequest resetLogLevelsForAllCtxNames(AsyncRpcResponse<Void> rsp);

  AsyncRequest resetLogLevelsForAllCtxNames(AsyncRpcResponse<Void> rsp, RpcCtrl rpcCtrl);


  public class GetLogLevelsForAllCtxNamesResult {
    public java.util.List<com.raritan.idl.diag.DiagLogSettings.LogLevelEntry> _ret_;
  }

  GetLogLevelsForAllCtxNamesResult getLogLevelsForAllCtxNames() throws Exception;

  AsyncRequest getLogLevelsForAllCtxNames(AsyncRpcResponse<GetLogLevelsForAllCtxNamesResult> rsp);

  AsyncRequest getLogLevelsForAllCtxNames(AsyncRpcResponse<GetLogLevelsForAllCtxNamesResult> rsp, RpcCtrl rpcCtrl);


  public class SetLogLevelForAllCtxNamesResult {
    public int _ret_;
  }

  SetLogLevelForAllCtxNamesResult setLogLevelForAllCtxNames(com.raritan.idl.diag.DiagLogSettings.LogLevel logLevel) throws Exception;

  AsyncRequest setLogLevelForAllCtxNames(com.raritan.idl.diag.DiagLogSettings.LogLevel logLevel, AsyncRpcResponse<SetLogLevelForAllCtxNamesResult> rsp);

  AsyncRequest setLogLevelForAllCtxNames(com.raritan.idl.diag.DiagLogSettings.LogLevel logLevel, AsyncRpcResponse<SetLogLevelForAllCtxNamesResult> rsp, RpcCtrl rpcCtrl);


  public class GetLogLevelByCtxNameResult {
    public int _ret_;
    public com.raritan.idl.diag.DiagLogSettings.LogLevel logLevel;
  }

  GetLogLevelByCtxNameResult getLogLevelByCtxName(String ctxName) throws Exception;

  AsyncRequest getLogLevelByCtxName(String ctxName, AsyncRpcResponse<GetLogLevelByCtxNameResult> rsp);

  AsyncRequest getLogLevelByCtxName(String ctxName, AsyncRpcResponse<GetLogLevelByCtxNameResult> rsp, RpcCtrl rpcCtrl);


  public class SetLogLevelByCtxNameResult {
    public int _ret_;
  }

  SetLogLevelByCtxNameResult setLogLevelByCtxName(String ctxName, com.raritan.idl.diag.DiagLogSettings.LogLevel logLevel) throws Exception;

  AsyncRequest setLogLevelByCtxName(String ctxName, com.raritan.idl.diag.DiagLogSettings.LogLevel logLevel, AsyncRpcResponse<SetLogLevelByCtxNameResult> rsp);

  AsyncRequest setLogLevelByCtxName(String ctxName, com.raritan.idl.diag.DiagLogSettings.LogLevel logLevel, AsyncRpcResponse<SetLogLevelByCtxNameResult> rsp, RpcCtrl rpcCtrl);

}
