// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from EventService.idl.

package com.raritan.idl.event;

import com.raritan.idl.*;
import com.raritan.util.AsyncRequest;

public interface Channel {
  static public final TypeInfo typeInfo = new TypeInfo("event.Channel:1.0.0", null);
  Void demandEventType(TypeInfo type) throws Exception;

  AsyncRequest demandEventType(TypeInfo type, AsyncRpcResponse<Void> rsp);

  AsyncRequest demandEventType(TypeInfo type, AsyncRpcResponse<Void> rsp, RpcCtrl rpcCtrl);

  Void cancelEventType(TypeInfo type) throws Exception;

  AsyncRequest cancelEventType(TypeInfo type, AsyncRpcResponse<Void> rsp);

  AsyncRequest cancelEventType(TypeInfo type, AsyncRpcResponse<Void> rsp, RpcCtrl rpcCtrl);

  Void demandEventTypes(java.util.List<TypeInfo> types) throws Exception;

  AsyncRequest demandEventTypes(java.util.List<TypeInfo> types, AsyncRpcResponse<Void> rsp);

  AsyncRequest demandEventTypes(java.util.List<TypeInfo> types, AsyncRpcResponse<Void> rsp, RpcCtrl rpcCtrl);

  Void cancelEventTypes(java.util.List<TypeInfo> types) throws Exception;

  AsyncRequest cancelEventTypes(java.util.List<TypeInfo> types, AsyncRpcResponse<Void> rsp);

  AsyncRequest cancelEventTypes(java.util.List<TypeInfo> types, AsyncRpcResponse<Void> rsp, RpcCtrl rpcCtrl);

  Void demandEvent(TypeInfo type, Object src) throws Exception;

  AsyncRequest demandEvent(TypeInfo type, Object src, AsyncRpcResponse<Void> rsp);

  AsyncRequest demandEvent(TypeInfo type, Object src, AsyncRpcResponse<Void> rsp, RpcCtrl rpcCtrl);

  Void cancelEvent(TypeInfo type, Object src) throws Exception;

  AsyncRequest cancelEvent(TypeInfo type, Object src, AsyncRpcResponse<Void> rsp);

  AsyncRequest cancelEvent(TypeInfo type, Object src, AsyncRpcResponse<Void> rsp, RpcCtrl rpcCtrl);


  static public class EventSelect implements Cloneable {
    public TypeInfo type = null;
    public Object src = null;

    public Object clone() {
      EventSelect copy = new EventSelect();

      copy.type = this.type;
      copy.src = this.src;

      return copy;
    }

  }
  Void demandEvents(java.util.List<com.raritan.idl.event.Channel.EventSelect> events) throws Exception;

  AsyncRequest demandEvents(java.util.List<com.raritan.idl.event.Channel.EventSelect> events, AsyncRpcResponse<Void> rsp);

  AsyncRequest demandEvents(java.util.List<com.raritan.idl.event.Channel.EventSelect> events, AsyncRpcResponse<Void> rsp, RpcCtrl rpcCtrl);

  Void cancelEvents(java.util.List<com.raritan.idl.event.Channel.EventSelect> events) throws Exception;

  AsyncRequest cancelEvents(java.util.List<com.raritan.idl.event.Channel.EventSelect> events, AsyncRpcResponse<Void> rsp);

  AsyncRequest cancelEvents(java.util.List<com.raritan.idl.event.Channel.EventSelect> events, AsyncRpcResponse<Void> rsp, RpcCtrl rpcCtrl);

  Void subscribe(com.raritan.idl.event.Consumer consumer) throws Exception;

  AsyncRequest subscribe(com.raritan.idl.event.Consumer consumer, AsyncRpcResponse<Void> rsp);

  AsyncRequest subscribe(com.raritan.idl.event.Consumer consumer, AsyncRpcResponse<Void> rsp, RpcCtrl rpcCtrl);


  public class UnsubscribeResult {
    public int _ret_;
  }

  UnsubscribeResult unsubscribe(com.raritan.idl.event.Consumer consumer) throws Exception;

  AsyncRequest unsubscribe(com.raritan.idl.event.Consumer consumer, AsyncRpcResponse<UnsubscribeResult> rsp);

  AsyncRequest unsubscribe(com.raritan.idl.event.Consumer consumer, AsyncRpcResponse<UnsubscribeResult> rsp, RpcCtrl rpcCtrl);


  public class PollEventsResult {
    public boolean _ret_;
    public java.util.List<com.raritan.idl.idl.Event> events;
  }

  PollEventsResult pollEvents() throws Exception;

  AsyncRequest pollEvents(AsyncRpcResponse<PollEventsResult> rsp);

  AsyncRequest pollEvents(AsyncRpcResponse<PollEventsResult> rsp, RpcCtrl rpcCtrl);

}
