// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from Firmware.idl.

package com.raritan.idl.firmware;

import com.raritan.idl.*;
import com.raritan.util.AsyncRequest;

public interface Firmware_2_0_3 {
  static public final TypeInfo typeInfo = new TypeInfo("firmware.Firmware:2.0.3", null);

  static public class Info implements Cloneable {
    public String product = new String();
    public String platform = new String();
    public String version = new String();

    public Object clone() {
      Info copy = new Info();

      copy.product = this.product;
      copy.platform = this.platform;
      copy.version = this.version;

      return copy;
    }

  }

  public class GetInfoResult {
    public com.raritan.idl.firmware.Firmware_2_0_3.Info _ret_;
  }

  GetInfoResult getInfo() throws Exception;

  AsyncRequest getInfo(AsyncRpcResponse<GetInfoResult> rsp);

  AsyncRequest getInfo(AsyncRpcResponse<GetInfoResult> rsp, RpcCtrl rpcCtrl);

  Void reboot() throws Exception;

  AsyncRequest reboot(AsyncRpcResponse<Void> rsp);

  AsyncRequest reboot(AsyncRpcResponse<Void> rsp, RpcCtrl rpcCtrl);

  Void factoryReset() throws Exception;

  AsyncRequest factoryReset(AsyncRpcResponse<Void> rsp);

  AsyncRequest factoryReset(AsyncRpcResponse<Void> rsp, RpcCtrl rpcCtrl);


  public class HardFactoryResetResult {
    public int _ret_;
  }

  HardFactoryResetResult hardFactoryReset() throws Exception;

  AsyncRequest hardFactoryReset(AsyncRpcResponse<HardFactoryResetResult> rsp);

  AsyncRequest hardFactoryReset(AsyncRpcResponse<HardFactoryResetResult> rsp, RpcCtrl rpcCtrl);


  public class ManufacturingResetResult {
    public int _ret_;
  }

  ManufacturingResetResult manufacturingReset() throws Exception;

  AsyncRequest manufacturingReset(AsyncRpcResponse<ManufacturingResetResult> rsp);

  AsyncRequest manufacturingReset(AsyncRpcResponse<ManufacturingResetResult> rsp, RpcCtrl rpcCtrl);


  public class GetVersionResult {
    public String _ret_;
  }

  GetVersionResult getVersion() throws Exception;

  AsyncRequest getVersion(AsyncRpcResponse<GetVersionResult> rsp);

  AsyncRequest getVersion(AsyncRpcResponse<GetVersionResult> rsp, RpcCtrl rpcCtrl);


  public class GetUpdateHistoryResult {
    public java.util.List<com.raritan.idl.firmware.UpdateHistoryEntry> _ret_;
  }

  GetUpdateHistoryResult getUpdateHistory() throws Exception;

  AsyncRequest getUpdateHistory(AsyncRpcResponse<GetUpdateHistoryResult> rsp);

  AsyncRequest getUpdateHistory(AsyncRpcResponse<GetUpdateHistoryResult> rsp, RpcCtrl rpcCtrl);


  public class GetImageStatusResult {
    public com.raritan.idl.firmware.ImageStatus _ret_;
  }

  GetImageStatusResult getImageStatus() throws Exception;

  AsyncRequest getImageStatus(AsyncRpcResponse<GetImageStatusResult> rsp);

  AsyncRequest getImageStatus(AsyncRpcResponse<GetImageStatusResult> rsp, RpcCtrl rpcCtrl);

  Void discardImage() throws Exception;

  AsyncRequest discardImage(AsyncRpcResponse<Void> rsp);

  AsyncRequest discardImage(AsyncRpcResponse<Void> rsp, RpcCtrl rpcCtrl);


  public class GetImageInfoResult {
    public boolean _ret_;
    public com.raritan.idl.firmware.ImageInfo_1_0_1 info;
  }

  GetImageInfoResult getImageInfo() throws Exception;

  AsyncRequest getImageInfo(AsyncRpcResponse<GetImageInfoResult> rsp);

  AsyncRequest getImageInfo(AsyncRpcResponse<GetImageInfoResult> rsp, RpcCtrl rpcCtrl);

  Void startUpdate(java.util.List<com.raritan.idl.firmware.UpdateFlags> flags) throws Exception;

  AsyncRequest startUpdate(java.util.List<com.raritan.idl.firmware.UpdateFlags> flags, AsyncRpcResponse<Void> rsp);

  AsyncRequest startUpdate(java.util.List<com.raritan.idl.firmware.UpdateFlags> flags, AsyncRpcResponse<Void> rsp, RpcCtrl rpcCtrl);

}
