// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from HardwareHealth.idl.

package com.raritan.idl.fitness;

import com.raritan.idl.*;
import com.raritan.util.AsyncRequest;

public interface HardwareHealth_1_0_2 {
  static public final TypeInfo typeInfo = new TypeInfo("fitness.HardwareHealth:1.0.2", null);

  public static final int FAILURE_TYPE_NETWORK_DEVICE_NOT_DETECTED = 1;

  public static final int FAILURE_TYPE_I2C_BUS_STUCK = 2;

  public static final int FAILURE_TYPE_SUB_CTRL_NOT_REACHABLE = 3;

  public static final int FAILURE_TYPE_SUB_CTRL_MALFUNCTION = 4;

  public static final int FAILURE_TYPE_OUTLET_POWER_STATE_INCONSISTENT = 5;

  static public class Failure implements Cloneable {
    public int creationOrderId = 0;
    public String componentId = new String();
    public int type = 0;
    public String description = new String();
    public boolean isAsserted = false;
    public java.util.Date lastAssertTimeStamp = new java.util.Date();
    public java.util.Date lastDeassertTimeStamp = new java.util.Date();
    public int assertCount = 0;

    public Object clone() {
      Failure copy = new Failure();

      copy.creationOrderId = this.creationOrderId;
      copy.componentId = this.componentId;
      copy.type = this.type;
      copy.description = this.description;
      copy.isAsserted = this.isAsserted;
      copy.lastAssertTimeStamp = this.lastAssertTimeStamp;
      copy.lastDeassertTimeStamp = this.lastDeassertTimeStamp;
      copy.assertCount = this.assertCount;

      return copy;
    }

  }

  public class FailureStatusChangedEvent extends com.raritan.idl.idl.Event {

    static public final TypeInfo typeInfo = new TypeInfo("fitness.HardwareHealth_1_0_2.FailureStatusChangedEvent:1.0.0", com.raritan.idl.idl.Event.typeInfo);

    @Override
    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public String componentId = new String();
    public int failureType = 0;
    public boolean isAsserted = false;
  }

  public class GetFailuresResult {
    public java.util.List<com.raritan.idl.fitness.HardwareHealth_1_0_2.Failure> _ret_;
  }

  GetFailuresResult getFailures() throws Exception;

  AsyncRequest getFailures(AsyncRpcResponse<GetFailuresResult> rsp);

  AsyncRequest getFailures(AsyncRpcResponse<GetFailuresResult> rsp, RpcCtrl rpcCtrl);

}
