// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from Lhx.idl.

package com.raritan.idl.lhxmodel;

import com.raritan.idl.*;
import com.raritan.util.AsyncRequest;

public interface Lhx {
  static public final TypeInfo typeInfo = new TypeInfo("lhxmodel.Lhx:1.0.0", null);

  public static final int ERR_INVALID_PARAMS = 1;

  public enum Events {
    EVT_KEY_OPSTATE_CHANGED,
    EVT_KEY_SETTINGS_CHANGED;
  }

  static public class MetaData implements Cloneable {
    public String model = new String();

    public Object clone() {
      MetaData copy = new MetaData();

      copy.model = this.model;

      return copy;
    }

  }

  static public class Settings implements Cloneable {
    public double setpointWaterValve = 0.0;
    public double setpointVentilators = 0.0;

    public Object clone() {
      Settings copy = new Settings();

      copy.setpointWaterValve = this.setpointWaterValve;
      copy.setpointVentilators = this.setpointVentilators;

      return copy;
    }

  }

  static public class Sensors implements Cloneable {
    public java.util.List<com.raritan.idl.lhxmodel.Sensor> airTemp = new java.util.ArrayList<>();
    public java.util.List<com.raritan.idl.lhxmodel.Sensor> waterTemp = new java.util.ArrayList<>();
    public java.util.List<com.raritan.idl.lhxmodel.Sensor> fanSpeed = new java.util.ArrayList<>();
    public com.raritan.idl.lhxmodel.Sensor doorContact = null;

    public Object clone() {
      Sensors copy = new Sensors();

      copy.airTemp = new java.util.ArrayList<com.raritan.idl.lhxmodel.Sensor>(this.airTemp);
      copy.waterTemp = new java.util.ArrayList<com.raritan.idl.lhxmodel.Sensor>(this.waterTemp);
      copy.fanSpeed = new java.util.ArrayList<com.raritan.idl.lhxmodel.Sensor>(this.fanSpeed);
      copy.doorContact = this.doorContact;

      return copy;
    }

  }

  static public class AlertStatus implements Cloneable {
    public java.util.List<Boolean> sensorFailure = new java.util.ArrayList<>();
    public java.util.List<Boolean> fanFailure = new java.util.ArrayList<>();
    public java.util.List<Boolean> powerSupplyFailure = new java.util.ArrayList<>();
    public boolean thresholdAirOutlet = false;
    public boolean thresholdAirInlet = false;
    public boolean thresholdWaterInlet = false;
    public boolean doorOpened = false;
    public boolean maximumCoolingRequest = false;
    public boolean emergencyCooling = false;
    public boolean waterLeak = false;
    public boolean thresholdHumidity = false;
    public boolean externalWaterCoolingFailure = false;
    public boolean thresholdWaterOutlet = false;
    public boolean parameterDataLoss = false;
    public boolean stBusError = false;
    public boolean collectiveFault = false;

    public Object clone() {
      AlertStatus copy = new AlertStatus();

      copy.sensorFailure = new java.util.ArrayList<Boolean>(this.sensorFailure);
      copy.fanFailure = new java.util.ArrayList<Boolean>(this.fanFailure);
      copy.powerSupplyFailure = new java.util.ArrayList<Boolean>(this.powerSupplyFailure);
      copy.thresholdAirOutlet = this.thresholdAirOutlet;
      copy.thresholdAirInlet = this.thresholdAirInlet;
      copy.thresholdWaterInlet = this.thresholdWaterInlet;
      copy.doorOpened = this.doorOpened;
      copy.maximumCoolingRequest = this.maximumCoolingRequest;
      copy.emergencyCooling = this.emergencyCooling;
      copy.waterLeak = this.waterLeak;
      copy.thresholdHumidity = this.thresholdHumidity;
      copy.externalWaterCoolingFailure = this.externalWaterCoolingFailure;
      copy.thresholdWaterOutlet = this.thresholdWaterOutlet;
      copy.parameterDataLoss = this.parameterDataLoss;
      copy.stBusError = this.stBusError;
      copy.collectiveFault = this.collectiveFault;

      return copy;
    }

  }

  static public class OpState implements Cloneable {
    public boolean on = false;
    public com.raritan.idl.lhxmodel.Lhx.AlertStatus alertStatus = new com.raritan.idl.lhxmodel.Lhx.AlertStatus();
    public int operatingHoursLhx = 0;
    public java.util.List<Integer> operatingHoursFan = new java.util.ArrayList<>();

    public Object clone() {
      OpState copy = new OpState();

      copy.on = this.on;
      Object alertStatusCopy = this.alertStatus.clone();
      copy.alertStatus = (com.raritan.idl.lhxmodel.Lhx.AlertStatus) alertStatusCopy;
      copy.operatingHoursLhx = this.operatingHoursLhx;
      copy.operatingHoursFan = new java.util.ArrayList<Integer>(this.operatingHoursFan);

      return copy;
    }

  }

  public class GetMetaDataResult {
    public com.raritan.idl.lhxmodel.Lhx.MetaData _ret_;
  }

  GetMetaDataResult getMetaData() throws Exception;

  AsyncRequest getMetaData(AsyncRpcResponse<GetMetaDataResult> rsp);

  AsyncRequest getMetaData(AsyncRpcResponse<GetMetaDataResult> rsp, RpcCtrl rpcCtrl);


  public class GetSettingsResult {
    public com.raritan.idl.lhxmodel.Lhx.Settings _ret_;
  }

  GetSettingsResult getSettings() throws Exception;

  AsyncRequest getSettings(AsyncRpcResponse<GetSettingsResult> rsp);

  AsyncRequest getSettings(AsyncRpcResponse<GetSettingsResult> rsp, RpcCtrl rpcCtrl);


  public class SetSettingsResult {
    public int _ret_;
  }

  SetSettingsResult setSettings(com.raritan.idl.lhxmodel.Lhx.Settings settings) throws Exception;

  AsyncRequest setSettings(com.raritan.idl.lhxmodel.Lhx.Settings settings, AsyncRpcResponse<SetSettingsResult> rsp);

  AsyncRequest setSettings(com.raritan.idl.lhxmodel.Lhx.Settings settings, AsyncRpcResponse<SetSettingsResult> rsp, RpcCtrl rpcCtrl);


  public class GetSensorsResult {
    public com.raritan.idl.lhxmodel.Lhx.Sensors _ret_;
  }

  GetSensorsResult getSensors() throws Exception;

  AsyncRequest getSensors(AsyncRpcResponse<GetSensorsResult> rsp);

  AsyncRequest getSensors(AsyncRpcResponse<GetSensorsResult> rsp, RpcCtrl rpcCtrl);


  public class GetOpStateResult {
    public com.raritan.idl.lhxmodel.Lhx.OpState _ret_;
  }

  GetOpStateResult getOpState() throws Exception;

  AsyncRequest getOpState(AsyncRpcResponse<GetOpStateResult> rsp);

  AsyncRequest getOpState(AsyncRpcResponse<GetOpStateResult> rsp, RpcCtrl rpcCtrl);

  Void setPowerState(com.raritan.idl.sensors.Sensor.OnOffState state) throws Exception;

  AsyncRequest setPowerState(com.raritan.idl.sensors.Sensor.OnOffState state, AsyncRpcResponse<Void> rsp);

  AsyncRequest setPowerState(com.raritan.idl.sensors.Sensor.OnOffState state, AsyncRpcResponse<Void> rsp, RpcCtrl rpcCtrl);

}
