// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from Lhx.idl.

package com.raritan.idl.lhxmodel;

import com.raritan.idl.*;
import com.raritan.util.AsyncRequest;

public interface Lhx_3_2_3 {
  static public final TypeInfo typeInfo = new TypeInfo("lhxmodel.Lhx:3.2.3", null);

  public static final int ERR_INVALID_PARAMS = 1;

  public static final int ERR_NOT_SUPPORTED = 2;

  static public class ParamCfg implements Cloneable {
    public double min = 0.0;
    public double max = 0.0;
    public int decdigits = 0;

    public Object clone() {
      ParamCfg copy = new ParamCfg();

      copy.min = this.min;
      copy.max = this.max;
      copy.decdigits = this.decdigits;

      return copy;
    }

  }

  static public class MetaData implements Cloneable {
    public String model = new String();
    public String version = new String();
    public com.raritan.idl.lhxmodel.Lhx_3_2_3.ParamCfg setpointWaterValveCfg = new com.raritan.idl.lhxmodel.Lhx_3_2_3.ParamCfg();
    public com.raritan.idl.lhxmodel.Lhx_3_2_3.ParamCfg setpointVentilatorsCfg = new com.raritan.idl.lhxmodel.Lhx_3_2_3.ParamCfg();
    public com.raritan.idl.lhxmodel.Lhx_3_2_3.ParamCfg defaultFanSpeedCfg = new com.raritan.idl.lhxmodel.Lhx_3_2_3.ParamCfg();

    public Object clone() {
      MetaData copy = new MetaData();

      copy.model = this.model;
      copy.version = this.version;
      Object setpointWaterValveCfgCopy = this.setpointWaterValveCfg.clone();
      copy.setpointWaterValveCfg = (com.raritan.idl.lhxmodel.Lhx_3_2_3.ParamCfg) setpointWaterValveCfgCopy;
      Object setpointVentilatorsCfgCopy = this.setpointVentilatorsCfg.clone();
      copy.setpointVentilatorsCfg = (com.raritan.idl.lhxmodel.Lhx_3_2_3.ParamCfg) setpointVentilatorsCfgCopy;
      Object defaultFanSpeedCfgCopy = this.defaultFanSpeedCfg.clone();
      copy.defaultFanSpeedCfg = (com.raritan.idl.lhxmodel.Lhx_3_2_3.ParamCfg) defaultFanSpeedCfgCopy;

      return copy;
    }

  }

  static public class Settings implements Cloneable {
    public double setpointWaterValve = 0.0;
    public double setpointVentilators = 0.0;
    public double defaultFanSpeed = 0.0;

    public Object clone() {
      Settings copy = new Settings();

      copy.setpointWaterValve = this.setpointWaterValve;
      copy.setpointVentilators = this.setpointVentilators;
      copy.defaultFanSpeed = this.defaultFanSpeed;

      return copy;
    }

  }

  static public class AlertStatus implements Cloneable {
    public java.util.List<Boolean> sensorFailure = new java.util.ArrayList<>();
    public java.util.List<Boolean> fanFailure = new java.util.ArrayList<>();
    public java.util.List<Boolean> powerSupplyFailure = new java.util.ArrayList<>();
    public boolean thresholdAirOutlet = false;
    public boolean thresholdAirInlet = false;
    public boolean thresholdWaterInlet = false;
    public boolean doorOpened = false;
    public boolean maximumCoolingRequest = false;
    public boolean emergencyCooling = false;
    public boolean waterLeak = false;
    public boolean thresholdHumidity = false;
    public boolean externalWaterCoolingFailure = false;
    public boolean thresholdWaterOutlet = false;
    public boolean stBusError = false;
    public boolean condenserPumpFailure = false;
    public boolean baseElectronicsFailure = false;
    public boolean voltageLow = false;

    public Object clone() {
      AlertStatus copy = new AlertStatus();

      copy.sensorFailure = new java.util.ArrayList<Boolean>(this.sensorFailure);
      copy.fanFailure = new java.util.ArrayList<Boolean>(this.fanFailure);
      copy.powerSupplyFailure = new java.util.ArrayList<Boolean>(this.powerSupplyFailure);
      copy.thresholdAirOutlet = this.thresholdAirOutlet;
      copy.thresholdAirInlet = this.thresholdAirInlet;
      copy.thresholdWaterInlet = this.thresholdWaterInlet;
      copy.doorOpened = this.doorOpened;
      copy.maximumCoolingRequest = this.maximumCoolingRequest;
      copy.emergencyCooling = this.emergencyCooling;
      copy.waterLeak = this.waterLeak;
      copy.thresholdHumidity = this.thresholdHumidity;
      copy.externalWaterCoolingFailure = this.externalWaterCoolingFailure;
      copy.thresholdWaterOutlet = this.thresholdWaterOutlet;
      copy.stBusError = this.stBusError;
      copy.condenserPumpFailure = this.condenserPumpFailure;
      copy.baseElectronicsFailure = this.baseElectronicsFailure;
      copy.voltageLow = this.voltageLow;

      return copy;
    }

  }

  static public class OpState implements Cloneable {
    public boolean on = false;
    public com.raritan.idl.lhxmodel.Lhx_3_2_3.AlertStatus alertStatus = new com.raritan.idl.lhxmodel.Lhx_3_2_3.AlertStatus();
    public int operatingHoursLhx = 0;
    public java.util.List<Integer> operatingHoursFan = new java.util.ArrayList<>();

    public Object clone() {
      OpState copy = new OpState();

      copy.on = this.on;
      Object alertStatusCopy = this.alertStatus.clone();
      copy.alertStatus = (com.raritan.idl.lhxmodel.Lhx_3_2_3.AlertStatus) alertStatusCopy;
      copy.operatingHoursLhx = this.operatingHoursLhx;
      copy.operatingHoursFan = new java.util.ArrayList<Integer>(this.operatingHoursFan);

      return copy;
    }

  }

  static public class Capabilities implements Cloneable {
    public com.raritan.idl.lhxmodel.Lhx_3_2_3.AlertStatus alerts = new com.raritan.idl.lhxmodel.Lhx_3_2_3.AlertStatus();
    public java.util.Map<String, Boolean> features = new java.util.HashMap<>();

    public Object clone() {
      Capabilities copy = new Capabilities();

      Object alertsCopy = this.alerts.clone();
      copy.alerts = (com.raritan.idl.lhxmodel.Lhx_3_2_3.AlertStatus) alertsCopy;
      copy.features = new java.util.HashMap<String, Boolean>(this.features);

      return copy;
    }

  }

  public class OpStateChangedEvent extends com.raritan.idl.idl.Event {

    static public final TypeInfo typeInfo = new TypeInfo("lhxmodel.Lhx_3_2_3.OpStateChangedEvent:1.0.0", com.raritan.idl.idl.Event.typeInfo);

    @Override
    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public com.raritan.idl.lhxmodel.Lhx_3_2_3.OpState oldState = new com.raritan.idl.lhxmodel.Lhx_3_2_3.OpState();
    public com.raritan.idl.lhxmodel.Lhx_3_2_3.OpState newState = new com.raritan.idl.lhxmodel.Lhx_3_2_3.OpState();
  }

  public class SettingsChangedEvent extends com.raritan.idl.event.UserEvent {

    static public final TypeInfo typeInfo = new TypeInfo("lhxmodel.Lhx_3_2_3.SettingsChangedEvent:1.0.0", com.raritan.idl.event.UserEvent.typeInfo);

    @Override
    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public com.raritan.idl.lhxmodel.Lhx_3_2_3.Settings oldSettings = new com.raritan.idl.lhxmodel.Lhx_3_2_3.Settings();
    public com.raritan.idl.lhxmodel.Lhx_3_2_3.Settings newSettings = new com.raritan.idl.lhxmodel.Lhx_3_2_3.Settings();
  }

  public class GetCapabilitiesResult {
    public com.raritan.idl.lhxmodel.Lhx_3_2_3.Capabilities _ret_;
  }

  GetCapabilitiesResult getCapabilities() throws Exception;

  AsyncRequest getCapabilities(AsyncRpcResponse<GetCapabilitiesResult> rsp);

  AsyncRequest getCapabilities(AsyncRpcResponse<GetCapabilitiesResult> rsp, RpcCtrl rpcCtrl);


  public class GetMetaDataResult {
    public com.raritan.idl.lhxmodel.Lhx_3_2_3.MetaData _ret_;
  }

  GetMetaDataResult getMetaData() throws Exception;

  AsyncRequest getMetaData(AsyncRpcResponse<GetMetaDataResult> rsp);

  AsyncRequest getMetaData(AsyncRpcResponse<GetMetaDataResult> rsp, RpcCtrl rpcCtrl);


  public class GetSettingsResult {
    public com.raritan.idl.lhxmodel.Lhx_3_2_3.Settings _ret_;
  }

  GetSettingsResult getSettings() throws Exception;

  AsyncRequest getSettings(AsyncRpcResponse<GetSettingsResult> rsp);

  AsyncRequest getSettings(AsyncRpcResponse<GetSettingsResult> rsp, RpcCtrl rpcCtrl);


  public class SetSettingsResult {
    public int _ret_;
  }

  SetSettingsResult setSettings(com.raritan.idl.lhxmodel.Lhx_3_2_3.Settings settings) throws Exception;

  AsyncRequest setSettings(com.raritan.idl.lhxmodel.Lhx_3_2_3.Settings settings, AsyncRpcResponse<SetSettingsResult> rsp);

  AsyncRequest setSettings(com.raritan.idl.lhxmodel.Lhx_3_2_3.Settings settings, AsyncRpcResponse<SetSettingsResult> rsp, RpcCtrl rpcCtrl);


  public class GetSensorsResult {
    public java.util.List<com.raritan.idl.lhxmodel.Sensor_4_0_2> _ret_;
  }

  GetSensorsResult getSensors() throws Exception;

  AsyncRequest getSensors(AsyncRpcResponse<GetSensorsResult> rsp);

  AsyncRequest getSensors(AsyncRpcResponse<GetSensorsResult> rsp, RpcCtrl rpcCtrl);


  public class GetOpStateResult {
    public com.raritan.idl.lhxmodel.Lhx_3_2_3.OpState _ret_;
  }

  GetOpStateResult getOpState() throws Exception;

  AsyncRequest getOpState(AsyncRpcResponse<GetOpStateResult> rsp);

  AsyncRequest getOpState(AsyncRpcResponse<GetOpStateResult> rsp, RpcCtrl rpcCtrl);


  public class SetPowerStateResult {
    public int _ret_;
  }

  SetPowerStateResult setPowerState(com.raritan.idl.sensors.Sensor_4_0_2.OnOffState state) throws Exception;

  AsyncRequest setPowerState(com.raritan.idl.sensors.Sensor_4_0_2.OnOffState state, AsyncRpcResponse<SetPowerStateResult> rsp);

  AsyncRequest setPowerState(com.raritan.idl.sensors.Sensor_4_0_2.OnOffState state, AsyncRpcResponse<SetPowerStateResult> rsp, RpcCtrl rpcCtrl);


  public class GetParametersResult {
    public java.util.List<com.raritan.idl.lhxmodel.Parameter_2_0_1> _ret_;
  }

  GetParametersResult getParameters() throws Exception;

  AsyncRequest getParameters(AsyncRpcResponse<GetParametersResult> rsp);

  AsyncRequest getParameters(AsyncRpcResponse<GetParametersResult> rsp, RpcCtrl rpcCtrl);


  public class GetActualValuesResult {
    public java.util.List<com.raritan.idl.lhxmodel.Parameter_2_0_1> _ret_;
  }

  GetActualValuesResult getActualValues() throws Exception;

  AsyncRequest getActualValues(AsyncRpcResponse<GetActualValuesResult> rsp);

  AsyncRequest getActualValues(AsyncRpcResponse<GetActualValuesResult> rsp, RpcCtrl rpcCtrl);


  public class SetMaximumCoolingRequestResult {
    public int _ret_;
  }

  SetMaximumCoolingRequestResult setMaximumCoolingRequest(boolean requested) throws Exception;

  AsyncRequest setMaximumCoolingRequest(boolean requested, AsyncRpcResponse<SetMaximumCoolingRequestResult> rsp);

  AsyncRequest setMaximumCoolingRequest(boolean requested, AsyncRpcResponse<SetMaximumCoolingRequestResult> rsp, RpcCtrl rpcCtrl);


  public class AcknowledgeAlertStatusResult {
    public int _ret_;
  }

  AcknowledgeAlertStatusResult acknowledgeAlertStatus() throws Exception;

  AsyncRequest acknowledgeAlertStatus(AsyncRpcResponse<AcknowledgeAlertStatusResult> rsp);

  AsyncRequest acknowledgeAlertStatus(AsyncRpcResponse<AcknowledgeAlertStatusResult> rsp, RpcCtrl rpcCtrl);

}
