// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from LhxParameter.idl.

package com.raritan.idl.lhxmodel;

import com.raritan.idl.*;
import com.raritan.util.AsyncRequest;

public interface Parameter_1_0_1 {
  static public final TypeInfo typeInfo = new TypeInfo("lhxmodel.Parameter:1.0.1", null);

  public static final int ERR_INVALID_PARAMS = 1;

  public static final int ERR_READ_ONLY = 2;

  public enum Events {
    EVT_KEY_VALUE_CHANGED,
    EVT_KEY_METADATA_CHANGED;
  }

  public enum Unit {
    NONE,
    NUMBER,
    BINARY,
    TEMP_ABS,
    TEMP_REL,
    BAR,
    PASCAL,
    SIEMENS,
    METER,
    VOLT,
    AMPERE,
    HOURS,
    MINUTES,
    SECONDS,
    TIME,
    METERS_PER_SECOND,
    NEWTON,
    GRAMMS,
    HUMIDITY_REL,
    HERTZ,
    OHM,
    PERCENT,
    LITERS_PER_MINUTE,
    LITERS_PER_HOUR;
  }

  static public class Status implements Cloneable {
    public boolean switchedOn = false;
    public boolean active = false;
    public boolean overflow = false;
    public boolean underflow = false;
    public boolean valid = false;

    public Object clone() {
      Status copy = new Status();

      copy.switchedOn = this.switchedOn;
      copy.active = this.active;
      copy.overflow = this.overflow;
      copy.underflow = this.underflow;
      copy.valid = this.valid;

      return copy;
    }

  }

  static public class MetaData implements Cloneable {
    public com.raritan.idl.lhxmodel.Parameter_1_0_1.Unit unit = com.raritan.idl.lhxmodel.Parameter_1_0_1.Unit.values()[0];
    public String id = new String();
    public double defaultValue = 0.0;
    public double min = 0.0;
    public double max = 0.0;
    public boolean read_only = false;
    public int decDigits = 0;

    public Object clone() {
      MetaData copy = new MetaData();

      copy.unit = this.unit;
      copy.id = this.id;
      copy.defaultValue = this.defaultValue;
      copy.min = this.min;
      copy.max = this.max;
      copy.read_only = this.read_only;
      copy.decDigits = this.decDigits;

      return copy;
    }

  }

  static public class Value implements Cloneable {
    public java.util.Date timestamp = new java.util.Date();
    public com.raritan.idl.lhxmodel.Parameter_1_0_1.Status status = new com.raritan.idl.lhxmodel.Parameter_1_0_1.Status();
    public double value = 0.0;

    public Object clone() {
      Value copy = new Value();

      copy.timestamp = this.timestamp;
      Object statusCopy = this.status.clone();
      copy.status = (com.raritan.idl.lhxmodel.Parameter_1_0_1.Status) statusCopy;
      copy.value = this.value;

      return copy;
    }

  }

  public class GetMetaDataResult {
    public com.raritan.idl.lhxmodel.Parameter_1_0_1.MetaData _ret_;
  }

  GetMetaDataResult getMetaData() throws Exception;

  AsyncRequest getMetaData(AsyncRpcResponse<GetMetaDataResult> rsp);

  AsyncRequest getMetaData(AsyncRpcResponse<GetMetaDataResult> rsp, RpcCtrl rpcCtrl);


  public class GetValueResult {
    public com.raritan.idl.lhxmodel.Parameter_1_0_1.Value _ret_;
  }

  GetValueResult getValue() throws Exception;

  AsyncRequest getValue(AsyncRpcResponse<GetValueResult> rsp);

  AsyncRequest getValue(AsyncRpcResponse<GetValueResult> rsp, RpcCtrl rpcCtrl);


  public class GetRawValueResult {
    public int _ret_;
  }

  GetRawValueResult getRawValue() throws Exception;

  AsyncRequest getRawValue(AsyncRpcResponse<GetRawValueResult> rsp);

  AsyncRequest getRawValue(AsyncRpcResponse<GetRawValueResult> rsp, RpcCtrl rpcCtrl);


  public class SetRawValueResult {
    public int _ret_;
  }

  SetRawValueResult setRawValue(int rawValue) throws Exception;

  AsyncRequest setRawValue(int rawValue, AsyncRpcResponse<SetRawValueResult> rsp);

  AsyncRequest setRawValue(int rawValue, AsyncRpcResponse<SetRawValueResult> rsp, RpcCtrl rpcCtrl);

}
