// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from Net.idl.

package com.raritan.idl.net;

import com.raritan.idl.*;
import com.raritan.util.AsyncRequest;

public interface Net_7_0_1 {
  static public final TypeInfo typeInfo = new TypeInfo("net.Net:7.0.1", null);

  public static final int SUCCESS = 0;

  public static final int ERR_DNS_TOO_MANY_SERVERS = 100;

  public static final int ERR_DNS_INVALID_SERVER = 101;

  public static final int ERR_DNS_TOO_MANY_SEARCH_SUFFIXES = 102;

  public static final int ERR_DNS_INVALID_SEARCH_SUFFIX = 103;

  public static final int ERR_ROUTING_IPV4_INVALID_DFLT_GATEWAY_ADDR = 200;

  public static final int ERR_ROUTING_IPV6_INVALID_DFLT_GATEWAY_ADDR = 201;

  public static final int ERR_ROUTING_IPV4_INVALID_DEST_ADDR = 202;

  public static final int ERR_ROUTING_IPV6_INVALID_DEST_ADDR = 203;

  public static final int ERR_ROUTING_IPV4_INVALID_DEST_PREFIX_LEN = 204;

  public static final int ERR_ROUTING_IPV6_INVALID_DEST_PREFIX_LEN = 205;

  public static final int ERR_ROUTING_IPV4_INVALID_NEXTHOP_ADDR = 206;

  public static final int ERR_ROUTING_IPV6_INVALID_NEXTHOP_ADDR = 207;

  public static final int ERR_ROUTING_IPV4_INVALID_INTERFACE = 208;

  public static final int ERR_ROUTING_IPV6_INVALID_INTERFACE = 209;

  public static final int ERR_ROUTING_IPV4_DEST_IS_NO_NETWORK_ADDR = 210;

  public static final int ERR_ROUTING_IPV6_DEST_IS_NO_NETWORK_ADDR = 211;

  public static final int ERR_ROUTING_IPV4_DEST_IS_DUPLICATE = 212;

  public static final int ERR_ROUTING_IPV6_DEST_IS_DUPLICATE = 213;

  public static final int ERR_ROUTING_IPV4_NO_NEXTHOP_OR_INTERFACE = 214;

  public static final int ERR_ROUTING_IPV6_NO_NEXTHOP_OR_INTERFACE = 215;

  public static final int ERR_ROUTING_IPV4_NEXTHOP_AND_INTERFACE_SET = 216;

  public static final int ERR_ROUTING_IPV6_NEXTHOP_AND_INTERFACE_SET = 217;

  public static final int ERR_PF_INVALID_PRIMARY_UNIT_DOWNSTREAM_INTERFACE = 300;

  public static final int ERR_PF_NO_WORKING_PRIMARY_UNIT_UPSTREAM_INTERFACE = 301;

  public static final int ERR_PF_NOT_SUPPORTED = 302;

  public static final int ERR_IF_IPV4_INVALID_CONFIG_METHOD = 400;

  public static final int ERR_IF_IPV6_INVALID_CONFIG_METHOD = 401;

  public static final int ERR_IF_IPV4_INVALID_STATIC_ADDR = 402;

  public static final int ERR_IF_IPV6_INVALID_STATIC_ADDR = 403;

  public static final int ERR_IF_IPV4_INVALID_STATIC_PREFIX_LEN = 404;

  public static final int ERR_IF_IPV6_INVALID_STATIC_PREFIX_LEN = 405;

  public static final int ERR_IF_IPV4_INVALID_DHCP_PREF_HOSTNAME = 406;

  public static final int ERR_IF_IPV6_INVALID_DHCP_PREF_HOSTNAME = 407;

  public static final int ERR_IF_EAP_INVALID_IDENTITY = 408;

  public static final int ERR_IF_EAP_INVALID_PASSWORD = 409;

  public static final int ERR_IF_EAP_INVALID_CLIENT_CERT = 410;

  public static final int ERR_IF_EAP_INVALID_CLIENT_PRIV_KEY_OR_PWD = 411;

  public static final int ERR_IF_EAP_CLIENT_CERT_PRIV_KEY_MISMATCH = 412;

  public static final int ERR_IF_EAP_INVALID_CA_CERT = 413;

  public static final int ERR_IF_EAP_CA_CERT_VERIFY_FAILED = 414;

  public static final int ERR_IF_EAP_INVALID_AUTH_SERVER_NAME = 415;

  public static final int ERR_ETH_IF_UNSUPPORTED_LINKMODE = 500;

  public static final int ERR_ETH_IF_INVALID_MTU = 501;

  public static final int ERR_WLAN_IF_INVALID_SSID = 600;

  public static final int ERR_WLAN_IF_INVALID_BSSID = 601;

  public static final int ERR_WLAN_IF_INVALID_PSK = 602;

  public static final int ERR_WLAN_IF_INVALID_MTU = 603;

  public static final int ERR_WLAN_IF_NOT_SUPPORTED = 604;

  public static final int ERR_BRIDGE_IF_NOT_SUPPORTED = 700;

  public class GetInfoResult {
    public com.raritan.idl.net.Info_3_0_0 _ret_;
  }

  GetInfoResult getInfo() throws Exception;

  AsyncRequest getInfo(AsyncRpcResponse<GetInfoResult> rsp);

  AsyncRequest getInfo(AsyncRpcResponse<GetInfoResult> rsp, RpcCtrl rpcCtrl);


  public class GetSettingsResult {
    public com.raritan.idl.net.Settings_5_0_0 _ret_;
  }

  GetSettingsResult getSettings() throws Exception;

  AsyncRequest getSettings(AsyncRpcResponse<GetSettingsResult> rsp);

  AsyncRequest getSettings(AsyncRpcResponse<GetSettingsResult> rsp, RpcCtrl rpcCtrl);


  public class SetSettingsResult {
    public int _ret_;
  }

  SetSettingsResult setSettings(com.raritan.idl.net.Settings_5_0_0 settings) throws Exception;

  AsyncRequest setSettings(com.raritan.idl.net.Settings_5_0_0 settings, AsyncRpcResponse<SetSettingsResult> rsp);

  AsyncRequest setSettings(com.raritan.idl.net.Settings_5_0_0 settings, AsyncRpcResponse<SetSettingsResult> rsp, RpcCtrl rpcCtrl);


  public class GetPortForwardingProtocolMappingsResult {
    public java.util.List<com.raritan.idl.net.PortForwardingProtocolMapping> _ret_;
  }

  GetPortForwardingProtocolMappingsResult getPortForwardingProtocolMappings() throws Exception;

  AsyncRequest getPortForwardingProtocolMappings(AsyncRpcResponse<GetPortForwardingProtocolMappingsResult> rsp);

  AsyncRequest getPortForwardingProtocolMappings(AsyncRpcResponse<GetPortForwardingProtocolMappingsResult> rsp, RpcCtrl rpcCtrl);

}
