// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from Ade.idl.

package com.raritan.idl.pdumodel;

import com.raritan.idl.*;
import com.raritan.util.AsyncRequest;

public interface Ade {
  static public final TypeInfo typeInfo = new TypeInfo("pdumodel.Ade:1.0.0", null);

  static public class MetaData implements Cloneable {
    public String adeType = new String();
    public int channels = 0;
    public double currentDivider = 0.0;
    public double voltageDivider = 0.0;
    public double energyDivider = 0.0;

    public Object clone() {
      MetaData copy = new MetaData();

      copy.adeType = this.adeType;
      copy.channels = this.channels;
      copy.currentDivider = this.currentDivider;
      copy.voltageDivider = this.voltageDivider;
      copy.energyDivider = this.energyDivider;

      return copy;
    }

  }

  static public class Sample implements Cloneable {
    public long vrms = 0;
    public long irms = 0;
    public long watt = 0;
    public long va = 0;
    public long wh = 0;
    public long vah = 0;

    public Object clone() {
      Sample copy = new Sample();

      copy.vrms = this.vrms;
      copy.irms = this.irms;
      copy.watt = this.watt;
      copy.va = this.va;
      copy.wh = this.wh;
      copy.vah = this.vah;

      return copy;
    }

  }

  public class GetMetaDataResult {
    public com.raritan.idl.pdumodel.Ade.MetaData _ret_;
  }

  GetMetaDataResult getMetaData() throws Exception;

  AsyncRequest getMetaData(AsyncRpcResponse<GetMetaDataResult> rsp);

  AsyncRequest getMetaData(AsyncRpcResponse<GetMetaDataResult> rsp, RpcCtrl rpcCtrl);


  public class GetLatestSampleResult {
    public java.util.List<com.raritan.idl.pdumodel.Ade.Sample> _ret_;
  }

  GetLatestSampleResult getLatestSample() throws Exception;

  AsyncRequest getLatestSample(AsyncRpcResponse<GetLatestSampleResult> rsp);

  AsyncRequest getLatestSample(AsyncRpcResponse<GetLatestSampleResult> rsp, RpcCtrl rpcCtrl);


  public class GetCalibrationDataResult {
    public java.util.Map<String, Long> _ret_;
  }

  GetCalibrationDataResult getCalibrationData() throws Exception;

  AsyncRequest getCalibrationData(AsyncRpcResponse<GetCalibrationDataResult> rsp);

  AsyncRequest getCalibrationData(AsyncRpcResponse<GetCalibrationDataResult> rsp, RpcCtrl rpcCtrl);


  public class SetCalibrationDataResult {
    public int _ret_;
  }

  SetCalibrationDataResult setCalibrationData(java.util.Map<String, Long> regs) throws Exception;

  AsyncRequest setCalibrationData(java.util.Map<String, Long> regs, AsyncRpcResponse<SetCalibrationDataResult> rsp);

  AsyncRequest setCalibrationData(java.util.Map<String, Long> regs, AsyncRpcResponse<SetCalibrationDataResult> rsp, RpcCtrl rpcCtrl);

}
