// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from Bcm.idl.

package com.raritan.idl.pdumodel;

import com.raritan.idl.*;
import com.raritan.util.AsyncRequest;

public interface Bcm {
  static public final TypeInfo typeInfo = new TypeInfo("pdumodel.Bcm:1.0.0", null);

  public enum LineConfig {
    UNCONNECTED,
    L1_N,
    L2_N,
    L3_N;
  }

  public enum TransformerType {
    VOLTAGE,
    TURNSRATIO;
  }

  static public class PhaseConfig implements Cloneable {
    public com.raritan.idl.pdumodel.Bcm.LineConfig lineConfig = com.raritan.idl.pdumodel.Bcm.LineConfig.values()[0];
    public com.raritan.idl.pdumodel.Bcm.TransformerType ctType = com.raritan.idl.pdumodel.Bcm.TransformerType.values()[0];
    public int fsCurrent = 0;
    public int fsVoltage = 0;
    public int turnsRatio = 0;
    public int burdenResistor = 0;

    public Object clone() {
      PhaseConfig copy = new PhaseConfig();

      copy.lineConfig = this.lineConfig;
      copy.ctType = this.ctType;
      copy.fsCurrent = this.fsCurrent;
      copy.fsVoltage = this.fsVoltage;
      copy.turnsRatio = this.turnsRatio;
      copy.burdenResistor = this.burdenResistor;

      return copy;
    }

  }

  static public class ChannelConfig implements Cloneable {
    public int channel = 0;
    public String label = new String();
    public boolean is3Phase = false;
    public com.raritan.idl.pdumodel.Bcm.PhaseConfig lineA = new com.raritan.idl.pdumodel.Bcm.PhaseConfig();
    public com.raritan.idl.pdumodel.Bcm.PhaseConfig lineB = new com.raritan.idl.pdumodel.Bcm.PhaseConfig();
    public com.raritan.idl.pdumodel.Bcm.PhaseConfig lineC = new com.raritan.idl.pdumodel.Bcm.PhaseConfig();

    public Object clone() {
      ChannelConfig copy = new ChannelConfig();

      copy.channel = this.channel;
      copy.label = this.label;
      copy.is3Phase = this.is3Phase;
      Object lineACopy = this.lineA.clone();
      copy.lineA = (com.raritan.idl.pdumodel.Bcm.PhaseConfig) lineACopy;
      Object lineBCopy = this.lineB.clone();
      copy.lineB = (com.raritan.idl.pdumodel.Bcm.PhaseConfig) lineBCopy;
      Object lineCCopy = this.lineC.clone();
      copy.lineC = (com.raritan.idl.pdumodel.Bcm.PhaseConfig) lineCCopy;

      return copy;
    }

  }

  public class GetChannelCountResult {
    public int _ret_;
  }

  GetChannelCountResult getChannelCount() throws Exception;

  AsyncRequest getChannelCount(AsyncRpcResponse<GetChannelCountResult> rsp);

  AsyncRequest getChannelCount(AsyncRpcResponse<GetChannelCountResult> rsp, RpcCtrl rpcCtrl);


  public class GetChannelConfigsResult {
    public java.util.List<com.raritan.idl.pdumodel.Bcm.ChannelConfig> _ret_;
  }

  GetChannelConfigsResult getChannelConfigs() throws Exception;

  AsyncRequest getChannelConfigs(AsyncRpcResponse<GetChannelConfigsResult> rsp);

  AsyncRequest getChannelConfigs(AsyncRpcResponse<GetChannelConfigsResult> rsp, RpcCtrl rpcCtrl);


  public class SetChannelConfigResult {
    public int _ret_;
  }

  SetChannelConfigResult setChannelConfig(int channel, com.raritan.idl.pdumodel.Bcm.ChannelConfig config) throws Exception;

  AsyncRequest setChannelConfig(int channel, com.raritan.idl.pdumodel.Bcm.ChannelConfig config, AsyncRpcResponse<SetChannelConfigResult> rsp);

  AsyncRequest setChannelConfig(int channel, com.raritan.idl.pdumodel.Bcm.ChannelConfig config, AsyncRpcResponse<SetChannelConfigResult> rsp, RpcCtrl rpcCtrl);

}
