// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from Controller.idl.

package com.raritan.idl.pdumodel;

import com.raritan.idl.*;
import com.raritan.util.AsyncRequest;

public interface Controller_5_0_0 {
  static public final TypeInfo typeInfo = new TypeInfo("pdumodel.Controller:5.0.0", null);

  public static final int ERR_NOT_SUPPORTED = 1;

  public enum Status {
    OK,
    COMMUNICATION_UNSTABLE,
    COMMUNICATION_FAILURE,
    UNKNOWN,
    INCOMPATIBLE,
    FIRMWARE_UPDATE;
  }

  public enum Type {
    OUTLET_CTRL,
    INLET_CTRL,
    METER_CTRL;
  }

  static public class MetaData implements Cloneable {
    public com.raritan.idl.pdumodel.Controller_5_0_0.Type type = com.raritan.idl.pdumodel.Controller_5_0_0.Type.values()[0];
    public String address = new String();
    public int magic = 0;
    public boolean versionAvailable = false;
    public int fwAppVersion = 0;
    public int fwBootVersion = 0;
    public int hwVersion = 0;
    public String serial = new String();
    public boolean haveResetCnt = false;
    public boolean haveEmResetCnt = false;

    public Object clone() {
      MetaData copy = new MetaData();

      copy.type = this.type;
      copy.address = this.address;
      copy.magic = this.magic;
      copy.versionAvailable = this.versionAvailable;
      copy.fwAppVersion = this.fwAppVersion;
      copy.fwBootVersion = this.fwBootVersion;
      copy.hwVersion = this.hwVersion;
      copy.serial = this.serial;
      copy.haveResetCnt = this.haveResetCnt;
      copy.haveEmResetCnt = this.haveEmResetCnt;

      return copy;
    }

  }

  public class StatusChangedEvent extends com.raritan.idl.idl.Event {

    static public final TypeInfo typeInfo = new TypeInfo("pdumodel.Controller_5_0_0.StatusChangedEvent:1.0.0", com.raritan.idl.idl.Event.typeInfo);

    @Override
    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public com.raritan.idl.pdumodel.Controller_5_0_0.Status oldStatus = com.raritan.idl.pdumodel.Controller_5_0_0.Status.values()[0];
    public com.raritan.idl.pdumodel.Controller_5_0_0.Status newStatus = com.raritan.idl.pdumodel.Controller_5_0_0.Status.values()[0];
  }

  public class MetaDataChangedEvent extends com.raritan.idl.idl.Event {

    static public final TypeInfo typeInfo = new TypeInfo("pdumodel.Controller_5_0_0.MetaDataChangedEvent:1.0.0", com.raritan.idl.idl.Event.typeInfo);

    @Override
    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public com.raritan.idl.pdumodel.Controller_5_0_0.MetaData oldMetaData = new com.raritan.idl.pdumodel.Controller_5_0_0.MetaData();
    public com.raritan.idl.pdumodel.Controller_5_0_0.MetaData newMetaData = new com.raritan.idl.pdumodel.Controller_5_0_0.MetaData();
  }

  public class GetCommunicationStatusResult {
    public com.raritan.idl.pdumodel.Controller_5_0_0.Status _ret_;
  }

  GetCommunicationStatusResult getCommunicationStatus() throws Exception;

  AsyncRequest getCommunicationStatus(AsyncRpcResponse<GetCommunicationStatusResult> rsp);

  AsyncRequest getCommunicationStatus(AsyncRpcResponse<GetCommunicationStatusResult> rsp, RpcCtrl rpcCtrl);


  public class GetStatisticsResult {
    public com.raritan.idl.pdumodel.CtrlStatistic_2_0_0 _ret_;
  }

  GetStatisticsResult getStatistics() throws Exception;

  AsyncRequest getStatistics(AsyncRpcResponse<GetStatisticsResult> rsp);

  AsyncRequest getStatistics(AsyncRpcResponse<GetStatisticsResult> rsp, RpcCtrl rpcCtrl);


  public class GetMetaDataResult {
    public com.raritan.idl.pdumodel.Controller_5_0_0.MetaData _ret_;
  }

  GetMetaDataResult getMetaData() throws Exception;

  AsyncRequest getMetaData(AsyncRpcResponse<GetMetaDataResult> rsp);

  AsyncRequest getMetaData(AsyncRpcResponse<GetMetaDataResult> rsp, RpcCtrl rpcCtrl);


  public class ResetResult {
    public int _ret_;
  }

  ResetResult reset() throws Exception;

  AsyncRequest reset(AsyncRpcResponse<ResetResult> rsp);

  AsyncRequest reset(AsyncRpcResponse<ResetResult> rsp, RpcCtrl rpcCtrl);

}
