// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from Inlet.idl.

package com.raritan.idl.pdumodel;

import com.raritan.idl.*;
import com.raritan.util.AsyncRequest;

public interface Inlet_1_1_5 extends com.raritan.idl.pdumodel.EDevice {
  static public final TypeInfo typeInfo = new TypeInfo("pdumodel.Inlet:1.1.5", com.raritan.idl.pdumodel.EDevice.typeInfo);

  public enum Events {
    EVT_KEY_SETTINGS_CHANGED,
    EVT_KEY_ENABLE_STATE_CHANGED;
  }

  static public class MetaData implements Cloneable {
    public String label = new String();
    public String plugType = new String();
    public com.raritan.idl.pdumodel.Nameplate namePlate = new com.raritan.idl.pdumodel.Nameplate();
    public com.raritan.idl.pdumodel.Rating rating = new com.raritan.idl.pdumodel.Rating();

    public Object clone() {
      MetaData copy = new MetaData();

      copy.label = this.label;
      copy.plugType = this.plugType;
      Object namePlateCopy = this.namePlate.clone();
      copy.namePlate = (com.raritan.idl.pdumodel.Nameplate) namePlateCopy;
      Object ratingCopy = this.rating.clone();
      copy.rating = (com.raritan.idl.pdumodel.Rating) ratingCopy;

      return copy;
    }

  }

  static public class Sensors implements Cloneable {
    public com.raritan.idl.sensors.NumericSensor_3_0_1 voltage = null;
    public com.raritan.idl.sensors.NumericSensor_3_0_1 current = null;
    public com.raritan.idl.sensors.NumericSensor_3_0_1 peakCurrent = null;
    public com.raritan.idl.sensors.NumericSensor_3_0_1 residualCurrent = null;
    public com.raritan.idl.sensors.NumericSensor_3_0_1 activePower = null;
    public com.raritan.idl.sensors.NumericSensor_3_0_1 apparentPower = null;
    public com.raritan.idl.sensors.NumericSensor_3_0_1 powerFactor = null;
    public com.raritan.idl.sensors.NumericSensor_3_0_1 activeEnergy = null;
    public com.raritan.idl.sensors.NumericSensor_3_0_1 apparentEnergy = null;
    public com.raritan.idl.sensors.NumericSensor_3_0_1 unbalancedCurrent = null;
    public com.raritan.idl.sensors.NumericSensor_3_0_1 lineFrequency = null;
    public com.raritan.idl.sensors.NumericSensor_3_0_1 phaseAngle = null;
    public com.raritan.idl.sensors.StateSensor_3_0_1 powerQuality = null;
    public com.raritan.idl.sensors.StateSensor_3_0_1 surgeProtectorStatus = null;
    public com.raritan.idl.pdumodel.ResidualCurrentStateSensor residualCurrentStatus = null;

    public Object clone() {
      Sensors copy = new Sensors();

      copy.voltage = this.voltage;
      copy.current = this.current;
      copy.peakCurrent = this.peakCurrent;
      copy.residualCurrent = this.residualCurrent;
      copy.activePower = this.activePower;
      copy.apparentPower = this.apparentPower;
      copy.powerFactor = this.powerFactor;
      copy.activeEnergy = this.activeEnergy;
      copy.apparentEnergy = this.apparentEnergy;
      copy.unbalancedCurrent = this.unbalancedCurrent;
      copy.lineFrequency = this.lineFrequency;
      copy.phaseAngle = this.phaseAngle;
      copy.powerQuality = this.powerQuality;
      copy.surgeProtectorStatus = this.surgeProtectorStatus;
      copy.residualCurrentStatus = this.residualCurrentStatus;

      return copy;
    }

  }

  static public class Settings implements Cloneable {
    public String name = new String();

    public Object clone() {
      Settings copy = new Settings();

      copy.name = this.name;

      return copy;
    }

  }

  public class GetMetaDataResult {
    public com.raritan.idl.pdumodel.Inlet_1_1_5.MetaData _ret_;
  }

  GetMetaDataResult getMetaData() throws Exception;

  AsyncRequest getMetaData(AsyncRpcResponse<GetMetaDataResult> rsp);

  AsyncRequest getMetaData(AsyncRpcResponse<GetMetaDataResult> rsp, RpcCtrl rpcCtrl);


  public class GetSensorsResult {
    public com.raritan.idl.pdumodel.Inlet_1_1_5.Sensors _ret_;
  }

  GetSensorsResult getSensors() throws Exception;

  AsyncRequest getSensors(AsyncRpcResponse<GetSensorsResult> rsp);

  AsyncRequest getSensors(AsyncRpcResponse<GetSensorsResult> rsp, RpcCtrl rpcCtrl);


  public class GetPolesResult {
    public java.util.List<com.raritan.idl.pdumodel.Pole_1_1_1> _ret_;
  }

  GetPolesResult getPoles() throws Exception;

  AsyncRequest getPoles(AsyncRpcResponse<GetPolesResult> rsp);

  AsyncRequest getPoles(AsyncRpcResponse<GetPolesResult> rsp, RpcCtrl rpcCtrl);


  public class GetSettingsResult {
    public com.raritan.idl.pdumodel.Inlet_1_1_5.Settings _ret_;
  }

  GetSettingsResult getSettings() throws Exception;

  AsyncRequest getSettings(AsyncRpcResponse<GetSettingsResult> rsp);

  AsyncRequest getSettings(AsyncRpcResponse<GetSettingsResult> rsp, RpcCtrl rpcCtrl);


  public class SetSettingsResult {
    public int _ret_;
  }

  SetSettingsResult setSettings(com.raritan.idl.pdumodel.Inlet_1_1_5.Settings settings) throws Exception;

  AsyncRequest setSettings(com.raritan.idl.pdumodel.Inlet_1_1_5.Settings settings, AsyncRpcResponse<SetSettingsResult> rsp);

  AsyncRequest setSettings(com.raritan.idl.pdumodel.Inlet_1_1_5.Settings settings, AsyncRpcResponse<SetSettingsResult> rsp, RpcCtrl rpcCtrl);

  Void setEnabled(boolean enabled) throws Exception;

  AsyncRequest setEnabled(boolean enabled, AsyncRpcResponse<Void> rsp);

  AsyncRequest setEnabled(boolean enabled, AsyncRpcResponse<Void> rsp, RpcCtrl rpcCtrl);


  public class IsEnabledResult {
    public boolean _ret_;
  }

  IsEnabledResult isEnabled() throws Exception;

  AsyncRequest isEnabled(AsyncRpcResponse<IsEnabledResult> rsp);

  AsyncRequest isEnabled(AsyncRpcResponse<IsEnabledResult> rsp, RpcCtrl rpcCtrl);

}
