// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from Inlet.idl.

package com.raritan.idl.pdumodel;

import com.raritan.idl.*;
import com.raritan.util.AsyncRequest;

public interface Inlet_2_0_1 extends com.raritan.idl.pdumodel.EDevice {
  static public final TypeInfo typeInfo = new TypeInfo("pdumodel.Inlet:2.0.1", com.raritan.idl.pdumodel.EDevice.typeInfo);

  static public class MetaData implements Cloneable {
    public String label = new String();
    public String plugType = new String();
    public com.raritan.idl.pdumodel.Nameplate namePlate = new com.raritan.idl.pdumodel.Nameplate();
    public com.raritan.idl.pdumodel.Rating rating = new com.raritan.idl.pdumodel.Rating();

    public Object clone() {
      MetaData copy = new MetaData();

      copy.label = this.label;
      copy.plugType = this.plugType;
      Object namePlateCopy = this.namePlate.clone();
      copy.namePlate = (com.raritan.idl.pdumodel.Nameplate) namePlateCopy;
      Object ratingCopy = this.rating.clone();
      copy.rating = (com.raritan.idl.pdumodel.Rating) ratingCopy;

      return copy;
    }

  }

  static public class Sensors implements Cloneable {
    public com.raritan.idl.sensors.NumericSensor_4_0_2 voltage = null;
    public com.raritan.idl.sensors.NumericSensor_4_0_2 current = null;
    public com.raritan.idl.sensors.NumericSensor_4_0_2 peakCurrent = null;
    public com.raritan.idl.sensors.NumericSensor_4_0_2 residualCurrent = null;
    public com.raritan.idl.sensors.NumericSensor_4_0_2 activePower = null;
    public com.raritan.idl.sensors.NumericSensor_4_0_2 reactivePower = null;
    public com.raritan.idl.sensors.NumericSensor_4_0_2 apparentPower = null;
    public com.raritan.idl.sensors.NumericSensor_4_0_2 powerFactor = null;
    public com.raritan.idl.sensors.NumericSensor_4_0_2 displacementPowerFactor = null;
    public com.raritan.idl.sensors.NumericSensor_4_0_2 activeEnergy = null;
    public com.raritan.idl.sensors.NumericSensor_4_0_2 apparentEnergy = null;
    public com.raritan.idl.sensors.NumericSensor_4_0_2 unbalancedCurrent = null;
    public com.raritan.idl.sensors.NumericSensor_4_0_2 lineFrequency = null;
    public com.raritan.idl.sensors.NumericSensor_4_0_2 phaseAngle = null;
    public com.raritan.idl.sensors.StateSensor_4_0_2 powerQuality = null;
    public com.raritan.idl.sensors.StateSensor_4_0_2 surgeProtectorStatus = null;
    public com.raritan.idl.pdumodel.ResidualCurrentStateSensor_2_0_2 residualCurrentStatus = null;

    public Object clone() {
      Sensors copy = new Sensors();

      copy.voltage = this.voltage;
      copy.current = this.current;
      copy.peakCurrent = this.peakCurrent;
      copy.residualCurrent = this.residualCurrent;
      copy.activePower = this.activePower;
      copy.reactivePower = this.reactivePower;
      copy.apparentPower = this.apparentPower;
      copy.powerFactor = this.powerFactor;
      copy.displacementPowerFactor = this.displacementPowerFactor;
      copy.activeEnergy = this.activeEnergy;
      copy.apparentEnergy = this.apparentEnergy;
      copy.unbalancedCurrent = this.unbalancedCurrent;
      copy.lineFrequency = this.lineFrequency;
      copy.phaseAngle = this.phaseAngle;
      copy.powerQuality = this.powerQuality;
      copy.surgeProtectorStatus = this.surgeProtectorStatus;
      copy.residualCurrentStatus = this.residualCurrentStatus;

      return copy;
    }

  }

  static public class Settings implements Cloneable {
    public String name = new String();

    public Object clone() {
      Settings copy = new Settings();

      copy.name = this.name;

      return copy;
    }

  }

  public class SettingsChangedEvent extends com.raritan.idl.event.UserEvent {

    static public final TypeInfo typeInfo = new TypeInfo("pdumodel.Inlet_2_0_1.SettingsChangedEvent:1.0.0", com.raritan.idl.event.UserEvent.typeInfo);

    @Override
    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public com.raritan.idl.pdumodel.Inlet_2_0_1.Settings oldSettings = new com.raritan.idl.pdumodel.Inlet_2_0_1.Settings();
    public com.raritan.idl.pdumodel.Inlet_2_0_1.Settings newSettings = new com.raritan.idl.pdumodel.Inlet_2_0_1.Settings();
  }

  public class EnableStateChangedEvent extends com.raritan.idl.event.UserEvent {

    static public final TypeInfo typeInfo = new TypeInfo("pdumodel.Inlet_2_0_1.EnableStateChangedEvent:1.0.0", com.raritan.idl.event.UserEvent.typeInfo);

    @Override
    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public boolean enabled = false;
  }

  public class GetMetaDataResult {
    public com.raritan.idl.pdumodel.Inlet_2_0_1.MetaData _ret_;
  }

  GetMetaDataResult getMetaData() throws Exception;

  AsyncRequest getMetaData(AsyncRpcResponse<GetMetaDataResult> rsp);

  AsyncRequest getMetaData(AsyncRpcResponse<GetMetaDataResult> rsp, RpcCtrl rpcCtrl);


  public class GetSensorsResult {
    public com.raritan.idl.pdumodel.Inlet_2_0_1.Sensors _ret_;
  }

  GetSensorsResult getSensors() throws Exception;

  AsyncRequest getSensors(AsyncRpcResponse<GetSensorsResult> rsp);

  AsyncRequest getSensors(AsyncRpcResponse<GetSensorsResult> rsp, RpcCtrl rpcCtrl);


  public class GetPolesResult {
    public java.util.List<com.raritan.idl.pdumodel.Pole_4_0_1> _ret_;
  }

  GetPolesResult getPoles() throws Exception;

  AsyncRequest getPoles(AsyncRpcResponse<GetPolesResult> rsp);

  AsyncRequest getPoles(AsyncRpcResponse<GetPolesResult> rsp, RpcCtrl rpcCtrl);


  public class GetSettingsResult {
    public com.raritan.idl.pdumodel.Inlet_2_0_1.Settings _ret_;
  }

  GetSettingsResult getSettings() throws Exception;

  AsyncRequest getSettings(AsyncRpcResponse<GetSettingsResult> rsp);

  AsyncRequest getSettings(AsyncRpcResponse<GetSettingsResult> rsp, RpcCtrl rpcCtrl);


  public class SetSettingsResult {
    public int _ret_;
  }

  SetSettingsResult setSettings(com.raritan.idl.pdumodel.Inlet_2_0_1.Settings settings) throws Exception;

  AsyncRequest setSettings(com.raritan.idl.pdumodel.Inlet_2_0_1.Settings settings, AsyncRpcResponse<SetSettingsResult> rsp);

  AsyncRequest setSettings(com.raritan.idl.pdumodel.Inlet_2_0_1.Settings settings, AsyncRpcResponse<SetSettingsResult> rsp, RpcCtrl rpcCtrl);

  Void setEnabled(boolean enabled) throws Exception;

  AsyncRequest setEnabled(boolean enabled, AsyncRpcResponse<Void> rsp);

  AsyncRequest setEnabled(boolean enabled, AsyncRpcResponse<Void> rsp, RpcCtrl rpcCtrl);


  public class IsEnabledResult {
    public boolean _ret_;
  }

  IsEnabledResult isEnabled() throws Exception;

  AsyncRequest isEnabled(AsyncRpcResponse<IsEnabledResult> rsp);

  AsyncRequest isEnabled(AsyncRpcResponse<IsEnabledResult> rsp, RpcCtrl rpcCtrl);

}
