// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from Pdu.idl.

package com.raritan.idl.pdumodel;

import com.raritan.idl.*;
import com.raritan.util.AsyncRequest;

public interface Pdu_6_3_3 {
  static public final TypeInfo typeInfo = new TypeInfo("pdumodel.Pdu:6.3.3", null);

  public static final int ERR_INVALID_PARAM = 1;

  public enum PduOrientation {
    PO_NONE,
    PO_BOTTOMFEED,
    PO_TOPFEED;
  }

  static public class MetaData implements Cloneable {
    public com.raritan.idl.pdumodel.Nameplate_2_0_0 nameplate = new com.raritan.idl.pdumodel.Nameplate_2_0_0();
    public String ctrlBoardSerial = new String();
    public String hwRevision = new String();
    public String fwRevision = new String();
    public String macAddress = new String();
    public boolean hasSwitchableOutlets = false;
    public boolean hasMeteredOutlets = false;
    public boolean hasLatchingOutletRelays = false;
    public boolean isInlineMeter = false;
    public boolean isEnergyPulseSupported = false;
    public boolean hasDCInlets = false;
    public com.raritan.idl.pdumodel.Pdu_6_3_3.PduOrientation pduOrientation = com.raritan.idl.pdumodel.Pdu_6_3_3.PduOrientation.values()[0];

    public Object clone() {
      MetaData copy = new MetaData();

      Object nameplateCopy = this.nameplate.clone();
      copy.nameplate = (com.raritan.idl.pdumodel.Nameplate_2_0_0) nameplateCopy;
      copy.ctrlBoardSerial = this.ctrlBoardSerial;
      copy.hwRevision = this.hwRevision;
      copy.fwRevision = this.fwRevision;
      copy.macAddress = this.macAddress;
      copy.hasSwitchableOutlets = this.hasSwitchableOutlets;
      copy.hasMeteredOutlets = this.hasMeteredOutlets;
      copy.hasLatchingOutletRelays = this.hasLatchingOutletRelays;
      copy.isInlineMeter = this.isInlineMeter;
      copy.isEnergyPulseSupported = this.isEnergyPulseSupported;
      copy.hasDCInlets = this.hasDCInlets;
      copy.pduOrientation = this.pduOrientation;

      return copy;
    }

  }

  static public class Sensors implements Cloneable {
    public java.util.List<com.raritan.idl.sensors.StateSensor_4_0_6> powerSupplyStatus = new java.util.ArrayList<>();
    public com.raritan.idl.sensors.NumericSensor_4_0_7 activePower = null;
    public com.raritan.idl.sensors.NumericSensor_4_0_7 apparentPower = null;
    public com.raritan.idl.sensors.NumericSensor_4_0_7 activeEnergy = null;
    public com.raritan.idl.sensors.NumericSensor_4_0_7 apparentEnergy = null;

    public Object clone() {
      Sensors copy = new Sensors();

      copy.powerSupplyStatus = new java.util.ArrayList<com.raritan.idl.sensors.StateSensor_4_0_6>(this.powerSupplyStatus);
      copy.activePower = this.activePower;
      copy.apparentPower = this.apparentPower;
      copy.activeEnergy = this.activeEnergy;
      copy.apparentEnergy = this.apparentEnergy;

      return copy;
    }

  }

  static public class Statistic implements Cloneable {
    public java.util.List<com.raritan.idl.pdumodel.CircuitBreakerStatistic> cbStats = new java.util.ArrayList<>();
    public java.util.List<com.raritan.idl.pdumodel.CtrlStatistic_2_0_0> ctrlStats = new java.util.ArrayList<>();
    public java.util.List<com.raritan.idl.pdumodel.OutletStatistic> outletStats = new java.util.ArrayList<>();
    public com.raritan.idl.peripheral.DeviceManager_5_2_4.Statistics peripheralStats = new com.raritan.idl.peripheral.DeviceManager_5_2_4.Statistics();

    public Object clone() {
      Statistic copy = new Statistic();

      copy.cbStats = new java.util.ArrayList<com.raritan.idl.pdumodel.CircuitBreakerStatistic>(this.cbStats);
      copy.ctrlStats = new java.util.ArrayList<com.raritan.idl.pdumodel.CtrlStatistic_2_0_0>(this.ctrlStats);
      copy.outletStats = new java.util.ArrayList<com.raritan.idl.pdumodel.OutletStatistic>(this.outletStats);
      Object peripheralStatsCopy = this.peripheralStats.clone();
      copy.peripheralStats = (com.raritan.idl.peripheral.DeviceManager_5_2_4.Statistics) peripheralStatsCopy;

      return copy;
    }

  }

  public enum StartupState {
    SS_ON,
    SS_OFF,
    SS_LASTKNOWN;
  }

  static public class Settings implements Cloneable {
    public String name = new String();
    public com.raritan.idl.pdumodel.Pdu_6_3_3.StartupState startupState = com.raritan.idl.pdumodel.Pdu_6_3_3.StartupState.values()[0];
    public int cycleDelay = 0;
    public int inRushGuardDelay = 0;
    public java.util.List<Integer> outletPowerStateSequence = new java.util.ArrayList<>();
    public int powerOnDelay = 0;
    public boolean latchingRelays = false;
    public boolean energyPulseEnabled = false;
    public int energyPulsesPerKWh = 0;
    public int demandUpdateInterval = 0;
    public int demandAveragingIntervals = 0;
    public boolean suspendTripCauseOutlets = false;

    public Object clone() {
      Settings copy = new Settings();

      copy.name = this.name;
      copy.startupState = this.startupState;
      copy.cycleDelay = this.cycleDelay;
      copy.inRushGuardDelay = this.inRushGuardDelay;
      copy.outletPowerStateSequence = new java.util.ArrayList<Integer>(this.outletPowerStateSequence);
      copy.powerOnDelay = this.powerOnDelay;
      copy.latchingRelays = this.latchingRelays;
      copy.energyPulseEnabled = this.energyPulseEnabled;
      copy.energyPulsesPerKWh = this.energyPulsesPerKWh;
      copy.demandUpdateInterval = this.demandUpdateInterval;
      copy.demandAveragingIntervals = this.demandAveragingIntervals;
      copy.suspendTripCauseOutlets = this.suspendTripCauseOutlets;

      return copy;
    }

  }

  static public class OutletSequenceState implements Cloneable {
    public boolean sequenceRunning = false;
    public int nextOutletToSwitch = 0;
    public int timeUntilNextSwitch = 0;
    public int outletsRemaining = 0;
    public int cancelableOutletsRemaining = 0;

    public Object clone() {
      OutletSequenceState copy = new OutletSequenceState();

      copy.sequenceRunning = this.sequenceRunning;
      copy.nextOutletToSwitch = this.nextOutletToSwitch;
      copy.timeUntilNextSwitch = this.timeUntilNextSwitch;
      copy.outletsRemaining = this.outletsRemaining;
      copy.cancelableOutletsRemaining = this.cancelableOutletsRemaining;

      return copy;
    }

  }

  public class SettingsChangedEvent extends com.raritan.idl.event.UserEvent {

    static public final TypeInfo typeInfo = new TypeInfo("pdumodel.Pdu_6_3_3.SettingsChangedEvent:1.0.0", com.raritan.idl.event.UserEvent.typeInfo);

    @Override
    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public com.raritan.idl.pdumodel.Pdu_6_3_3.Settings oldSettings = new com.raritan.idl.pdumodel.Pdu_6_3_3.Settings();
    public com.raritan.idl.pdumodel.Pdu_6_3_3.Settings newSettings = new com.raritan.idl.pdumodel.Pdu_6_3_3.Settings();
  }

  public class LoadSheddingModeChangedEvent extends com.raritan.idl.event.UserEvent {

    static public final TypeInfo typeInfo = new TypeInfo("pdumodel.Pdu_6_3_3.LoadSheddingModeChangedEvent:1.0.0", com.raritan.idl.event.UserEvent.typeInfo);

    @Override
    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public boolean enabled = false;
  }

  public class OutletSequenceStateChangedEvent extends com.raritan.idl.idl.Event {

    static public final TypeInfo typeInfo = new TypeInfo("pdumodel.Pdu_6_3_3.OutletSequenceStateChangedEvent:1.0.0", com.raritan.idl.idl.Event.typeInfo);

    @Override
    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public com.raritan.idl.pdumodel.Pdu_6_3_3.OutletSequenceState newState = new com.raritan.idl.pdumodel.Pdu_6_3_3.OutletSequenceState();
  }

  public class GetNameplateResult {
    public com.raritan.idl.pdumodel.Nameplate_2_0_0 _ret_;
  }

  GetNameplateResult getNameplate() throws Exception;

  AsyncRequest getNameplate(AsyncRpcResponse<GetNameplateResult> rsp);

  AsyncRequest getNameplate(AsyncRpcResponse<GetNameplateResult> rsp, RpcCtrl rpcCtrl);


  public class GetMetaDataResult {
    public com.raritan.idl.pdumodel.Pdu_6_3_3.MetaData _ret_;
  }

  GetMetaDataResult getMetaData() throws Exception;

  AsyncRequest getMetaData(AsyncRpcResponse<GetMetaDataResult> rsp);

  AsyncRequest getMetaData(AsyncRpcResponse<GetMetaDataResult> rsp, RpcCtrl rpcCtrl);


  public class GetSensorsResult {
    public com.raritan.idl.pdumodel.Pdu_6_3_3.Sensors _ret_;
  }

  GetSensorsResult getSensors() throws Exception;

  AsyncRequest getSensors(AsyncRpcResponse<GetSensorsResult> rsp);

  AsyncRequest getSensors(AsyncRpcResponse<GetSensorsResult> rsp, RpcCtrl rpcCtrl);


  public class GetSensorLoggerResult {
    public com.raritan.idl.sensors.Logger_3_1_2 _ret_;
  }

  GetSensorLoggerResult getSensorLogger() throws Exception;

  AsyncRequest getSensorLogger(AsyncRpcResponse<GetSensorLoggerResult> rsp);

  AsyncRequest getSensorLogger(AsyncRpcResponse<GetSensorLoggerResult> rsp, RpcCtrl rpcCtrl);


  public class GetAlertedSensorManagerResult {
    public com.raritan.idl.sensors.AlertedSensorManager_1_0_4 _ret_;
  }

  GetAlertedSensorManagerResult getAlertedSensorManager() throws Exception;

  AsyncRequest getAlertedSensorManager(AsyncRpcResponse<GetAlertedSensorManagerResult> rsp);

  AsyncRequest getAlertedSensorManager(AsyncRpcResponse<GetAlertedSensorManagerResult> rsp, RpcCtrl rpcCtrl);


  public class GetControllersResult {
    public java.util.List<com.raritan.idl.pdumodel.Controller_5_0_0> _ret_;
  }

  GetControllersResult getControllers() throws Exception;

  AsyncRequest getControllers(AsyncRpcResponse<GetControllersResult> rsp);

  AsyncRequest getControllers(AsyncRpcResponse<GetControllersResult> rsp, RpcCtrl rpcCtrl);


  public class GetOutletsResult {
    public java.util.List<com.raritan.idl.pdumodel.Outlet_3_0_2> _ret_;
  }

  GetOutletsResult getOutlets() throws Exception;

  AsyncRequest getOutlets(AsyncRpcResponse<GetOutletsResult> rsp);

  AsyncRequest getOutlets(AsyncRpcResponse<GetOutletsResult> rsp, RpcCtrl rpcCtrl);


  public class GetOverCurrentProtectorsResult {
    public java.util.List<com.raritan.idl.pdumodel.OverCurrentProtector_4_0_2> _ret_;
  }

  GetOverCurrentProtectorsResult getOverCurrentProtectors() throws Exception;

  AsyncRequest getOverCurrentProtectors(AsyncRpcResponse<GetOverCurrentProtectorsResult> rsp);

  AsyncRequest getOverCurrentProtectors(AsyncRpcResponse<GetOverCurrentProtectorsResult> rsp, RpcCtrl rpcCtrl);


  public class GetInletsResult {
    public java.util.List<com.raritan.idl.pdumodel.Inlet_3_0_2> _ret_;
  }

  GetInletsResult getInlets() throws Exception;

  AsyncRequest getInlets(AsyncRpcResponse<GetInletsResult> rsp);

  AsyncRequest getInlets(AsyncRpcResponse<GetInletsResult> rsp, RpcCtrl rpcCtrl);


  public class GetTransferSwitchesResult {
    public java.util.List<com.raritan.idl.pdumodel.TransferSwitch_5_0_3> _ret_;
  }

  GetTransferSwitchesResult getTransferSwitches() throws Exception;

  AsyncRequest getTransferSwitches(AsyncRpcResponse<GetTransferSwitchesResult> rsp);

  AsyncRequest getTransferSwitches(AsyncRpcResponse<GetTransferSwitchesResult> rsp, RpcCtrl rpcCtrl);


  public class GetPeripheralDeviceManagerResult {
    public com.raritan.idl.peripheral.DeviceManager_5_2_4 _ret_;
  }

  GetPeripheralDeviceManagerResult getPeripheralDeviceManager() throws Exception;

  AsyncRequest getPeripheralDeviceManager(AsyncRpcResponse<GetPeripheralDeviceManagerResult> rsp);

  AsyncRequest getPeripheralDeviceManager(AsyncRpcResponse<GetPeripheralDeviceManagerResult> rsp, RpcCtrl rpcCtrl);


  public class GetBeeperResult {
    public com.raritan.idl.hmi.InternalBeeper_2_0_1 _ret_;
  }

  GetBeeperResult getBeeper() throws Exception;

  AsyncRequest getBeeper(AsyncRpcResponse<GetBeeperResult> rsp);

  AsyncRequest getBeeper(AsyncRpcResponse<GetBeeperResult> rsp, RpcCtrl rpcCtrl);


  public class GetSettingsResult {
    public com.raritan.idl.pdumodel.Pdu_6_3_3.Settings _ret_;
  }

  GetSettingsResult getSettings() throws Exception;

  AsyncRequest getSettings(AsyncRpcResponse<GetSettingsResult> rsp);

  AsyncRequest getSettings(AsyncRpcResponse<GetSettingsResult> rsp, RpcCtrl rpcCtrl);


  public class IsLoadSheddingActiveResult {
    public boolean _ret_;
  }

  IsLoadSheddingActiveResult isLoadSheddingActive() throws Exception;

  AsyncRequest isLoadSheddingActive(AsyncRpcResponse<IsLoadSheddingActiveResult> rsp);

  AsyncRequest isLoadSheddingActive(AsyncRpcResponse<IsLoadSheddingActiveResult> rsp, RpcCtrl rpcCtrl);


  public class SetSettingsResult {
    public int _ret_;
  }

  SetSettingsResult setSettings(com.raritan.idl.pdumodel.Pdu_6_3_3.Settings settings) throws Exception;

  AsyncRequest setSettings(com.raritan.idl.pdumodel.Pdu_6_3_3.Settings settings, AsyncRpcResponse<SetSettingsResult> rsp);

  AsyncRequest setSettings(com.raritan.idl.pdumodel.Pdu_6_3_3.Settings settings, AsyncRpcResponse<SetSettingsResult> rsp, RpcCtrl rpcCtrl);

  Void setLoadSheddingActive(boolean active) throws Exception;

  AsyncRequest setLoadSheddingActive(boolean active, AsyncRpcResponse<Void> rsp);

  AsyncRequest setLoadSheddingActive(boolean active, AsyncRpcResponse<Void> rsp, RpcCtrl rpcCtrl);


  public class GetFeaturePortsResult {
    public java.util.List<com.raritan.idl.portsmodel.Port_2_0_3> _ret_;
  }

  GetFeaturePortsResult getFeaturePorts() throws Exception;

  AsyncRequest getFeaturePorts(AsyncRpcResponse<GetFeaturePortsResult> rsp);

  AsyncRequest getFeaturePorts(AsyncRpcResponse<GetFeaturePortsResult> rsp, RpcCtrl rpcCtrl);


  public class GetSensorPortsResult {
    public java.util.List<com.raritan.idl.portsmodel.Port_2_0_3> _ret_;
  }

  GetSensorPortsResult getSensorPorts() throws Exception;

  AsyncRequest getSensorPorts(AsyncRpcResponse<GetSensorPortsResult> rsp);

  AsyncRequest getSensorPorts(AsyncRpcResponse<GetSensorPortsResult> rsp, RpcCtrl rpcCtrl);


  public class GetRemoteHubPortsResult {
    public java.util.List<com.raritan.idl.portsmodel.Port_2_0_3> _ret_;
  }

  GetRemoteHubPortsResult getRemoteHubPorts() throws Exception;

  AsyncRequest getRemoteHubPorts(AsyncRpcResponse<GetRemoteHubPortsResult> rsp);

  AsyncRequest getRemoteHubPorts(AsyncRpcResponse<GetRemoteHubPortsResult> rsp, RpcCtrl rpcCtrl);


  public class EnterRS485ConfigModeAndAssignCtrlBoardAddressResult {
    public int _ret_;
  }

  EnterRS485ConfigModeAndAssignCtrlBoardAddressResult enterRS485ConfigModeAndAssignCtrlBoardAddress(int addr) throws Exception;

  AsyncRequest enterRS485ConfigModeAndAssignCtrlBoardAddress(int addr, AsyncRpcResponse<EnterRS485ConfigModeAndAssignCtrlBoardAddressResult> rsp);

  AsyncRequest enterRS485ConfigModeAndAssignCtrlBoardAddress(int addr, AsyncRpcResponse<EnterRS485ConfigModeAndAssignCtrlBoardAddressResult> rsp, RpcCtrl rpcCtrl);


  public class EnterRS485ConfigModeAndAssignSCBoardAddressResult {
    public int _ret_;
  }

  EnterRS485ConfigModeAndAssignSCBoardAddressResult enterRS485ConfigModeAndAssignSCBoardAddress(int deviceId, int addr) throws Exception;

  AsyncRequest enterRS485ConfigModeAndAssignSCBoardAddress(int deviceId, int addr, AsyncRpcResponse<EnterRS485ConfigModeAndAssignSCBoardAddressResult> rsp);

  AsyncRequest enterRS485ConfigModeAndAssignSCBoardAddress(int deviceId, int addr, AsyncRpcResponse<EnterRS485ConfigModeAndAssignSCBoardAddressResult> rsp, RpcCtrl rpcCtrl);


  public class LeaveRS485ConfigModeResult {
    public int _ret_;
  }

  LeaveRS485ConfigModeResult leaveRS485ConfigMode() throws Exception;

  AsyncRequest leaveRS485ConfigMode(AsyncRpcResponse<LeaveRS485ConfigModeResult> rsp);

  AsyncRequest leaveRS485ConfigMode(AsyncRpcResponse<LeaveRS485ConfigModeResult> rsp, RpcCtrl rpcCtrl);


  public class SetAllOutletPowerStatesResult {
    public int _ret_;
  }

  SetAllOutletPowerStatesResult setAllOutletPowerStates(com.raritan.idl.pdumodel.Outlet_3_0_2.PowerState pstate) throws Exception;

  AsyncRequest setAllOutletPowerStates(com.raritan.idl.pdumodel.Outlet_3_0_2.PowerState pstate, AsyncRpcResponse<SetAllOutletPowerStatesResult> rsp);

  AsyncRequest setAllOutletPowerStates(com.raritan.idl.pdumodel.Outlet_3_0_2.PowerState pstate, AsyncRpcResponse<SetAllOutletPowerStatesResult> rsp, RpcCtrl rpcCtrl);


  public class SetMultipleOutletPowerStatesResult {
    public int _ret_;
  }

  SetMultipleOutletPowerStatesResult setMultipleOutletPowerStates(java.util.List<Integer> outletNumbers, com.raritan.idl.pdumodel.Outlet_3_0_2.PowerState state, boolean respectSequence) throws Exception;

  AsyncRequest setMultipleOutletPowerStates(java.util.List<Integer> outletNumbers, com.raritan.idl.pdumodel.Outlet_3_0_2.PowerState state, boolean respectSequence, AsyncRpcResponse<SetMultipleOutletPowerStatesResult> rsp);

  AsyncRequest setMultipleOutletPowerStates(java.util.List<Integer> outletNumbers, com.raritan.idl.pdumodel.Outlet_3_0_2.PowerState state, boolean respectSequence, AsyncRpcResponse<SetMultipleOutletPowerStatesResult> rsp, RpcCtrl rpcCtrl);


  public class CycleAllOutletPowerStatesResult {
    public int _ret_;
  }

  CycleAllOutletPowerStatesResult cycleAllOutletPowerStates() throws Exception;

  AsyncRequest cycleAllOutletPowerStates(AsyncRpcResponse<CycleAllOutletPowerStatesResult> rsp);

  AsyncRequest cycleAllOutletPowerStates(AsyncRpcResponse<CycleAllOutletPowerStatesResult> rsp, RpcCtrl rpcCtrl);


  public class CycleMultipleOutletPowerStatesResult {
    public int _ret_;
  }

  CycleMultipleOutletPowerStatesResult cycleMultipleOutletPowerStates(java.util.List<Integer> outletNumbers, boolean respectSequence) throws Exception;

  AsyncRequest cycleMultipleOutletPowerStates(java.util.List<Integer> outletNumbers, boolean respectSequence, AsyncRpcResponse<CycleMultipleOutletPowerStatesResult> rsp);

  AsyncRequest cycleMultipleOutletPowerStates(java.util.List<Integer> outletNumbers, boolean respectSequence, AsyncRpcResponse<CycleMultipleOutletPowerStatesResult> rsp, RpcCtrl rpcCtrl);


  public class GetStatisticResult {
    public com.raritan.idl.pdumodel.Pdu_6_3_3.Statistic _ret_;
  }

  GetStatisticResult getStatistic() throws Exception;

  AsyncRequest getStatistic(AsyncRpcResponse<GetStatisticResult> rsp);

  AsyncRequest getStatistic(AsyncRpcResponse<GetStatisticResult> rsp, RpcCtrl rpcCtrl);


  public class GetOutletSequenceStateResult {
    public com.raritan.idl.pdumodel.Pdu_6_3_3.OutletSequenceState _ret_;
  }

  GetOutletSequenceStateResult getOutletSequenceState() throws Exception;

  AsyncRequest getOutletSequenceState(AsyncRpcResponse<GetOutletSequenceStateResult> rsp);

  AsyncRequest getOutletSequenceState(AsyncRpcResponse<GetOutletSequenceStateResult> rsp, RpcCtrl rpcCtrl);

  Void cancelOutletSequence() throws Exception;

  AsyncRequest cancelOutletSequence(AsyncRpcResponse<Void> rsp);

  AsyncRequest cancelOutletSequence(AsyncRpcResponse<Void> rsp, RpcCtrl rpcCtrl);

}
