// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from Unit.idl.

package com.raritan.idl.pdumodel;

import com.raritan.idl.*;
import com.raritan.util.AsyncRequest;

public interface Unit_1_0_1 {
  static public final TypeInfo typeInfo = new TypeInfo("pdumodel.Unit:1.0.1", null);

  public static final int ERR_INVALID_PARAM = 1;

  public enum Orientation {
    NORMAL,
    FLIPPED,
    LEFT,
    RIGHT;
  }

  static public class DisplayOptions implements Cloneable {
    public String key = new String();
    public String value = new String();

    public Object clone() {
      DisplayOptions copy = new DisplayOptions();

      copy.key = this.key;
      copy.value = this.value;

      return copy;
    }

  }

  static public class DisplayInfo implements Cloneable {
    public String type = new String();
    public String address = new String();
    public java.util.List<com.raritan.idl.pdumodel.Unit_1_0_1.DisplayOptions> options = new java.util.ArrayList<>();
    public com.raritan.idl.pdumodel.Unit_1_0_1.Orientation orientation = com.raritan.idl.pdumodel.Unit_1_0_1.Orientation.values()[0];

    public Object clone() {
      DisplayInfo copy = new DisplayInfo();

      copy.type = this.type;
      copy.address = this.address;
      copy.options = new java.util.ArrayList<com.raritan.idl.pdumodel.Unit_1_0_1.DisplayOptions>(this.options);
      copy.orientation = this.orientation;

      return copy;
    }

  }

  static public class MetaData implements Cloneable {
    public boolean hasOrientationSensor = false;
    public java.util.List<com.raritan.idl.pdumodel.Unit_1_0_1.Orientation> supportedDisplayOrientations = new java.util.ArrayList<>();

    public Object clone() {
      MetaData copy = new MetaData();

      copy.hasOrientationSensor = this.hasOrientationSensor;
      copy.supportedDisplayOrientations = new java.util.ArrayList<com.raritan.idl.pdumodel.Unit_1_0_1.Orientation>(this.supportedDisplayOrientations);

      return copy;
    }

  }

  static public class Settings implements Cloneable {
    public boolean buzzerMuted = false;
    public boolean autoDisplayOrientation = false;
    public com.raritan.idl.pdumodel.Unit_1_0_1.Orientation displayOrientation = com.raritan.idl.pdumodel.Unit_1_0_1.Orientation.values()[0];

    public Object clone() {
      Settings copy = new Settings();

      copy.buzzerMuted = this.buzzerMuted;
      copy.autoDisplayOrientation = this.autoDisplayOrientation;
      copy.displayOrientation = this.displayOrientation;

      return copy;
    }

  }

  public class GetMetaDataResult {
    public com.raritan.idl.pdumodel.Unit_1_0_1.MetaData _ret_;
  }

  GetMetaDataResult getMetaData() throws Exception;

  AsyncRequest getMetaData(AsyncRpcResponse<GetMetaDataResult> rsp);

  AsyncRequest getMetaData(AsyncRpcResponse<GetMetaDataResult> rsp, RpcCtrl rpcCtrl);


  public class GetSettingsResult {
    public com.raritan.idl.pdumodel.Unit_1_0_1.Settings _ret_;
  }

  GetSettingsResult getSettings() throws Exception;

  AsyncRequest getSettings(AsyncRpcResponse<GetSettingsResult> rsp);

  AsyncRequest getSettings(AsyncRpcResponse<GetSettingsResult> rsp, RpcCtrl rpcCtrl);


  public class SetSettingsResult {
    public int _ret_;
  }

  SetSettingsResult setSettings(com.raritan.idl.pdumodel.Unit_1_0_1.Settings settings) throws Exception;

  AsyncRequest setSettings(com.raritan.idl.pdumodel.Unit_1_0_1.Settings settings, AsyncRpcResponse<SetSettingsResult> rsp);

  AsyncRequest setSettings(com.raritan.idl.pdumodel.Unit_1_0_1.Settings settings, AsyncRpcResponse<SetSettingsResult> rsp, RpcCtrl rpcCtrl);

  Void identify(int seconds) throws Exception;

  AsyncRequest identify(int seconds, AsyncRpcResponse<Void> rsp);

  AsyncRequest identify(int seconds, AsyncRpcResponse<Void> rsp, RpcCtrl rpcCtrl);

  Void muteBuzzer(boolean mute) throws Exception;

  AsyncRequest muteBuzzer(boolean mute, AsyncRpcResponse<Void> rsp);

  AsyncRequest muteBuzzer(boolean mute, AsyncRpcResponse<Void> rsp, RpcCtrl rpcCtrl);

  Void testBuzzer(boolean on) throws Exception;

  AsyncRequest testBuzzer(boolean on, AsyncRpcResponse<Void> rsp);

  AsyncRequest testBuzzer(boolean on, AsyncRpcResponse<Void> rsp, RpcCtrl rpcCtrl);


  public class GetAllButtonStatesResult {
    public java.util.List<Boolean> _ret_;
  }

  GetAllButtonStatesResult getAllButtonStates() throws Exception;

  AsyncRequest getAllButtonStates(AsyncRpcResponse<GetAllButtonStatesResult> rsp);

  AsyncRequest getAllButtonStates(AsyncRpcResponse<GetAllButtonStatesResult> rsp, RpcCtrl rpcCtrl);


  public class TestButtonStateResult {
    public boolean _ret_;
  }

  TestButtonStateResult testButtonState(int button) throws Exception;

  AsyncRequest testButtonState(int button, AsyncRpcResponse<TestButtonStateResult> rsp);

  AsyncRequest testButtonState(int button, AsyncRpcResponse<TestButtonStateResult> rsp, RpcCtrl rpcCtrl);

  Void testLEDSequence() throws Exception;

  AsyncRequest testLEDSequence(AsyncRpcResponse<Void> rsp);

  AsyncRequest testLEDSequence(AsyncRpcResponse<Void> rsp, RpcCtrl rpcCtrl);

  Void runDisplayTest(int cycleTimeMs) throws Exception;

  AsyncRequest runDisplayTest(int cycleTimeMs, AsyncRpcResponse<Void> rsp);

  AsyncRequest runDisplayTest(int cycleTimeMs, AsyncRpcResponse<Void> rsp, RpcCtrl rpcCtrl);


  public class GetDisplayInfoResult {
    public java.util.List<com.raritan.idl.pdumodel.Unit_1_0_1.DisplayInfo> _ret_;
  }

  GetDisplayInfoResult getDisplayInfo() throws Exception;

  AsyncRequest getDisplayInfo(AsyncRpcResponse<GetDisplayInfoResult> rsp);

  AsyncRequest getDisplayInfo(AsyncRpcResponse<GetDisplayInfoResult> rsp, RpcCtrl rpcCtrl);

}
