// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from SensorHub.idl.

package com.raritan.idl.peripheral;

import com.raritan.idl.*;
import com.raritan.util.AsyncRequest;

public interface SensorHub_2_0_4 {
  static public final TypeInfo typeInfo = new TypeInfo("peripheral.SensorHub:2.0.4", null);

  public enum UpstreamType {
    BUILTIN,
    ENV_HUB,
    REMOTE_HUB;
  }

  static public class HubPortInfo implements Cloneable {
    public String hubPort = new String();
    public com.raritan.idl.portsmodel.PortFuse_1_0_1 fuse = null;

    public Object clone() {
      HubPortInfo copy = new HubPortInfo();

      copy.hubPort = this.hubPort;
      copy.fuse = this.fuse;

      return copy;
    }

  }

  static public class DeviceInfo implements Cloneable {
    public String serial = new String();
    public String model = new String();
    public com.raritan.idl.peripheral.SensorHub_2_0_4.UpstreamType upstreamType = com.raritan.idl.peripheral.SensorHub_2_0_4.UpstreamType.values()[0];
    public com.raritan.idl.peripheral.PosElement_5_0_0 position = new com.raritan.idl.peripheral.PosElement_5_0_0();
    public int protocolVersion = 0;
    public int bootVersion = 0;
    public int appVersion = 0;
    public java.util.List<com.raritan.idl.peripheral.SensorHub_2_0_4.HubPortInfo> hubPortInfos = new java.util.ArrayList<>();

    public Object clone() {
      DeviceInfo copy = new DeviceInfo();

      copy.serial = this.serial;
      copy.model = this.model;
      copy.upstreamType = this.upstreamType;
      Object positionCopy = this.position.clone();
      copy.position = (com.raritan.idl.peripheral.PosElement_5_0_0) positionCopy;
      copy.protocolVersion = this.protocolVersion;
      copy.bootVersion = this.bootVersion;
      copy.appVersion = this.appVersion;
      copy.hubPortInfos = new java.util.ArrayList<com.raritan.idl.peripheral.SensorHub_2_0_4.HubPortInfo>(this.hubPortInfos);

      return copy;
    }

  }

  public class GetDeviceInfoResult {
    public com.raritan.idl.peripheral.SensorHub_2_0_4.DeviceInfo _ret_;
  }

  GetDeviceInfoResult getDeviceInfo() throws Exception;

  AsyncRequest getDeviceInfo(AsyncRpcResponse<GetDeviceInfoResult> rsp);

  AsyncRequest getDeviceInfo(AsyncRpcResponse<GetDeviceInfoResult> rsp, RpcCtrl rpcCtrl);


  public class GetPackageInfoResult {
    public com.raritan.idl.peripheral.PackageInfo_7_0_0 _ret_;
  }

  GetPackageInfoResult getPackageInfo() throws Exception;

  AsyncRequest getPackageInfo(AsyncRpcResponse<GetPackageInfoResult> rsp);

  AsyncRequest getPackageInfo(AsyncRpcResponse<GetPackageInfoResult> rsp, RpcCtrl rpcCtrl);

}
