// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from Port.idl.

package com.raritan.idl.portsmodel;

import com.raritan.idl.*;
import com.raritan.util.AsyncRequest;

public interface Port_2_0_3 {
  static public final TypeInfo typeInfo = new TypeInfo("portsmodel.Port:2.0.3", null);

  public static final int NO_ERROR = 0;

  public static final int ERR_INVALID_PARAM = 1;

  public static final int ERR_DEVICE_BUSY = 2;

  public enum DetectionType {
    AUTO,
    PINNED,
    DISABLED;
  }

  static public class DetectionMode implements Cloneable {
    public com.raritan.idl.portsmodel.Port_2_0_3.DetectionType type = com.raritan.idl.portsmodel.Port_2_0_3.DetectionType.values()[0];
    public String pinnedDeviceType = new String();

    public Object clone() {
      DetectionMode copy = new DetectionMode();

      copy.type = this.type;
      copy.pinnedDeviceType = this.pinnedDeviceType;

      return copy;
    }

  }

  static public class Properties implements Cloneable {
    public String name = new String();
    public String label = new String();
    public com.raritan.idl.portsmodel.Port_2_0_3.DetectionMode mode = new com.raritan.idl.portsmodel.Port_2_0_3.DetectionMode();
    public String detectedDeviceType = new String();
    public String detectedDeviceName = new String();

    public Object clone() {
      Properties copy = new Properties();

      copy.name = this.name;
      copy.label = this.label;
      Object modeCopy = this.mode.clone();
      copy.mode = (com.raritan.idl.portsmodel.Port_2_0_3.DetectionMode) modeCopy;
      copy.detectedDeviceType = this.detectedDeviceType;
      copy.detectedDeviceName = this.detectedDeviceName;

      return copy;
    }

  }

  public class PropertiesChangedEvent extends com.raritan.idl.idl.Event {

    static public final TypeInfo typeInfo = new TypeInfo("portsmodel.Port_2_0_3.PropertiesChangedEvent:1.0.0", com.raritan.idl.idl.Event.typeInfo);

    @Override
    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public com.raritan.idl.portsmodel.Port_2_0_3.Properties oldProperties = new com.raritan.idl.portsmodel.Port_2_0_3.Properties();
    public com.raritan.idl.portsmodel.Port_2_0_3.Properties newProperties = new com.raritan.idl.portsmodel.Port_2_0_3.Properties();
  }

  public class DeviceChangedEvent extends com.raritan.idl.idl.Event {

    static public final TypeInfo typeInfo = new TypeInfo("portsmodel.Port_2_0_3.DeviceChangedEvent:1.0.0", com.raritan.idl.idl.Event.typeInfo);

    @Override
    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public Object oldDevice = null;
    public Object newDevice = null;
  }

  public class GetPropertiesResult {
    public com.raritan.idl.portsmodel.Port_2_0_3.Properties _ret_;
  }

  GetPropertiesResult getProperties() throws Exception;

  AsyncRequest getProperties(AsyncRpcResponse<GetPropertiesResult> rsp);

  AsyncRequest getProperties(AsyncRpcResponse<GetPropertiesResult> rsp, RpcCtrl rpcCtrl);

  Void setName(String name) throws Exception;

  AsyncRequest setName(String name, AsyncRpcResponse<Void> rsp);

  AsyncRequest setName(String name, AsyncRpcResponse<Void> rsp, RpcCtrl rpcCtrl);


  public class SetDetectionModeResult {
    public int _ret_;
  }

  SetDetectionModeResult setDetectionMode(com.raritan.idl.portsmodel.Port_2_0_3.DetectionMode mode) throws Exception;

  AsyncRequest setDetectionMode(com.raritan.idl.portsmodel.Port_2_0_3.DetectionMode mode, AsyncRpcResponse<SetDetectionModeResult> rsp);

  AsyncRequest setDetectionMode(com.raritan.idl.portsmodel.Port_2_0_3.DetectionMode mode, AsyncRpcResponse<SetDetectionModeResult> rsp, RpcCtrl rpcCtrl);


  public class GetDetectableDevicesResult {
    public java.util.List<String> _ret_;
  }

  GetDetectableDevicesResult getDetectableDevices() throws Exception;

  AsyncRequest getDetectableDevices(AsyncRpcResponse<GetDetectableDevicesResult> rsp);

  AsyncRequest getDetectableDevices(AsyncRpcResponse<GetDetectableDevicesResult> rsp, RpcCtrl rpcCtrl);


  public class GetDeviceResult {
    public Object _ret_;
  }

  GetDeviceResult getDevice() throws Exception;

  AsyncRequest getDevice(AsyncRpcResponse<GetDeviceResult> rsp);

  AsyncRequest getDevice(AsyncRpcResponse<GetDeviceResult> rsp, RpcCtrl rpcCtrl);


  public class GetDeviceConfigResult {
    public Object _ret_;
  }

  GetDeviceConfigResult getDeviceConfig(String deviceType) throws Exception;

  AsyncRequest getDeviceConfig(String deviceType, AsyncRpcResponse<GetDeviceConfigResult> rsp);

  AsyncRequest getDeviceConfig(String deviceType, AsyncRpcResponse<GetDeviceConfigResult> rsp, RpcCtrl rpcCtrl);


  public class GetFuseResult {
    public com.raritan.idl.portsmodel.PortFuse_1_0_1 _ret_;
  }

  GetFuseResult getFuse() throws Exception;

  AsyncRequest getFuse(AsyncRpcResponse<GetFuseResult> rsp);

  AsyncRequest getFuse(AsyncRpcResponse<GetFuseResult> rsp, RpcCtrl rpcCtrl);

}
