// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from AlertedSensorManager.idl.

package com.raritan.idl.sensors;

import com.raritan.idl.*;
import com.raritan.util.AsyncRequest;

public interface AlertedSensorManager_1_0_3 {
  static public final TypeInfo typeInfo = new TypeInfo("sensors.AlertedSensorManager:1.0.3", null);

  public enum AlertState {
    UNAVAILABLE,
    NORMAL,
    CRITICAL,
    WARNED;
  }

  static public class SensorCounts implements Cloneable {
    public int total = 0;
    public int unavailable = 0;
    public int critical = 0;
    public int warned = 0;

    public Object clone() {
      SensorCounts copy = new SensorCounts();

      copy.total = this.total;
      copy.unavailable = this.unavailable;
      copy.critical = this.critical;
      copy.warned = this.warned;

      return copy;
    }

  }

  static public class SensorData implements Cloneable {
    public com.raritan.idl.sensors.Sensor_4_0_5 sensor = null;
    public Object parent = null;
    public com.raritan.idl.sensors.AlertedSensorManager_1_0_3.AlertState alertState = com.raritan.idl.sensors.AlertedSensorManager_1_0_3.AlertState.values()[0];

    public Object clone() {
      SensorData copy = new SensorData();

      copy.sensor = this.sensor;
      copy.parent = this.parent;
      copy.alertState = this.alertState;

      return copy;
    }

  }

  public class MonitoredSensorsChangedEvent extends com.raritan.idl.idl.Event {

    static public final TypeInfo typeInfo = new TypeInfo("sensors.AlertedSensorManager_1_0_3.MonitoredSensorsChangedEvent:1.0.0", com.raritan.idl.idl.Event.typeInfo);

    @Override
    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public com.raritan.idl.sensors.AlertedSensorManager_1_0_3.SensorCounts counts = new com.raritan.idl.sensors.AlertedSensorManager_1_0_3.SensorCounts();
  }

  public class AlertedSensorsChangedEvent extends com.raritan.idl.idl.Event {

    static public final TypeInfo typeInfo = new TypeInfo("sensors.AlertedSensorManager_1_0_3.AlertedSensorsChangedEvent:1.0.0", com.raritan.idl.idl.Event.typeInfo);

    @Override
    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public com.raritan.idl.sensors.AlertedSensorManager_1_0_3.SensorCounts counts = new com.raritan.idl.sensors.AlertedSensorManager_1_0_3.SensorCounts();
    public java.util.List<com.raritan.idl.sensors.AlertedSensorManager_1_0_3.SensorData> changedSensors = new java.util.ArrayList<>();
    public java.util.List<com.raritan.idl.sensors.Sensor_4_0_5> removedSensors = new java.util.ArrayList<>();
  }

  public class GetSensorCountsResult {
    public com.raritan.idl.sensors.AlertedSensorManager_1_0_3.SensorCounts _ret_;
  }

  GetSensorCountsResult getSensorCounts() throws Exception;

  AsyncRequest getSensorCounts(AsyncRpcResponse<GetSensorCountsResult> rsp);

  AsyncRequest getSensorCounts(AsyncRpcResponse<GetSensorCountsResult> rsp, RpcCtrl rpcCtrl);


  public class GetAllSensorsResult {
    public java.util.List<com.raritan.idl.sensors.AlertedSensorManager_1_0_3.SensorData> _ret_;
  }

  GetAllSensorsResult getAllSensors() throws Exception;

  AsyncRequest getAllSensors(AsyncRpcResponse<GetAllSensorsResult> rsp);

  AsyncRequest getAllSensors(AsyncRpcResponse<GetAllSensorsResult> rsp, RpcCtrl rpcCtrl);


  public class GetAlertedSensorsResult {
    public java.util.List<com.raritan.idl.sensors.AlertedSensorManager_1_0_3.SensorData> _ret_;
  }

  GetAlertedSensorsResult getAlertedSensors() throws Exception;

  AsyncRequest getAlertedSensors(AsyncRpcResponse<GetAlertedSensorsResult> rsp);

  AsyncRequest getAlertedSensors(AsyncRpcResponse<GetAlertedSensorsResult> rsp, RpcCtrl rpcCtrl);

}
