// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from ExternalSensorSlot.idl.

package com.raritan.idl.sensors;

import com.raritan.idl.*;
import com.raritan.util.AsyncRequest;

public interface ExternalSensorSlot {
  static public final TypeInfo typeInfo = new TypeInfo("sensors.ExternalSensorSlot:1.0.0", null);

  public enum Events {
    EVT_KEY_INFO_CHANGED;
  }

  static public class Location implements Cloneable {
    public String x = new String();
    public String y = new String();
    public String z = new String();

    public Object clone() {
      Location copy = new Location();

      copy.x = this.x;
      copy.y = this.y;
      copy.z = this.z;

      return copy;
    }

  }

  static public class Settings implements Cloneable {
    public String name = new String();
    public String description = new String();
    public com.raritan.idl.sensors.ExternalSensorSlot.Location location = new com.raritan.idl.sensors.ExternalSensorSlot.Location();

    public Object clone() {
      Settings copy = new Settings();

      copy.name = this.name;
      copy.description = this.description;
      Object locationCopy = this.location.clone();
      copy.location = (com.raritan.idl.sensors.ExternalSensorSlot.Location) locationCopy;

      return copy;
    }

  }

  static public class Info implements Cloneable {
    public com.raritan.idl.sensors.ExternalSensorSlot.Settings settings = new com.raritan.idl.sensors.ExternalSensorSlot.Settings();
    public boolean assigned = false;
    public com.raritan.idl.sensors.ExternalSensorData data = new com.raritan.idl.sensors.ExternalSensorData();
    public com.raritan.idl.sensors.NumericSensor numericSensor = null;
    public com.raritan.idl.sensors.StateSensor stateSensor = null;

    public Object clone() {
      Info copy = new Info();

      Object settingsCopy = this.settings.clone();
      copy.settings = (com.raritan.idl.sensors.ExternalSensorSlot.Settings) settingsCopy;
      copy.assigned = this.assigned;
      Object dataCopy = this.data.clone();
      copy.data = (com.raritan.idl.sensors.ExternalSensorData) dataCopy;
      copy.numericSensor = this.numericSensor;
      copy.stateSensor = this.stateSensor;

      return copy;
    }

  }

  public class GetInfoResult {
    public com.raritan.idl.sensors.ExternalSensorSlot.Info _ret_;
  }

  GetInfoResult getInfo() throws Exception;

  AsyncRequest getInfo(AsyncRpcResponse<GetInfoResult> rsp);

  AsyncRequest getInfo(AsyncRpcResponse<GetInfoResult> rsp, RpcCtrl rpcCtrl);


  public class GetSettingsResult {
    public com.raritan.idl.sensors.ExternalSensorSlot.Settings _ret_;
  }

  GetSettingsResult getSettings() throws Exception;

  AsyncRequest getSettings(AsyncRpcResponse<GetSettingsResult> rsp);

  AsyncRequest getSettings(AsyncRpcResponse<GetSettingsResult> rsp, RpcCtrl rpcCtrl);


  public class SetSettingsResult {
    public int _ret_;
  }

  SetSettingsResult setSettings(com.raritan.idl.sensors.ExternalSensorSlot.Settings settings) throws Exception;

  AsyncRequest setSettings(com.raritan.idl.sensors.ExternalSensorSlot.Settings settings, AsyncRpcResponse<SetSettingsResult> rsp);

  AsyncRequest setSettings(com.raritan.idl.sensors.ExternalSensorSlot.Settings settings, AsyncRpcResponse<SetSettingsResult> rsp, RpcCtrl rpcCtrl);


  public class AssignResult {
    public int _ret_;
  }

  AssignResult assign(com.raritan.idl.sensors.ExternalSensorData data) throws Exception;

  AsyncRequest assign(com.raritan.idl.sensors.ExternalSensorData data, AsyncRpcResponse<AssignResult> rsp);

  AsyncRequest assign(com.raritan.idl.sensors.ExternalSensorData data, AsyncRpcResponse<AssignResult> rsp, RpcCtrl rpcCtrl);

  Void unassign() throws Exception;

  AsyncRequest unassign(AsyncRpcResponse<Void> rsp);

  AsyncRequest unassign(AsyncRpcResponse<Void> rsp, RpcCtrl rpcCtrl);

}
