// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from Sensor.idl.

package com.raritan.idl.sensors;

import com.raritan.idl.*;
import com.raritan.util.AsyncRequest;

public interface Sensor {
  static public final TypeInfo typeInfo = new TypeInfo("sensors.Sensor:1.0.0", null);

  public static final int ERR_NOT_SUPPORTED = 1;

  public enum Events {
    EVT_KEY_TYPESPEC_CHANGED;
  }

  public enum ReadingType {
    NUMERIC,
    DISCRETE_ON_OFF,
    DISCRETE_MULTI;
  }

  public enum OnOffState {
    OFF,
    ON;
  }

  public enum Type {
    RMS_VOLTAGE,
    RMS_CURRENT,
    PEAK_CURRENT,
    MAXIMUM_CURRENT,
    UNBALANCE_CURRENT,
    ACTIVE_POWER,
    APPARENT_POWER,
    POWER_FACTOR,
    ACTIVE_ENERGY,
    APPARENT_ENERGY,
    FREQUENCY,
    TEMPERATURE,
    HUMIDITY,
    AIR_FLOW,
    AIR_PRESSURE,
    CONTACT_CLOSURE,
    ON_OFF_SENSOR,
    TRIP_SENSOR,
    VIBRATION,
    WATER_LEAK,
    SMOKE_DETECTOR;
  }

  public enum Unit {
    NONE,
    VOLT,
    AMPERE,
    WATT,
    VOLT_AMP,
    WATT_HOUR,
    VOLT_AMP_HOUR,
    DEGREE_CELSIUS,
    HZ,
    PERCENT,
    METER_PER_SEC,
    PASCAL,
    G,
    RPM,
    METER,
    HOUR,
    MINUTE,
    SECOND;
  }

  static public class TypeSpec implements Cloneable {
    public com.raritan.idl.sensors.Sensor.ReadingType readingtype = com.raritan.idl.sensors.Sensor.ReadingType.values()[0];
    public com.raritan.idl.sensors.Sensor.Type type = com.raritan.idl.sensors.Sensor.Type.values()[0];
    public com.raritan.idl.sensors.Sensor.Unit unit = com.raritan.idl.sensors.Sensor.Unit.values()[0];

    public Object clone() {
      TypeSpec copy = new TypeSpec();

      copy.readingtype = this.readingtype;
      copy.type = this.type;
      copy.unit = this.unit;

      return copy;
    }

  }

  public class GetTypeSpecResult {
    public com.raritan.idl.sensors.Sensor.TypeSpec _ret_;
  }

  GetTypeSpecResult getTypeSpec() throws Exception;

  AsyncRequest getTypeSpec(AsyncRpcResponse<GetTypeSpecResult> rsp);

  AsyncRequest getTypeSpec(AsyncRpcResponse<GetTypeSpecResult> rsp, RpcCtrl rpcCtrl);


  public class SetTypeResult {
    public int _ret_;
  }

  SetTypeResult setType(com.raritan.idl.sensors.Sensor.Type type, com.raritan.idl.sensors.Sensor.Unit unit) throws Exception;

  AsyncRequest setType(com.raritan.idl.sensors.Sensor.Type type, com.raritan.idl.sensors.Sensor.Unit unit, AsyncRpcResponse<SetTypeResult> rsp);

  AsyncRequest setType(com.raritan.idl.sensors.Sensor.Type type, com.raritan.idl.sensors.Sensor.Unit unit, AsyncRpcResponse<SetTypeResult> rsp, RpcCtrl rpcCtrl);

}
