// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from Sensor.idl.

package com.raritan.idl.sensors;

import com.raritan.idl.*;
import com.raritan.util.AsyncRequest;

public interface Sensor_4_0_1 {
  static public final TypeInfo typeInfo = new TypeInfo("sensors.Sensor:4.0.1", null);

  public static final int ERR_NOT_SUPPORTED = 1;

  public static final int NUMERIC = 0;

  public static final int DISCRETE_ON_OFF = 1;

  public static final int DISCRETE_MULTI = 2;

  public enum OnOffState {
    OFF,
    ON;
  }

  public static final int UNSPECIFIED = 0;

  public static final int VOLTAGE = 1;

  public static final int CURRENT = 2;

  public static final int UNBALANCE_CURRENT = 3;

  public static final int POWER = 4;

  public static final int POWER_FACTOR = 5;

  public static final int ENERGY = 6;

  public static final int FREQUENCY = 7;

  public static final int TEMPERATURE = 8;

  public static final int HUMIDITY = 9;

  public static final int AIR_FLOW = 10;

  public static final int AIR_PRESSURE = 11;

  public static final int CONTACT_CLOSURE = 12;

  public static final int ON_OFF_SENSOR = 13;

  public static final int TRIP_SENSOR = 14;

  public static final int VIBRATION = 15;

  public static final int WATER_LEAK = 16;

  public static final int SMOKE_DETECTOR = 17;

  public static final int TOTAL_HARMONIC_DISTORTION = 18;

  public static final int MASS = 19;

  public static final int ELECTRICAL_RESISTANCE = 20;

  public static final int FLUX = 21;

  public static final int LUMINOUS_INTENSITY = 22;

  public static final int ACCELERATION = 23;

  public static final int MAGNETIC_FLUX_DENSITY = 24;

  public static final int ELECTRIC_FIELD_STRENGTH = 25;

  public static final int MAGNETIC_FIELD_STRENGTH = 26;

  public static final int ANGLE = 27;

  public static final int SELECTION = 28;

  public static final int FAULT_STATE = 29;

  public static final int POWER_QUALITY = 30;

  public static final int ROTATIONAL_SPEED = 31;

  public static final int LUMINOUS_ENERGY = 32;

  public static final int LUMINOUS_FLUX = 33;

  public static final int ILLUMINANCE = 34;

  public static final int LUMINOUS_EMITTANCE = 35;

  public static final int MOTION = 36;

  public static final int OCCUPANCY = 37;

  public static final int TAMPER = 38;

  public static final int DRY_CONTACT = 39;

  public static final int POWERED_DRY_CONTACT = 40;

  public static final int ABSOLUTE_HUMIDITY = 41;

  public static final int NONE = 0;

  public static final int VOLT = 1;

  public static final int AMPERE = 2;

  public static final int WATT = 3;

  public static final int VOLT_AMP = 4;

  public static final int WATT_HOUR = 5;

  public static final int VOLT_AMP_HOUR = 6;

  public static final int DEGREE_CELSIUS = 7;

  public static final int HZ = 8;

  public static final int PERCENT = 9;

  public static final int METER_PER_SEC = 10;

  public static final int PASCAL = 11;

  public static final int G = 12;

  public static final int RPM = 13;

  public static final int METER = 14;

  public static final int HOUR = 15;

  public static final int MINUTE = 16;

  public static final int SECOND = 17;

  public static final int VOLT_AMP_REACTIVE = 18;

  public static final int VOLT_AMP_REACTIVE_HOUR = 19;

  public static final int GRAM = 20;

  public static final int OHM = 21;

  public static final int LITERS_PER_HOUR = 22;

  public static final int CANDELA = 23;

  public static final int METER_PER_SQARE_SEC = 24;

  public static final int TESLA = 25;

  public static final int VOLT_PER_METER = 26;

  public static final int VOLT_PER_AMPERE = 27;

  public static final int DEGREE = 28;

  public static final int DEGREE_FAHRENHEIT = 29;

  public static final int KELVIN = 30;

  public static final int JOULE = 31;

  public static final int COULOMB = 32;

  public static final int NIT = 33;

  public static final int LUMEN = 34;

  public static final int LUMEN_SECOND = 35;

  public static final int LUX = 36;

  public static final int PSI = 37;

  public static final int NEWTON = 38;

  public static final int FOOT = 39;

  public static final int FOOT_PER_SEC = 40;

  public static final int CUBIC_METER = 41;

  public static final int RADIANT = 42;

  public static final int STERADIANT = 43;

  public static final int HENRY = 44;

  public static final int FARAD = 45;

  public static final int MOL = 46;

  public static final int BECQUEREL = 47;

  public static final int GRAY = 48;

  public static final int SIEVERT = 49;

  public static final int G_PER_CUBIC_METER = 50;

  static public class TypeSpec implements Cloneable {
    public int readingtype = 0;
    public int type = 0;
    public int unit = 0;

    public Object clone() {
      TypeSpec copy = new TypeSpec();

      copy.readingtype = this.readingtype;
      copy.type = this.type;
      copy.unit = this.unit;

      return copy;
    }

  }

  public class TypeSpecChangedEvent extends com.raritan.idl.idl.Event {

    static public final TypeInfo typeInfo = new TypeInfo("sensors.Sensor_4_0_1.TypeSpecChangedEvent:1.0.0", com.raritan.idl.idl.Event.typeInfo);

    @Override
    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public com.raritan.idl.sensors.Sensor_4_0_1.TypeSpec oldTypeSpec = new com.raritan.idl.sensors.Sensor_4_0_1.TypeSpec();
    public com.raritan.idl.sensors.Sensor_4_0_1.TypeSpec newTypeSpec = new com.raritan.idl.sensors.Sensor_4_0_1.TypeSpec();
  }

  public class GetTypeSpecResult {
    public com.raritan.idl.sensors.Sensor_4_0_1.TypeSpec _ret_;
  }

  GetTypeSpecResult getTypeSpec() throws Exception;

  AsyncRequest getTypeSpec(AsyncRpcResponse<GetTypeSpecResult> rsp);

  AsyncRequest getTypeSpec(AsyncRpcResponse<GetTypeSpecResult> rsp, RpcCtrl rpcCtrl);


  public class SetTypeResult {
    public int _ret_;
  }

  SetTypeResult setType(int type, int unit) throws Exception;

  AsyncRequest setType(int type, int unit, AsyncRpcResponse<SetTypeResult> rsp);

  AsyncRequest setType(int type, int unit, AsyncRpcResponse<SetTypeResult> rsp, RpcCtrl rpcCtrl);

}
