// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from SessionManager.idl.

package com.raritan.idl.session;

import com.raritan.idl.*;
import com.raritan.util.AsyncRequest;

public interface SessionManager {
  static public final TypeInfo typeInfo = new TypeInfo("session.SessionManager:1.0.0", null);

  public static final int ERR_ACTIVE_SESSION_EXCLUSIVE_FOR_USER = 1;

  public enum CloseReason {
    CLOSE_REASON_LOGOUT,
    CLOSE_REASON_TIMEOUT,
    CLOSE_REASON_BROWSER_CLOSED,
    CLOSE_REASON_FORCED_DISCONNECT;
  }

  public class NewSessionResult {
    public int _ret_;
    public com.raritan.idl.session.Session session;
  }

  NewSessionResult newSession() throws Exception;

  AsyncRequest newSession(AsyncRpcResponse<NewSessionResult> rsp);

  AsyncRequest newSession(AsyncRpcResponse<NewSessionResult> rsp, RpcCtrl rpcCtrl);


  public class GetSessionResult {
    public com.raritan.idl.session.Session _ret_;
  }

  GetSessionResult getSession(String token) throws Exception;

  AsyncRequest getSession(String token, AsyncRpcResponse<GetSessionResult> rsp);

  AsyncRequest getSession(String token, AsyncRpcResponse<GetSessionResult> rsp, RpcCtrl rpcCtrl);


  public class GetCurrentSessionResult {
    public com.raritan.idl.session.Session _ret_;
  }

  GetCurrentSessionResult getCurrentSession() throws Exception;

  AsyncRequest getCurrentSession(AsyncRpcResponse<GetCurrentSessionResult> rsp);

  AsyncRequest getCurrentSession(AsyncRpcResponse<GetCurrentSessionResult> rsp, RpcCtrl rpcCtrl);


  public class GetSessionsResult {
    public java.util.List<com.raritan.idl.session.Session> _ret_;
  }

  GetSessionsResult getSessions() throws Exception;

  AsyncRequest getSessions(AsyncRpcResponse<GetSessionsResult> rsp);

  AsyncRequest getSessions(AsyncRpcResponse<GetSessionsResult> rsp, RpcCtrl rpcCtrl);

  Void closeSession(String token, com.raritan.idl.session.SessionManager.CloseReason reason) throws Exception;

  AsyncRequest closeSession(String token, com.raritan.idl.session.SessionManager.CloseReason reason, AsyncRpcResponse<Void> rsp);

  AsyncRequest closeSession(String token, com.raritan.idl.session.SessionManager.CloseReason reason, AsyncRpcResponse<Void> rsp, RpcCtrl rpcCtrl);

  Void closeCurrentSession(com.raritan.idl.session.SessionManager.CloseReason reason) throws Exception;

  AsyncRequest closeCurrentSession(com.raritan.idl.session.SessionManager.CloseReason reason, AsyncRpcResponse<Void> rsp);

  AsyncRequest closeCurrentSession(com.raritan.idl.session.SessionManager.CloseReason reason, AsyncRpcResponse<Void> rsp, RpcCtrl rpcCtrl);

  Void touchSession(String token) throws Exception;

  AsyncRequest touchSession(String token, AsyncRpcResponse<Void> rsp);

  AsyncRequest touchSession(String token, AsyncRpcResponse<Void> rsp, RpcCtrl rpcCtrl);

  Void touchCurrentSession(boolean userActivity) throws Exception;

  AsyncRequest touchCurrentSession(boolean userActivity, AsyncRpcResponse<Void> rsp);

  AsyncRequest touchCurrentSession(boolean userActivity, AsyncRpcResponse<Void> rsp, RpcCtrl rpcCtrl);


  public class GetSessionHistoryResult {
    public java.util.List<com.raritan.idl.session.HistoryEntry> _ret_;
  }

  GetSessionHistoryResult getSessionHistory() throws Exception;

  AsyncRequest getSessionHistory(AsyncRpcResponse<GetSessionHistoryResult> rsp);

  AsyncRequest getSessionHistory(AsyncRpcResponse<GetSessionHistoryResult> rsp, RpcCtrl rpcCtrl);

}
