// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from CardReader.idl.

package com.raritan.idl.smartcard;

import com.raritan.idl.*;
import com.raritan.util.AsyncRequest;

public interface CardReader {
  static public final TypeInfo typeInfo = new TypeInfo("smartcard.CardReader:1.0.0", null);

  public static final int NO_ERROR = 0;

  public static final int ERR_SLOT_EMPTY = 1;

  static public class MetaData implements Cloneable {
    public String manufacturer = new String();
    public String product = new String();
    public String serialNumber = new String();

    public Object clone() {
      MetaData copy = new MetaData();

      copy.manufacturer = this.manufacturer;
      copy.product = this.product;
      copy.serialNumber = this.serialNumber;

      return copy;
    }

  }

  static public class CardInformation implements Cloneable {
    public String type = new String();
    public String uid = new String();

    public Object clone() {
      CardInformation copy = new CardInformation();

      copy.type = this.type;
      copy.uid = this.uid;

      return copy;
    }

  }

  public class CardEvent extends com.raritan.idl.idl.Event {

    static public final TypeInfo typeInfo = new TypeInfo("smartcard.CardReader.CardEvent:1.0.0", com.raritan.idl.idl.Event.typeInfo);

    @Override
    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public com.raritan.idl.smartcard.CardReader.CardInformation cardInfo = new com.raritan.idl.smartcard.CardReader.CardInformation();
  }

  public class CardInsertedEvent extends com.raritan.idl.smartcard.CardReader.CardEvent {

    static public final TypeInfo typeInfo = new TypeInfo("smartcard.CardReader.CardInsertedEvent:1.0.0", com.raritan.idl.smartcard.CardReader.CardEvent.typeInfo);

    @Override
    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

  }

  public class CardRemovedEvent extends com.raritan.idl.smartcard.CardReader.CardEvent {

    static public final TypeInfo typeInfo = new TypeInfo("smartcard.CardReader.CardRemovedEvent:1.0.0", com.raritan.idl.smartcard.CardReader.CardEvent.typeInfo);

    @Override
    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

  }

  public class GetMetaDataResult {
    public com.raritan.idl.smartcard.CardReader.MetaData _ret_;
  }

  GetMetaDataResult getMetaData() throws Exception;

  AsyncRequest getMetaData(AsyncRpcResponse<GetMetaDataResult> rsp);

  AsyncRequest getMetaData(AsyncRpcResponse<GetMetaDataResult> rsp, RpcCtrl rpcCtrl);


  public class GetCardInformationResult {
    public int _ret_;
    public com.raritan.idl.smartcard.CardReader.CardInformation cardInfo;
  }

  GetCardInformationResult getCardInformation() throws Exception;

  AsyncRequest getCardInformation(AsyncRpcResponse<GetCardInformationResult> rsp);

  AsyncRequest getCardInformation(AsyncRpcResponse<GetCardInformationResult> rsp, RpcCtrl rpcCtrl);

}
