// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from UserManager.idl.

package com.raritan.idl.usermgmt;

import com.raritan.idl.*;
import com.raritan.util.AsyncRequest;

public interface UserManager_1_0_3 {
  static public final TypeInfo typeInfo = new TypeInfo("usermgmt.UserManager:1.0.3", null);

  public static final int ERR_USER_DOESNT_EXIST = 1;

  public static final int ERR_USER_NOT_DELETABLE = 2;

  public static final int ERR_USER_ALREADY_EXISTS = 1;

  public static final int ERR_MAX_USERS_REACHED = 2;

  public static final int ERR_PASSWORD_TOO_SHORT_FOR_SNMP = 3;

  public static final int ERR_INVALID_VALUE = 4;

  public static final int ERR_PASSWORD_EMPTY = 5;

  public static final int ERR_PASSWORD_TOO_SHORT = 6;

  public static final int ERR_PASSWORD_TOO_LONG = 7;

  public static final int ERR_PASSWORD_CTRL_CHARS = 8;

  public static final int ERR_PASSWORD_NEED_LOWER = 9;

  public static final int ERR_PASSWORD_NEED_UPPER = 10;

  public static final int ERR_PASSWORD_NEED_NUMERIC = 11;

  public static final int ERR_PASSWORD_NEED_SPECIAL = 12;

  public static final int ERR_SSH_PUBKEY_DATA_TOO_LARGE = 14;

  public static final int ERR_SSH_PUBKEY_INVALID = 15;

  public static final int ERR_SSH_PUBKEY_NOT_SUPPORTED = 16;

  public static final int ERR_SSH_RSA_PUBKEY_TOO_SHORT = 17;

  public class GetAccountNamesResult {
    public java.util.List<String> _ret_;
  }

  GetAccountNamesResult getAccountNames() throws Exception;

  AsyncRequest getAccountNames(AsyncRpcResponse<GetAccountNamesResult> rsp);

  AsyncRequest getAccountNames(AsyncRpcResponse<GetAccountNamesResult> rsp, RpcCtrl rpcCtrl);


  public class CreateAccountResult {
    public int _ret_;
  }

  CreateAccountResult createAccount(String username, String password) throws Exception;

  AsyncRequest createAccount(String username, String password, AsyncRpcResponse<CreateAccountResult> rsp);

  AsyncRequest createAccount(String username, String password, AsyncRpcResponse<CreateAccountResult> rsp, RpcCtrl rpcCtrl);


  public class DeleteAccountResult {
    public int _ret_;
  }

  DeleteAccountResult deleteAccount(String username) throws Exception;

  AsyncRequest deleteAccount(String username, AsyncRpcResponse<DeleteAccountResult> rsp);

  AsyncRequest deleteAccount(String username, AsyncRpcResponse<DeleteAccountResult> rsp, RpcCtrl rpcCtrl);


  public class GetAllAccountsResult {
    public java.util.List<com.raritan.idl.usermgmt.Account> _ret_;
  }

  GetAllAccountsResult getAllAccounts() throws Exception;

  AsyncRequest getAllAccounts(AsyncRpcResponse<GetAllAccountsResult> rsp);

  AsyncRequest getAllAccounts(AsyncRpcResponse<GetAllAccountsResult> rsp, RpcCtrl rpcCtrl);


  public class CreateAccountFullResult {
    public int _ret_;
  }

  CreateAccountFullResult createAccountFull(String username, String password, com.raritan.idl.usermgmt.UserInfo info) throws Exception;

  AsyncRequest createAccountFull(String username, String password, com.raritan.idl.usermgmt.UserInfo info, AsyncRpcResponse<CreateAccountFullResult> rsp);

  AsyncRequest createAccountFull(String username, String password, com.raritan.idl.usermgmt.UserInfo info, AsyncRpcResponse<CreateAccountFullResult> rsp, RpcCtrl rpcCtrl);


  public class GetAccountsByRoleResult {
    public java.util.List<com.raritan.idl.usermgmt.Account> _ret_;
  }

  GetAccountsByRoleResult getAccountsByRole(String roleName) throws Exception;

  AsyncRequest getAccountsByRole(String roleName, AsyncRpcResponse<GetAccountsByRoleResult> rsp);

  AsyncRequest getAccountsByRole(String roleName, AsyncRpcResponse<GetAccountsByRoleResult> rsp, RpcCtrl rpcCtrl);


  public class GetDefaultPreferencesResult {
    public com.raritan.idl.usermgmt.Preferences _ret_;
  }

  GetDefaultPreferencesResult getDefaultPreferences() throws Exception;

  AsyncRequest getDefaultPreferences(AsyncRpcResponse<GetDefaultPreferencesResult> rsp);

  AsyncRequest getDefaultPreferences(AsyncRpcResponse<GetDefaultPreferencesResult> rsp, RpcCtrl rpcCtrl);


  public class SetDefaultPreferencesResult {
    public int _ret_;
  }

  SetDefaultPreferencesResult setDefaultPreferences(com.raritan.idl.usermgmt.Preferences prefs) throws Exception;

  AsyncRequest setDefaultPreferences(com.raritan.idl.usermgmt.Preferences prefs, AsyncRpcResponse<SetDefaultPreferencesResult> rsp);

  AsyncRequest setDefaultPreferences(com.raritan.idl.usermgmt.Preferences prefs, AsyncRpcResponse<SetDefaultPreferencesResult> rsp, RpcCtrl rpcCtrl);

}
