// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from AssetStripConfig.idl.

package com.raritan.json_rpc.assetmgrmodel;

import org.json.*;

import com.raritan.idl.*;
import com.raritan.json_rpc.*;
import com.raritan.util.AsyncRequest;

public class AssetStripConfig_1_0_1_Proxy extends ObjectProxy implements com.raritan.idl.assetmgrmodel.AssetStripConfig_1_0_1 {

  public AssetStripConfig_1_0_1_Proxy(Agent agent, String rid, TypeInfo typeInfo) {
    super(agent, rid, typeInfo);
  }

  public AssetStripConfig_1_0_1_Proxy(Agent agent, String rid) {
    this(agent, rid, com.raritan.idl.assetmgrmodel.AssetStripConfig_1_0_1.typeInfo);
  }

  public static AssetStripConfig_1_0_1_Proxy staticCast(ObjectProxy proxy) {
    return proxy == null ? null : new AssetStripConfig_1_0_1_Proxy(proxy.getAgent(), proxy.getRid(), proxy.getStaticTypeInfo());
  }


  @Override
  public GetStripSettingsResult getStripSettings() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getStripSettings", params);
    GetStripSettingsResult ret = new GetStripSettingsResult();
    ret._ret_ = com.raritan.json_rpc.assetmgrmodel.AssetStripConfig_1_0_1.StripSettings_Codec.decode(result.getJSONObject("_ret_"), agent);
    return ret;
  }

  @Override
  public AsyncRequest getStripSettings(final AsyncRpcResponse<GetStripSettingsResult> rsp) {
    return getStripSettings(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getStripSettings(final AsyncRpcResponse<GetStripSettingsResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getStripSettings", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetStripSettingsResult ret = new GetStripSettingsResult();
          ret._ret_ = com.raritan.json_rpc.assetmgrmodel.AssetStripConfig_1_0_1.StripSettings_Codec.decode(result.getJSONObject("_ret_"), agent);
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public SetStripSettingsResult setStripSettings(final com.raritan.idl.assetmgrmodel.AssetStripConfig_1_0_1.StripSettings settings) throws Exception {
    JSONObject params = new JSONObject();
    params.put("settings", com.raritan.json_rpc.assetmgrmodel.AssetStripConfig_1_0_1.StripSettings_Codec.encode(settings));
    final JSONObject result = rpcCall("setStripSettings", params);
    SetStripSettingsResult ret = new SetStripSettingsResult();
    ret._ret_ = result.getInt("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest setStripSettings(final com.raritan.idl.assetmgrmodel.AssetStripConfig_1_0_1.StripSettings settings, final AsyncRpcResponse<SetStripSettingsResult> rsp) {
    return setStripSettings(settings, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest setStripSettings(final com.raritan.idl.assetmgrmodel.AssetStripConfig_1_0_1.StripSettings settings, final AsyncRpcResponse<SetStripSettingsResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("settings", com.raritan.json_rpc.assetmgrmodel.AssetStripConfig_1_0_1.StripSettings_Codec.encode(settings));
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("setStripSettings", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          SetStripSettingsResult ret = new SetStripSettingsResult();
          ret._ret_ = result.getInt("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetRackUnitSettingsResult getRackUnitSettings(final int rackUnitNumber) throws Exception {
    JSONObject params = new JSONObject();
    params.put("rackUnitNumber", rackUnitNumber);
    final JSONObject result = rpcCall("getRackUnitSettings", params);
    GetRackUnitSettingsResult ret = new GetRackUnitSettingsResult();
    ret._ret_ = result.getInt("_ret_");
    ret.settings = com.raritan.json_rpc.assetmgrmodel.AssetStripConfig_1_0_1.RackUnitSettings_Codec.decode(result.getJSONObject("settings"), agent);
    return ret;
  }

  @Override
  public AsyncRequest getRackUnitSettings(final int rackUnitNumber, final AsyncRpcResponse<GetRackUnitSettingsResult> rsp) {
    return getRackUnitSettings(rackUnitNumber, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getRackUnitSettings(final int rackUnitNumber, final AsyncRpcResponse<GetRackUnitSettingsResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("rackUnitNumber", rackUnitNumber);
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("getRackUnitSettings", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetRackUnitSettingsResult ret = new GetRackUnitSettingsResult();
          ret._ret_ = result.getInt("_ret_");
          ret.settings = com.raritan.json_rpc.assetmgrmodel.AssetStripConfig_1_0_1.RackUnitSettings_Codec.decode(result.getJSONObject("settings"), agent);
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetAllRackUnitSettingsResult getAllRackUnitSettings() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getAllRackUnitSettings", params);
    GetAllRackUnitSettingsResult ret = new GetAllRackUnitSettingsResult();
    ret._ret_ = new java.util.ArrayList<com.raritan.idl.assetmgrmodel.AssetStripConfig_1_0_1.RackUnitSettings>() {
      private static final long serialVersionUID = 1L;
      {
        final JSONArray array0 = result.getJSONArray("_ret_");
        for (int i0 = 0; i0 < array0.length(); i0++) {
          final int i0_f = i0;
          this.add(com.raritan.json_rpc.assetmgrmodel.AssetStripConfig_1_0_1.RackUnitSettings_Codec.decode(array0.getJSONObject(i0_f), agent));
        }
      }
    };
    return ret;
  }

  @Override
  public AsyncRequest getAllRackUnitSettings(final AsyncRpcResponse<GetAllRackUnitSettingsResult> rsp) {
    return getAllRackUnitSettings(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getAllRackUnitSettings(final AsyncRpcResponse<GetAllRackUnitSettingsResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getAllRackUnitSettings", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetAllRackUnitSettingsResult ret = new GetAllRackUnitSettingsResult();
          ret._ret_ = new java.util.ArrayList<com.raritan.idl.assetmgrmodel.AssetStripConfig_1_0_1.RackUnitSettings>() {
            private static final long serialVersionUID = 1L;
            {
              final JSONArray array0 = result.getJSONArray("_ret_");
              for (int i0 = 0; i0 < array0.length(); i0++) {
                final int i0_f = i0;
                this.add(com.raritan.json_rpc.assetmgrmodel.AssetStripConfig_1_0_1.RackUnitSettings_Codec.decode(array0.getJSONObject(i0_f), agent));
              }
            }
          };
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public SetRackUnitSettingsResult setRackUnitSettings(final int rackUnitNumber, final com.raritan.idl.assetmgrmodel.AssetStripConfig_1_0_1.RackUnitSettings settings) throws Exception {
    JSONObject params = new JSONObject();
    params.put("rackUnitNumber", rackUnitNumber);
    params.put("settings", com.raritan.json_rpc.assetmgrmodel.AssetStripConfig_1_0_1.RackUnitSettings_Codec.encode(settings));
    final JSONObject result = rpcCall("setRackUnitSettings", params);
    SetRackUnitSettingsResult ret = new SetRackUnitSettingsResult();
    ret._ret_ = result.getInt("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest setRackUnitSettings(final int rackUnitNumber, final com.raritan.idl.assetmgrmodel.AssetStripConfig_1_0_1.RackUnitSettings settings, final AsyncRpcResponse<SetRackUnitSettingsResult> rsp) {
    return setRackUnitSettings(rackUnitNumber, settings, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest setRackUnitSettings(final int rackUnitNumber, final com.raritan.idl.assetmgrmodel.AssetStripConfig_1_0_1.RackUnitSettings settings, final AsyncRpcResponse<SetRackUnitSettingsResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("rackUnitNumber", rackUnitNumber);
      params.put("settings", com.raritan.json_rpc.assetmgrmodel.AssetStripConfig_1_0_1.RackUnitSettings_Codec.encode(settings));
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("setRackUnitSettings", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          SetRackUnitSettingsResult ret = new SetRackUnitSettingsResult();
          ret._ret_ = result.getInt("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public SetMultipleRackUnitSettingsResult setMultipleRackUnitSettings(final java.util.Map<Integer, com.raritan.idl.assetmgrmodel.AssetStripConfig_1_0_1.RackUnitSettings> settings) throws Exception {
    JSONObject params = new JSONObject();
    params.put("settings", new JSONArray() {{
      java.util.Map<Integer, com.raritan.idl.assetmgrmodel.AssetStripConfig_1_0_1.RackUnitSettings> map0 = settings;
      for (java.util.Map.Entry<Integer, com.raritan.idl.assetmgrmodel.AssetStripConfig_1_0_1.RackUnitSettings> entry0 : map0.entrySet()) {
        final java.util.Map.Entry<Integer, com.raritan.idl.assetmgrmodel.AssetStripConfig_1_0_1.RackUnitSettings> entry0_f = entry0;
        JSONObject elem0 = new JSONObject();
        elem0.put("key", entry0_f.getKey());
        elem0.put("value", com.raritan.json_rpc.assetmgrmodel.AssetStripConfig_1_0_1.RackUnitSettings_Codec.encode(entry0_f.getValue()));
        this.put(elem0);
      }
    }});
    final JSONObject result = rpcCall("setMultipleRackUnitSettings", params);
    SetMultipleRackUnitSettingsResult ret = new SetMultipleRackUnitSettingsResult();
    ret._ret_ = result.getInt("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest setMultipleRackUnitSettings(final java.util.Map<Integer, com.raritan.idl.assetmgrmodel.AssetStripConfig_1_0_1.RackUnitSettings> settings, final AsyncRpcResponse<SetMultipleRackUnitSettingsResult> rsp) {
    return setMultipleRackUnitSettings(settings, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest setMultipleRackUnitSettings(final java.util.Map<Integer, com.raritan.idl.assetmgrmodel.AssetStripConfig_1_0_1.RackUnitSettings> settings, final AsyncRpcResponse<SetMultipleRackUnitSettingsResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("settings", new JSONArray() {{
        java.util.Map<Integer, com.raritan.idl.assetmgrmodel.AssetStripConfig_1_0_1.RackUnitSettings> map0 = settings;
        for (java.util.Map.Entry<Integer, com.raritan.idl.assetmgrmodel.AssetStripConfig_1_0_1.RackUnitSettings> entry0 : map0.entrySet()) {
          final java.util.Map.Entry<Integer, com.raritan.idl.assetmgrmodel.AssetStripConfig_1_0_1.RackUnitSettings> entry0_f = entry0;
          JSONObject elem0 = new JSONObject();
          elem0.put("key", entry0_f.getKey());
          elem0.put("value", com.raritan.json_rpc.assetmgrmodel.AssetStripConfig_1_0_1.RackUnitSettings_Codec.encode(entry0_f.getValue()));
          this.put(elem0);
        }
      }});
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("setMultipleRackUnitSettings", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          SetMultipleRackUnitSettingsResult ret = new SetMultipleRackUnitSettingsResult();
          ret._ret_ = result.getInt("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }
}
