// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from BulkConfiguration.idl.

package com.raritan.json_rpc.bulkcfg;

import org.json.*;

import com.raritan.idl.*;
import com.raritan.json_rpc.*;
import com.raritan.util.AsyncRequest;

public class BulkConfiguration_1_0_1_Proxy extends ObjectProxy implements com.raritan.idl.bulkcfg.BulkConfiguration_1_0_1 {

  public BulkConfiguration_1_0_1_Proxy(Agent agent, String rid, TypeInfo typeInfo) {
    super(agent, rid, typeInfo);
  }

  public BulkConfiguration_1_0_1_Proxy(Agent agent, String rid) {
    this(agent, rid, com.raritan.idl.bulkcfg.BulkConfiguration_1_0_1.typeInfo);
  }

  public static BulkConfiguration_1_0_1_Proxy staticCast(ObjectProxy proxy) {
    return proxy == null ? null : new BulkConfiguration_1_0_1_Proxy(proxy.getAgent(), proxy.getRid(), proxy.getStaticTypeInfo());
  }


  @Override
  public GetStatusResult getStatus() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getStatus", params);
    GetStatusResult ret = new GetStatusResult();
    ret.status = com.raritan.json_rpc.bulkcfg.BulkConfiguration_1_0_1.Status_Codec.decode(result.getInt("status"));
    ret.timeStamp = new java.util.Date(((long) result.getInt("timeStamp")) * 1000);
    return ret;
  }

  @Override
  public AsyncRequest getStatus(final AsyncRpcResponse<GetStatusResult> rsp) {
    return getStatus(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getStatus(final AsyncRpcResponse<GetStatusResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getStatus", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetStatusResult ret = new GetStatusResult();
          ret.status = com.raritan.json_rpc.bulkcfg.BulkConfiguration_1_0_1.Status_Codec.decode(result.getInt("status"));
          ret.timeStamp = new java.util.Date(((long) result.getInt("timeStamp")) * 1000);
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetFiltersResult getFilters() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getFilters", params);
    GetFiltersResult ret = new GetFiltersResult();
    ret._ret_ = new java.util.ArrayList<com.raritan.idl.bulkcfg.BulkConfiguration_1_0_1.Filter>() {
      private static final long serialVersionUID = 1L;
      {
        final JSONArray array0 = result.getJSONArray("_ret_");
        for (int i0 = 0; i0 < array0.length(); i0++) {
          final int i0_f = i0;
          this.add(com.raritan.json_rpc.bulkcfg.BulkConfiguration_1_0_1.Filter_Codec.decode(array0.getJSONObject(i0_f), agent));
        }
      }
    };
    return ret;
  }

  @Override
  public AsyncRequest getFilters(final AsyncRpcResponse<GetFiltersResult> rsp) {
    return getFilters(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getFilters(final AsyncRpcResponse<GetFiltersResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getFilters", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetFiltersResult ret = new GetFiltersResult();
          ret._ret_ = new java.util.ArrayList<com.raritan.idl.bulkcfg.BulkConfiguration_1_0_1.Filter>() {
            private static final long serialVersionUID = 1L;
            {
              final JSONArray array0 = result.getJSONArray("_ret_");
              for (int i0 = 0; i0 < array0.length(); i0++) {
                final int i0_f = i0;
                this.add(com.raritan.json_rpc.bulkcfg.BulkConfiguration_1_0_1.Filter_Codec.decode(array0.getJSONObject(i0_f), agent));
              }
            }
          };
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetFilterProfilesResult getFilterProfiles() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getFilterProfiles", params);
    GetFilterProfilesResult ret = new GetFilterProfilesResult();
    ret._ret_ = new java.util.ArrayList<com.raritan.idl.bulkcfg.BulkConfiguration_1_0_1.FilterProfile>() {
      private static final long serialVersionUID = 1L;
      {
        final JSONArray array0 = result.getJSONArray("_ret_");
        for (int i0 = 0; i0 < array0.length(); i0++) {
          final int i0_f = i0;
          this.add(com.raritan.json_rpc.bulkcfg.BulkConfiguration_1_0_1.FilterProfile_Codec.decode(array0.getJSONObject(i0_f), agent));
        }
      }
    };
    return ret;
  }

  @Override
  public AsyncRequest getFilterProfiles(final AsyncRpcResponse<GetFilterProfilesResult> rsp) {
    return getFilterProfiles(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getFilterProfiles(final AsyncRpcResponse<GetFilterProfilesResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getFilterProfiles", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetFilterProfilesResult ret = new GetFilterProfilesResult();
          ret._ret_ = new java.util.ArrayList<com.raritan.idl.bulkcfg.BulkConfiguration_1_0_1.FilterProfile>() {
            private static final long serialVersionUID = 1L;
            {
              final JSONArray array0 = result.getJSONArray("_ret_");
              for (int i0 = 0; i0 < array0.length(); i0++) {
                final int i0_f = i0;
                this.add(com.raritan.json_rpc.bulkcfg.BulkConfiguration_1_0_1.FilterProfile_Codec.decode(array0.getJSONObject(i0_f), agent));
              }
            }
          };
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public AddFilterProfileResult addFilterProfile(final com.raritan.idl.bulkcfg.BulkConfiguration_1_0_1.FilterProfile profile) throws Exception {
    JSONObject params = new JSONObject();
    params.put("profile", com.raritan.json_rpc.bulkcfg.BulkConfiguration_1_0_1.FilterProfile_Codec.encode(profile));
    final JSONObject result = rpcCall("addFilterProfile", params);
    AddFilterProfileResult ret = new AddFilterProfileResult();
    ret._ret_ = result.getInt("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest addFilterProfile(final com.raritan.idl.bulkcfg.BulkConfiguration_1_0_1.FilterProfile profile, final AsyncRpcResponse<AddFilterProfileResult> rsp) {
    return addFilterProfile(profile, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest addFilterProfile(final com.raritan.idl.bulkcfg.BulkConfiguration_1_0_1.FilterProfile profile, final AsyncRpcResponse<AddFilterProfileResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("profile", com.raritan.json_rpc.bulkcfg.BulkConfiguration_1_0_1.FilterProfile_Codec.encode(profile));
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("addFilterProfile", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          AddFilterProfileResult ret = new AddFilterProfileResult();
          ret._ret_ = result.getInt("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public ModifyFilterProfileResult modifyFilterProfile(final com.raritan.idl.bulkcfg.BulkConfiguration_1_0_1.FilterProfile profile) throws Exception {
    JSONObject params = new JSONObject();
    params.put("profile", com.raritan.json_rpc.bulkcfg.BulkConfiguration_1_0_1.FilterProfile_Codec.encode(profile));
    final JSONObject result = rpcCall("modifyFilterProfile", params);
    ModifyFilterProfileResult ret = new ModifyFilterProfileResult();
    ret._ret_ = result.getInt("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest modifyFilterProfile(final com.raritan.idl.bulkcfg.BulkConfiguration_1_0_1.FilterProfile profile, final AsyncRpcResponse<ModifyFilterProfileResult> rsp) {
    return modifyFilterProfile(profile, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest modifyFilterProfile(final com.raritan.idl.bulkcfg.BulkConfiguration_1_0_1.FilterProfile profile, final AsyncRpcResponse<ModifyFilterProfileResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("profile", com.raritan.json_rpc.bulkcfg.BulkConfiguration_1_0_1.FilterProfile_Codec.encode(profile));
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("modifyFilterProfile", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          ModifyFilterProfileResult ret = new ModifyFilterProfileResult();
          ret._ret_ = result.getInt("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public DeleteFilterProfileResult deleteFilterProfile(final String profileName) throws Exception {
    JSONObject params = new JSONObject();
    params.put("profileName", profileName);
    final JSONObject result = rpcCall("deleteFilterProfile", params);
    DeleteFilterProfileResult ret = new DeleteFilterProfileResult();
    ret._ret_ = result.getInt("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest deleteFilterProfile(final String profileName, final AsyncRpcResponse<DeleteFilterProfileResult> rsp) {
    return deleteFilterProfile(profileName, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest deleteFilterProfile(final String profileName, final AsyncRpcResponse<DeleteFilterProfileResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("profileName", profileName);
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("deleteFilterProfile", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          DeleteFilterProfileResult ret = new DeleteFilterProfileResult();
          ret._ret_ = result.getInt("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetDefaultFilterProfileNameResult getDefaultFilterProfileName() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getDefaultFilterProfileName", params);
    GetDefaultFilterProfileNameResult ret = new GetDefaultFilterProfileNameResult();
    ret._ret_ = result.getString("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest getDefaultFilterProfileName(final AsyncRpcResponse<GetDefaultFilterProfileNameResult> rsp) {
    return getDefaultFilterProfileName(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getDefaultFilterProfileName(final AsyncRpcResponse<GetDefaultFilterProfileNameResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getDefaultFilterProfileName", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetDefaultFilterProfileNameResult ret = new GetDefaultFilterProfileNameResult();
          ret._ret_ = result.getString("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public SelectDefaultFilterProfileResult selectDefaultFilterProfile(final String profileName) throws Exception {
    JSONObject params = new JSONObject();
    params.put("profileName", profileName);
    final JSONObject result = rpcCall("selectDefaultFilterProfile", params);
    SelectDefaultFilterProfileResult ret = new SelectDefaultFilterProfileResult();
    ret._ret_ = result.getInt("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest selectDefaultFilterProfile(final String profileName, final AsyncRpcResponse<SelectDefaultFilterProfileResult> rsp) {
    return selectDefaultFilterProfile(profileName, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest selectDefaultFilterProfile(final String profileName, final AsyncRpcResponse<SelectDefaultFilterProfileResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("profileName", profileName);
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("selectDefaultFilterProfile", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          SelectDefaultFilterProfileResult ret = new SelectDefaultFilterProfileResult();
          ret._ret_ = result.getInt("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }
}
