// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from BulkRequest.idl.

package com.raritan.json_rpc.bulkrpc;

import org.json.*;

import com.raritan.idl.*;
import com.raritan.json_rpc.*;
import com.raritan.util.AsyncRequest;

public class BulkRequest_1_0_1_Proxy extends ObjectProxy implements com.raritan.idl.bulkrpc.BulkRequest_1_0_1 {

  public BulkRequest_1_0_1_Proxy(Agent agent, String rid, TypeInfo typeInfo) {
    super(agent, rid, typeInfo);
  }

  public BulkRequest_1_0_1_Proxy(Agent agent, String rid) {
    this(agent, rid, com.raritan.idl.bulkrpc.BulkRequest_1_0_1.typeInfo);
  }

  public static BulkRequest_1_0_1_Proxy staticCast(ObjectProxy proxy) {
    return proxy == null ? null : new BulkRequest_1_0_1_Proxy(proxy.getAgent(), proxy.getRid(), proxy.getStaticTypeInfo());
  }


  @Override
  public PerformRequestResult performRequest(final java.util.List<com.raritan.idl.bulkrpc.Request> requests) throws Exception {
    JSONObject params = new JSONObject();
    params.put("requests", new JSONArray() {{
      final java.util.List<com.raritan.idl.bulkrpc.Request> array0 = requests;
      for (int i0 = 0; i0 < array0.size(); i0++) {
        final int i0_f = i0;
        this.put(com.raritan.json_rpc.bulkrpc.Request_Codec.encode(array0.get(i0_f)));
      }
    }});
    final JSONObject result = rpcCall("performRequest", params);
    PerformRequestResult ret = new PerformRequestResult();
    ret.responses = new java.util.ArrayList<com.raritan.idl.bulkrpc.Response>() {
      private static final long serialVersionUID = 1L;
      {
        final JSONArray array0 = result.getJSONArray("responses");
        for (int i0 = 0; i0 < array0.length(); i0++) {
          final int i0_f = i0;
          this.add(com.raritan.json_rpc.bulkrpc.Response_Codec.decode(array0.getJSONObject(i0_f), agent));
        }
      }
    };
    return ret;
  }

  @Override
  public AsyncRequest performRequest(final java.util.List<com.raritan.idl.bulkrpc.Request> requests, final AsyncRpcResponse<PerformRequestResult> rsp) {
    return performRequest(requests, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest performRequest(final java.util.List<com.raritan.idl.bulkrpc.Request> requests, final AsyncRpcResponse<PerformRequestResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("requests", new JSONArray() {{
        final java.util.List<com.raritan.idl.bulkrpc.Request> array0 = requests;
        for (int i0 = 0; i0 < array0.size(); i0++) {
          final int i0_f = i0;
          this.put(com.raritan.json_rpc.bulkrpc.Request_Codec.encode(array0.get(i0_f)));
        }
      }});
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("performRequest", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          PerformRequestResult ret = new PerformRequestResult();
          ret.responses = new java.util.ArrayList<com.raritan.idl.bulkrpc.Response>() {
            private static final long serialVersionUID = 1L;
            {
              final JSONArray array0 = result.getJSONArray("responses");
              for (int i0 = 0; i0 < array0.length(); i0++) {
                final int i0_f = i0;
                this.add(com.raritan.json_rpc.bulkrpc.Response_Codec.decode(array0.getJSONObject(i0_f), agent));
              }
            }
          };
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public PerformBulkResult performBulk(final java.util.List<com.raritan.idl.bulkrpc.BulkRequest_1_0_1.Request> requests) throws Exception {
    JSONObject params = new JSONObject();
    params.put("requests", new JSONArray() {{
      final java.util.List<com.raritan.idl.bulkrpc.BulkRequest_1_0_1.Request> array0 = requests;
      for (int i0 = 0; i0 < array0.size(); i0++) {
        final int i0_f = i0;
        this.put(com.raritan.json_rpc.bulkrpc.BulkRequest_1_0_1.Request_Codec.encode(array0.get(i0_f)));
      }
    }});
    final JSONObject result = rpcCall("performBulk", params);
    PerformBulkResult ret = new PerformBulkResult();
    ret.responses = new java.util.ArrayList<com.raritan.idl.bulkrpc.BulkRequest_1_0_1.Response>() {
      private static final long serialVersionUID = 1L;
      {
        final JSONArray array0 = result.getJSONArray("responses");
        for (int i0 = 0; i0 < array0.length(); i0++) {
          final int i0_f = i0;
          this.add(com.raritan.json_rpc.bulkrpc.BulkRequest_1_0_1.Response_Codec.decode(array0.getJSONObject(i0_f), agent));
        }
      }
    };
    return ret;
  }

  @Override
  public AsyncRequest performBulk(final java.util.List<com.raritan.idl.bulkrpc.BulkRequest_1_0_1.Request> requests, final AsyncRpcResponse<PerformBulkResult> rsp) {
    return performBulk(requests, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest performBulk(final java.util.List<com.raritan.idl.bulkrpc.BulkRequest_1_0_1.Request> requests, final AsyncRpcResponse<PerformBulkResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("requests", new JSONArray() {{
        final java.util.List<com.raritan.idl.bulkrpc.BulkRequest_1_0_1.Request> array0 = requests;
        for (int i0 = 0; i0 < array0.size(); i0++) {
          final int i0_f = i0;
          this.put(com.raritan.json_rpc.bulkrpc.BulkRequest_1_0_1.Request_Codec.encode(array0.get(i0_f)));
        }
      }});
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("performBulk", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          PerformBulkResult ret = new PerformBulkResult();
          ret.responses = new java.util.ArrayList<com.raritan.idl.bulkrpc.BulkRequest_1_0_1.Response>() {
            private static final long serialVersionUID = 1L;
            {
              final JSONArray array0 = result.getJSONArray("responses");
              for (int i0 = 0; i0 < array0.length(); i0++) {
                final int i0_f = i0;
                this.add(com.raritan.json_rpc.bulkrpc.BulkRequest_1_0_1.Response_Codec.decode(array0.getJSONObject(i0_f), agent));
              }
            }
          };
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }
}
