// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from ServerSSLCert.idl.

package com.raritan.json_rpc.cert;

import org.json.*;

import com.raritan.idl.*;
import com.raritan.json_rpc.*;
import com.raritan.util.AsyncRequest;

public class ServerSSLCert_4_0_0_Proxy extends ObjectProxy implements com.raritan.idl.cert.ServerSSLCert_4_0_0 {

  public ServerSSLCert_4_0_0_Proxy(Agent agent, String rid, TypeInfo typeInfo) {
    super(agent, rid, typeInfo);
  }

  public ServerSSLCert_4_0_0_Proxy(Agent agent, String rid) {
    this(agent, rid, com.raritan.idl.cert.ServerSSLCert_4_0_0.typeInfo);
  }

  public static ServerSSLCert_4_0_0_Proxy staticCast(ObjectProxy proxy) {
    return proxy == null ? null : new ServerSSLCert_4_0_0_Proxy(proxy.getAgent(), proxy.getRid(), proxy.getStaticTypeInfo());
  }


  @Override
  public GetSupportedKeyInfosResult getSupportedKeyInfos() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getSupportedKeyInfos", params);
    GetSupportedKeyInfosResult ret = new GetSupportedKeyInfosResult();
    ret._ret_ = new java.util.ArrayList<com.raritan.idl.cert.ServerSSLCert_4_0_0.KeyInfo>() {
      private static final long serialVersionUID = 1L;
      {
        final JSONArray array0 = result.getJSONArray("_ret_");
        for (int i0 = 0; i0 < array0.length(); i0++) {
          final int i0_f = i0;
          this.add(com.raritan.json_rpc.cert.ServerSSLCert_4_0_0.KeyInfo_Codec.decode(array0.getJSONObject(i0_f), agent));
        }
      }
    };
    return ret;
  }

  @Override
  public AsyncRequest getSupportedKeyInfos(final AsyncRpcResponse<GetSupportedKeyInfosResult> rsp) {
    return getSupportedKeyInfos(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getSupportedKeyInfos(final AsyncRpcResponse<GetSupportedKeyInfosResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getSupportedKeyInfos", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetSupportedKeyInfosResult ret = new GetSupportedKeyInfosResult();
          ret._ret_ = new java.util.ArrayList<com.raritan.idl.cert.ServerSSLCert_4_0_0.KeyInfo>() {
            private static final long serialVersionUID = 1L;
            {
              final JSONArray array0 = result.getJSONArray("_ret_");
              for (int i0 = 0; i0 < array0.length(); i0++) {
                final int i0_f = i0;
                this.add(com.raritan.json_rpc.cert.ServerSSLCert_4_0_0.KeyInfo_Codec.decode(array0.getJSONObject(i0_f), agent));
              }
            }
          };
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GenerateUnsignedKeyPairResult generateUnsignedKeyPair(final com.raritan.idl.cert.ServerSSLCert_4_0_0.ReqInfo reqInfo, final String challenge) throws Exception {
    JSONObject params = new JSONObject();
    params.put("reqInfo", com.raritan.json_rpc.cert.ServerSSLCert_4_0_0.ReqInfo_Codec.encode(reqInfo));
    params.put("challenge", challenge);
    final JSONObject result = rpcCall("generateUnsignedKeyPair", params);
    GenerateUnsignedKeyPairResult ret = new GenerateUnsignedKeyPairResult();
    ret._ret_ = result.getInt("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest generateUnsignedKeyPair(final com.raritan.idl.cert.ServerSSLCert_4_0_0.ReqInfo reqInfo, final String challenge, final AsyncRpcResponse<GenerateUnsignedKeyPairResult> rsp) {
    return generateUnsignedKeyPair(reqInfo, challenge, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest generateUnsignedKeyPair(final com.raritan.idl.cert.ServerSSLCert_4_0_0.ReqInfo reqInfo, final String challenge, final AsyncRpcResponse<GenerateUnsignedKeyPairResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("reqInfo", com.raritan.json_rpc.cert.ServerSSLCert_4_0_0.ReqInfo_Codec.encode(reqInfo));
      params.put("challenge", challenge);
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("generateUnsignedKeyPair", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GenerateUnsignedKeyPairResult ret = new GenerateUnsignedKeyPairResult();
          ret._ret_ = result.getInt("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GenerateSelfSignedKeyPairResult generateSelfSignedKeyPair(final com.raritan.idl.cert.ServerSSLCert_4_0_0.ReqInfo reqInfo, final int days) throws Exception {
    JSONObject params = new JSONObject();
    params.put("reqInfo", com.raritan.json_rpc.cert.ServerSSLCert_4_0_0.ReqInfo_Codec.encode(reqInfo));
    params.put("days", days);
    final JSONObject result = rpcCall("generateSelfSignedKeyPair", params);
    GenerateSelfSignedKeyPairResult ret = new GenerateSelfSignedKeyPairResult();
    ret._ret_ = result.getInt("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest generateSelfSignedKeyPair(final com.raritan.idl.cert.ServerSSLCert_4_0_0.ReqInfo reqInfo, final int days, final AsyncRpcResponse<GenerateSelfSignedKeyPairResult> rsp) {
    return generateSelfSignedKeyPair(reqInfo, days, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest generateSelfSignedKeyPair(final com.raritan.idl.cert.ServerSSLCert_4_0_0.ReqInfo reqInfo, final int days, final AsyncRpcResponse<GenerateSelfSignedKeyPairResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("reqInfo", com.raritan.json_rpc.cert.ServerSSLCert_4_0_0.ReqInfo_Codec.encode(reqInfo));
      params.put("days", days);
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("generateSelfSignedKeyPair", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GenerateSelfSignedKeyPairResult ret = new GenerateSelfSignedKeyPairResult();
          ret._ret_ = result.getInt("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public Void deletePending() throws Exception {
    JSONObject params = null;
    rpcCall("deletePending", params);
    Void ret = null;
    return ret;
  }

  @Override
  public AsyncRequest deletePending(final AsyncRpcResponse<Void> rsp) {
    return deletePending(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest deletePending(final AsyncRpcResponse<Void> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("deletePending", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          Void ret = null;
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetInfoResult getInfo() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getInfo", params);
    GetInfoResult ret = new GetInfoResult();
    ret.info = com.raritan.json_rpc.cert.ServerSSLCert_4_0_0.Info_Codec.decode(result.getJSONObject("info"), agent);
    return ret;
  }

  @Override
  public AsyncRequest getInfo(final AsyncRpcResponse<GetInfoResult> rsp) {
    return getInfo(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getInfo(final AsyncRpcResponse<GetInfoResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getInfo", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetInfoResult ret = new GetInfoResult();
          ret.info = com.raritan.json_rpc.cert.ServerSSLCert_4_0_0.Info_Codec.decode(result.getJSONObject("info"), agent);
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetActiveCertChainPEMResult getActiveCertChainPEM() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getActiveCertChainPEM", params);
    GetActiveCertChainPEMResult ret = new GetActiveCertChainPEMResult();
    ret._ret_ = result.getString("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest getActiveCertChainPEM(final AsyncRpcResponse<GetActiveCertChainPEMResult> rsp) {
    return getActiveCertChainPEM(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getActiveCertChainPEM(final AsyncRpcResponse<GetActiveCertChainPEMResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getActiveCertChainPEM", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetActiveCertChainPEMResult ret = new GetActiveCertChainPEMResult();
          ret._ret_ = result.getString("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetActiveKeyPEMResult getActiveKeyPEM(final String keyPassword) throws Exception {
    JSONObject params = new JSONObject();
    params.put("keyPassword", keyPassword);
    final JSONObject result = rpcCall("getActiveKeyPEM", params);
    GetActiveKeyPEMResult ret = new GetActiveKeyPEMResult();
    ret._ret_ = result.getString("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest getActiveKeyPEM(final String keyPassword, final AsyncRpcResponse<GetActiveKeyPEMResult> rsp) {
    return getActiveKeyPEM(keyPassword, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getActiveKeyPEM(final String keyPassword, final AsyncRpcResponse<GetActiveKeyPEMResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("keyPassword", keyPassword);
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("getActiveKeyPEM", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetActiveKeyPEMResult ret = new GetActiveKeyPEMResult();
          ret._ret_ = result.getString("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetPendingRequestPEMResult getPendingRequestPEM() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getPendingRequestPEM", params);
    GetPendingRequestPEMResult ret = new GetPendingRequestPEMResult();
    ret._ret_ = result.getString("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest getPendingRequestPEM(final AsyncRpcResponse<GetPendingRequestPEMResult> rsp) {
    return getPendingRequestPEM(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getPendingRequestPEM(final AsyncRpcResponse<GetPendingRequestPEMResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getPendingRequestPEM", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetPendingRequestPEMResult ret = new GetPendingRequestPEMResult();
          ret._ret_ = result.getString("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetPendingCertChainPEMResult getPendingCertChainPEM() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getPendingCertChainPEM", params);
    GetPendingCertChainPEMResult ret = new GetPendingCertChainPEMResult();
    ret._ret_ = result.getString("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest getPendingCertChainPEM(final AsyncRpcResponse<GetPendingCertChainPEMResult> rsp) {
    return getPendingCertChainPEM(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getPendingCertChainPEM(final AsyncRpcResponse<GetPendingCertChainPEMResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getPendingCertChainPEM", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetPendingCertChainPEMResult ret = new GetPendingCertChainPEMResult();
          ret._ret_ = result.getString("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetPendingKeyPEMResult getPendingKeyPEM(final String keyPassword) throws Exception {
    JSONObject params = new JSONObject();
    params.put("keyPassword", keyPassword);
    final JSONObject result = rpcCall("getPendingKeyPEM", params);
    GetPendingKeyPEMResult ret = new GetPendingKeyPEMResult();
    ret._ret_ = result.getString("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest getPendingKeyPEM(final String keyPassword, final AsyncRpcResponse<GetPendingKeyPEMResult> rsp) {
    return getPendingKeyPEM(keyPassword, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getPendingKeyPEM(final String keyPassword, final AsyncRpcResponse<GetPendingKeyPEMResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("keyPassword", keyPassword);
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("getPendingKeyPEM", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetPendingKeyPEMResult ret = new GetPendingKeyPEMResult();
          ret._ret_ = result.getString("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public SetPendingCertChainPEMResult setPendingCertChainPEM(final String certChain) throws Exception {
    JSONObject params = new JSONObject();
    params.put("certChain", certChain);
    final JSONObject result = rpcCall("setPendingCertChainPEM", params);
    SetPendingCertChainPEMResult ret = new SetPendingCertChainPEMResult();
    ret._ret_ = result.getInt("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest setPendingCertChainPEM(final String certChain, final AsyncRpcResponse<SetPendingCertChainPEMResult> rsp) {
    return setPendingCertChainPEM(certChain, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest setPendingCertChainPEM(final String certChain, final AsyncRpcResponse<SetPendingCertChainPEMResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("certChain", certChain);
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("setPendingCertChainPEM", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          SetPendingCertChainPEMResult ret = new SetPendingCertChainPEMResult();
          ret._ret_ = result.getInt("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public SetPendingKeyAndCertChainPEMResult setPendingKeyAndCertChainPEM(final String key, final String certChain, final String keyPassword) throws Exception {
    JSONObject params = new JSONObject();
    params.put("key", key);
    params.put("certChain", certChain);
    params.put("keyPassword", keyPassword);
    final JSONObject result = rpcCall("setPendingKeyAndCertChainPEM", params);
    SetPendingKeyAndCertChainPEMResult ret = new SetPendingKeyAndCertChainPEMResult();
    ret._ret_ = result.getInt("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest setPendingKeyAndCertChainPEM(final String key, final String certChain, final String keyPassword, final AsyncRpcResponse<SetPendingKeyAndCertChainPEMResult> rsp) {
    return setPendingKeyAndCertChainPEM(key, certChain, keyPassword, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest setPendingKeyAndCertChainPEM(final String key, final String certChain, final String keyPassword, final AsyncRpcResponse<SetPendingKeyAndCertChainPEMResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("key", key);
      params.put("certChain", certChain);
      params.put("keyPassword", keyPassword);
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("setPendingKeyAndCertChainPEM", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          SetPendingKeyAndCertChainPEMResult ret = new SetPendingKeyAndCertChainPEMResult();
          ret._ret_ = result.getInt("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public InstallPendingKeyPairResult installPendingKeyPair() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("installPendingKeyPair", params);
    InstallPendingKeyPairResult ret = new InstallPendingKeyPairResult();
    ret._ret_ = result.getInt("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest installPendingKeyPair(final AsyncRpcResponse<InstallPendingKeyPairResult> rsp) {
    return installPendingKeyPair(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest installPendingKeyPair(final AsyncRpcResponse<InstallPendingKeyPairResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("installPendingKeyPair", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          InstallPendingKeyPairResult ret = new InstallPendingKeyPairResult();
          ret._ret_ = result.getInt("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }
}
