// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from Cfg.idl.

package com.raritan.json_rpc.cfg;

import org.json.*;

import com.raritan.idl.*;
import com.raritan.json_rpc.*;
import com.raritan.util.AsyncRequest;

public class Cfg_Proxy extends ObjectProxy implements com.raritan.idl.cfg.Cfg {

  public Cfg_Proxy(Agent agent, String rid, TypeInfo typeInfo) {
    super(agent, rid, typeInfo);
  }

  public Cfg_Proxy(Agent agent, String rid) {
    this(agent, rid, com.raritan.idl.cfg.Cfg.typeInfo);
  }

  public static Cfg_Proxy staticCast(ObjectProxy proxy) {
    return proxy == null ? null : new Cfg_Proxy(proxy.getAgent(), proxy.getRid(), proxy.getStaticTypeInfo());
  }


  @Override
  public GetValuesResult getValues(final java.util.List<String> keys) throws Exception {
    JSONObject params = new JSONObject();
    params.put("keys", new JSONArray() {{
      final java.util.List<String> array0 = keys;
      for (int i0 = 0; i0 < array0.size(); i0++) {
        final int i0_f = i0;
        this.put(array0.get(i0_f));
      }
    }});
    final JSONObject result = rpcCall("getValues", params);
    GetValuesResult ret = new GetValuesResult();
    ret._ret_ = result.getInt("_ret_");
    ret.values = new java.util.ArrayList<String>() {
      private static final long serialVersionUID = 1L;
      {
        final JSONArray array0 = result.getJSONArray("values");
        for (int i0 = 0; i0 < array0.length(); i0++) {
          final int i0_f = i0;
          this.add(array0.getString(i0_f));
        }
      }
    };
    return ret;
  }

  @Override
  public AsyncRequest getValues(final java.util.List<String> keys, final AsyncRpcResponse<GetValuesResult> rsp) {
    return getValues(keys, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getValues(final java.util.List<String> keys, final AsyncRpcResponse<GetValuesResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("keys", new JSONArray() {{
        final java.util.List<String> array0 = keys;
        for (int i0 = 0; i0 < array0.size(); i0++) {
          final int i0_f = i0;
          this.put(array0.get(i0_f));
        }
      }});
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("getValues", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetValuesResult ret = new GetValuesResult();
          ret._ret_ = result.getInt("_ret_");
          ret.values = new java.util.ArrayList<String>() {
            private static final long serialVersionUID = 1L;
            {
              final JSONArray array0 = result.getJSONArray("values");
              for (int i0 = 0; i0 < array0.length(); i0++) {
                final int i0_f = i0;
                this.add(array0.getString(i0_f));
              }
            }
          };
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public SetValuesResult setValues(final java.util.List<com.raritan.idl.cfg.KeyValue> keyvaluepairs) throws Exception {
    JSONObject params = new JSONObject();
    params.put("keyvaluepairs", new JSONArray() {{
      final java.util.List<com.raritan.idl.cfg.KeyValue> array0 = keyvaluepairs;
      for (int i0 = 0; i0 < array0.size(); i0++) {
        final int i0_f = i0;
        this.put(com.raritan.json_rpc.cfg.KeyValue_Codec.encode(array0.get(i0_f)));
      }
    }});
    final JSONObject result = rpcCall("setValues", params);
    SetValuesResult ret = new SetValuesResult();
    ret._ret_ = result.getInt("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest setValues(final java.util.List<com.raritan.idl.cfg.KeyValue> keyvaluepairs, final AsyncRpcResponse<SetValuesResult> rsp) {
    return setValues(keyvaluepairs, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest setValues(final java.util.List<com.raritan.idl.cfg.KeyValue> keyvaluepairs, final AsyncRpcResponse<SetValuesResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("keyvaluepairs", new JSONArray() {{
        final java.util.List<com.raritan.idl.cfg.KeyValue> array0 = keyvaluepairs;
        for (int i0 = 0; i0 < array0.size(); i0++) {
          final int i0_f = i0;
          this.put(com.raritan.json_rpc.cfg.KeyValue_Codec.encode(array0.get(i0_f)));
        }
      }});
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("setValues", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          SetValuesResult ret = new SetValuesResult();
          ret._ret_ = result.getInt("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }
}
