// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from DateTime.idl.

package com.raritan.json_rpc.datetime;

import org.json.*;

import com.raritan.idl.*;
import com.raritan.json_rpc.*;
import com.raritan.util.AsyncRequest;

public class DateTime_3_0_0_Proxy extends ObjectProxy implements com.raritan.idl.datetime.DateTime_3_0_0 {

  public DateTime_3_0_0_Proxy(Agent agent, String rid, TypeInfo typeInfo) {
    super(agent, rid, typeInfo);
  }

  public DateTime_3_0_0_Proxy(Agent agent, String rid) {
    this(agent, rid, com.raritan.idl.datetime.DateTime_3_0_0.typeInfo);
  }

  public static DateTime_3_0_0_Proxy staticCast(ObjectProxy proxy) {
    return proxy == null ? null : new DateTime_3_0_0_Proxy(proxy.getAgent(), proxy.getRid(), proxy.getStaticTypeInfo());
  }


  @Override
  public GetZoneInfosResult getZoneInfos(final boolean useOlson) throws Exception {
    JSONObject params = new JSONObject();
    params.put("useOlson", useOlson);
    final JSONObject result = rpcCall("getZoneInfos", params);
    GetZoneInfosResult ret = new GetZoneInfosResult();
    ret.zoneInfos = new java.util.ArrayList<com.raritan.idl.datetime.DateTime_3_0_0.ZoneInfo>() {
      private static final long serialVersionUID = 1L;
      {
        final JSONArray array0 = result.getJSONArray("zoneInfos");
        for (int i0 = 0; i0 < array0.length(); i0++) {
          final int i0_f = i0;
          this.add(com.raritan.json_rpc.datetime.DateTime_3_0_0.ZoneInfo_Codec.decode(array0.getJSONObject(i0_f), agent));
        }
      }
    };
    return ret;
  }

  @Override
  public AsyncRequest getZoneInfos(final boolean useOlson, final AsyncRpcResponse<GetZoneInfosResult> rsp) {
    return getZoneInfos(useOlson, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getZoneInfos(final boolean useOlson, final AsyncRpcResponse<GetZoneInfosResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("useOlson", useOlson);
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("getZoneInfos", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetZoneInfosResult ret = new GetZoneInfosResult();
          ret.zoneInfos = new java.util.ArrayList<com.raritan.idl.datetime.DateTime_3_0_0.ZoneInfo>() {
            private static final long serialVersionUID = 1L;
            {
              final JSONArray array0 = result.getJSONArray("zoneInfos");
              for (int i0 = 0; i0 < array0.length(); i0++) {
                final int i0_f = i0;
                this.add(com.raritan.json_rpc.datetime.DateTime_3_0_0.ZoneInfo_Codec.decode(array0.getJSONObject(i0_f), agent));
              }
            }
          };
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public CheckNtpServerResult checkNtpServer(final String ntpServer) throws Exception {
    JSONObject params = new JSONObject();
    params.put("ntpServer", ntpServer);
    final JSONObject result = rpcCall("checkNtpServer", params);
    CheckNtpServerResult ret = new CheckNtpServerResult();
    ret._ret_ = result.getBoolean("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest checkNtpServer(final String ntpServer, final AsyncRpcResponse<CheckNtpServerResult> rsp) {
    return checkNtpServer(ntpServer, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest checkNtpServer(final String ntpServer, final AsyncRpcResponse<CheckNtpServerResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("ntpServer", ntpServer);
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("checkNtpServer", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          CheckNtpServerResult ret = new CheckNtpServerResult();
          ret._ret_ = result.getBoolean("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetCfgResult getCfg() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getCfg", params);
    GetCfgResult ret = new GetCfgResult();
    ret.cfg = com.raritan.json_rpc.datetime.DateTime_3_0_0.Cfg_Codec.decode(result.getJSONObject("cfg"), agent);
    return ret;
  }

  @Override
  public AsyncRequest getCfg(final AsyncRpcResponse<GetCfgResult> rsp) {
    return getCfg(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getCfg(final AsyncRpcResponse<GetCfgResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getCfg", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetCfgResult ret = new GetCfgResult();
          ret.cfg = com.raritan.json_rpc.datetime.DateTime_3_0_0.Cfg_Codec.decode(result.getJSONObject("cfg"), agent);
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public SetCfgResult setCfg(final com.raritan.idl.datetime.DateTime_3_0_0.Cfg cfg) throws Exception {
    JSONObject params = new JSONObject();
    params.put("cfg", com.raritan.json_rpc.datetime.DateTime_3_0_0.Cfg_Codec.encode(cfg));
    final JSONObject result = rpcCall("setCfg", params);
    SetCfgResult ret = new SetCfgResult();
    ret._ret_ = result.getInt("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest setCfg(final com.raritan.idl.datetime.DateTime_3_0_0.Cfg cfg, final AsyncRpcResponse<SetCfgResult> rsp) {
    return setCfg(cfg, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest setCfg(final com.raritan.idl.datetime.DateTime_3_0_0.Cfg cfg, final AsyncRpcResponse<SetCfgResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("cfg", com.raritan.json_rpc.datetime.DateTime_3_0_0.Cfg_Codec.encode(cfg));
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("setCfg", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          SetCfgResult ret = new SetCfgResult();
          ret._ret_ = result.getInt("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetTimeResult getTime(final boolean useOlson) throws Exception {
    JSONObject params = new JSONObject();
    params.put("useOlson", useOlson);
    final JSONObject result = rpcCall("getTime", params);
    GetTimeResult ret = new GetTimeResult();
    ret.zone = com.raritan.json_rpc.datetime.DateTime_3_0_0.ZoneInfo_Codec.decode(result.getJSONObject("zone"), agent);
    ret.dstEnabled = result.getBoolean("dstEnabled");
    ret.utcOffset = result.getInt("utcOffset");
    ret.currentTime = new java.util.Date(((long) result.getInt("currentTime")) * 1000);
    return ret;
  }

  @Override
  public AsyncRequest getTime(final boolean useOlson, final AsyncRpcResponse<GetTimeResult> rsp) {
    return getTime(useOlson, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getTime(final boolean useOlson, final AsyncRpcResponse<GetTimeResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("useOlson", useOlson);
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("getTime", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetTimeResult ret = new GetTimeResult();
          ret.zone = com.raritan.json_rpc.datetime.DateTime_3_0_0.ZoneInfo_Codec.decode(result.getJSONObject("zone"), agent);
          ret.dstEnabled = result.getBoolean("dstEnabled");
          ret.utcOffset = result.getInt("utcOffset");
          ret.currentTime = new java.util.Date(((long) result.getInt("currentTime")) * 1000);
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }
}
