// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from DisplayControl.idl.

package com.raritan.json_rpc.display;

import org.json.*;

import com.raritan.idl.*;
import com.raritan.json_rpc.*;
import com.raritan.util.AsyncRequest;

public class DisplayControl_Proxy extends ObjectProxy implements com.raritan.idl.display.DisplayControl {

  public DisplayControl_Proxy(Agent agent, String rid, TypeInfo typeInfo) {
    super(agent, rid, typeInfo);
  }

  public DisplayControl_Proxy(Agent agent, String rid) {
    this(agent, rid, com.raritan.idl.display.DisplayControl.typeInfo);
  }

  public static DisplayControl_Proxy staticCast(ObjectProxy proxy) {
    return proxy == null ? null : new DisplayControl_Proxy(proxy.getAgent(), proxy.getRid(), proxy.getStaticTypeInfo());
  }


  @Override
  public GetAvailableDefaultViewsResult getAvailableDefaultViews() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getAvailableDefaultViews", params);
    GetAvailableDefaultViewsResult ret = new GetAvailableDefaultViewsResult();
    ret._ret_ = new java.util.ArrayList<com.raritan.idl.display.DisplayControl.DefaultViewItem>() {
      private static final long serialVersionUID = 1L;
      {
        final JSONArray array0 = result.getJSONArray("_ret_");
        for (int i0 = 0; i0 < array0.length(); i0++) {
          final int i0_f = i0;
          this.add(com.raritan.json_rpc.display.DisplayControl.DefaultViewItem_Codec.decode(array0.getJSONObject(i0_f), agent));
        }
      }
    };
    return ret;
  }

  @Override
  public AsyncRequest getAvailableDefaultViews(final AsyncRpcResponse<GetAvailableDefaultViewsResult> rsp) {
    return getAvailableDefaultViews(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getAvailableDefaultViews(final AsyncRpcResponse<GetAvailableDefaultViewsResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getAvailableDefaultViews", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetAvailableDefaultViewsResult ret = new GetAvailableDefaultViewsResult();
          ret._ret_ = new java.util.ArrayList<com.raritan.idl.display.DisplayControl.DefaultViewItem>() {
            private static final long serialVersionUID = 1L;
            {
              final JSONArray array0 = result.getJSONArray("_ret_");
              for (int i0 = 0; i0 < array0.length(); i0++) {
                final int i0_f = i0;
                this.add(com.raritan.json_rpc.display.DisplayControl.DefaultViewItem_Codec.decode(array0.getJSONObject(i0_f), agent));
              }
            }
          };
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetDefaultViewResult getDefaultView() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getDefaultView", params);
    GetDefaultViewResult ret = new GetDefaultViewResult();
    ret._ret_ = result.getString("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest getDefaultView(final AsyncRpcResponse<GetDefaultViewResult> rsp) {
    return getDefaultView(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getDefaultView(final AsyncRpcResponse<GetDefaultViewResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getDefaultView", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetDefaultViewResult ret = new GetDefaultViewResult();
          ret._ret_ = result.getString("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public SetDefaultViewResult setDefaultView(final String id) throws Exception {
    JSONObject params = new JSONObject();
    params.put("id", id);
    final JSONObject result = rpcCall("setDefaultView", params);
    SetDefaultViewResult ret = new SetDefaultViewResult();
    ret._ret_ = result.getInt("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest setDefaultView(final String id, final AsyncRpcResponse<SetDefaultViewResult> rsp) {
    return setDefaultView(id, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest setDefaultView(final String id, final AsyncRpcResponse<SetDefaultViewResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("id", id);
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("setDefaultView", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          SetDefaultViewResult ret = new SetDefaultViewResult();
          ret._ret_ = result.getInt("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }
}
