// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from DataPushService.idl.

package com.raritan.json_rpc.event;

import org.json.*;

import com.raritan.idl.*;
import com.raritan.json_rpc.*;
import com.raritan.util.AsyncRequest;

public class DataPushService_1_0_2_Proxy extends ObjectProxy implements com.raritan.idl.event.DataPushService_1_0_2 {

  public DataPushService_1_0_2_Proxy(Agent agent, String rid, TypeInfo typeInfo) {
    super(agent, rid, typeInfo);
  }

  public DataPushService_1_0_2_Proxy(Agent agent, String rid) {
    this(agent, rid, com.raritan.idl.event.DataPushService_1_0_2.typeInfo);
  }

  public static DataPushService_1_0_2_Proxy staticCast(ObjectProxy proxy) {
    return proxy == null ? null : new DataPushService_1_0_2_Proxy(proxy.getAgent(), proxy.getRid(), proxy.getStaticTypeInfo());
  }


  @Override
  public AddEntryResult addEntry(final com.raritan.idl.event.DataPushService_1_0_2.EntrySettings entrySettings) throws Exception {
    JSONObject params = new JSONObject();
    params.put("entrySettings", com.raritan.json_rpc.event.DataPushService_1_0_2.EntrySettings_Codec.encode(entrySettings));
    final JSONObject result = rpcCall("addEntry", params);
    AddEntryResult ret = new AddEntryResult();
    ret._ret_ = result.getInt("_ret_");
    ret.entryId = result.getInt("entryId");
    return ret;
  }

  @Override
  public AsyncRequest addEntry(final com.raritan.idl.event.DataPushService_1_0_2.EntrySettings entrySettings, final AsyncRpcResponse<AddEntryResult> rsp) {
    return addEntry(entrySettings, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest addEntry(final com.raritan.idl.event.DataPushService_1_0_2.EntrySettings entrySettings, final AsyncRpcResponse<AddEntryResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("entrySettings", com.raritan.json_rpc.event.DataPushService_1_0_2.EntrySettings_Codec.encode(entrySettings));
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("addEntry", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          AddEntryResult ret = new AddEntryResult();
          ret._ret_ = result.getInt("_ret_");
          ret.entryId = result.getInt("entryId");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public ModifyEntryResult modifyEntry(final int entryId, final com.raritan.idl.event.DataPushService_1_0_2.EntrySettings entrySettings) throws Exception {
    JSONObject params = new JSONObject();
    params.put("entryId", entryId);
    params.put("entrySettings", com.raritan.json_rpc.event.DataPushService_1_0_2.EntrySettings_Codec.encode(entrySettings));
    final JSONObject result = rpcCall("modifyEntry", params);
    ModifyEntryResult ret = new ModifyEntryResult();
    ret._ret_ = result.getInt("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest modifyEntry(final int entryId, final com.raritan.idl.event.DataPushService_1_0_2.EntrySettings entrySettings, final AsyncRpcResponse<ModifyEntryResult> rsp) {
    return modifyEntry(entryId, entrySettings, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest modifyEntry(final int entryId, final com.raritan.idl.event.DataPushService_1_0_2.EntrySettings entrySettings, final AsyncRpcResponse<ModifyEntryResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("entryId", entryId);
      params.put("entrySettings", com.raritan.json_rpc.event.DataPushService_1_0_2.EntrySettings_Codec.encode(entrySettings));
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("modifyEntry", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          ModifyEntryResult ret = new ModifyEntryResult();
          ret._ret_ = result.getInt("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public DeleteEntryResult deleteEntry(final int entryId) throws Exception {
    JSONObject params = new JSONObject();
    params.put("entryId", entryId);
    final JSONObject result = rpcCall("deleteEntry", params);
    DeleteEntryResult ret = new DeleteEntryResult();
    ret._ret_ = result.getInt("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest deleteEntry(final int entryId, final AsyncRpcResponse<DeleteEntryResult> rsp) {
    return deleteEntry(entryId, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest deleteEntry(final int entryId, final AsyncRpcResponse<DeleteEntryResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("entryId", entryId);
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("deleteEntry", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          DeleteEntryResult ret = new DeleteEntryResult();
          ret._ret_ = result.getInt("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetEntryResult getEntry(final int entryId) throws Exception {
    JSONObject params = new JSONObject();
    params.put("entryId", entryId);
    final JSONObject result = rpcCall("getEntry", params);
    GetEntryResult ret = new GetEntryResult();
    ret._ret_ = result.getInt("_ret_");
    ret.entrySettings = com.raritan.json_rpc.event.DataPushService_1_0_2.EntrySettings_Codec.decode(result.getJSONObject("entrySettings"), agent);
    return ret;
  }

  @Override
  public AsyncRequest getEntry(final int entryId, final AsyncRpcResponse<GetEntryResult> rsp) {
    return getEntry(entryId, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getEntry(final int entryId, final AsyncRpcResponse<GetEntryResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("entryId", entryId);
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("getEntry", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetEntryResult ret = new GetEntryResult();
          ret._ret_ = result.getInt("_ret_");
          ret.entrySettings = com.raritan.json_rpc.event.DataPushService_1_0_2.EntrySettings_Codec.decode(result.getJSONObject("entrySettings"), agent);
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public ListEntriesResult listEntries() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("listEntries", params);
    ListEntriesResult ret = new ListEntriesResult();
    ret._ret_ = new java.util.HashMap<Integer, com.raritan.idl.event.DataPushService_1_0_2.EntrySettings>() {{
      final JSONArray array0 = result.getJSONArray("_ret_");
      for (int i0 = 0; i0 < array0.length(); i0++) {
        JSONObject elem0 = array0.getJSONObject(i0);
        final Integer key0 = elem0.getInt("key");
        final com.raritan.idl.event.DataPushService_1_0_2.EntrySettings value0 = com.raritan.json_rpc.event.DataPushService_1_0_2.EntrySettings_Codec.decode(elem0.getJSONObject("value"), agent);
        this.put(key0, value0);
      }
    }};
    return ret;
  }

  @Override
  public AsyncRequest listEntries(final AsyncRpcResponse<ListEntriesResult> rsp) {
    return listEntries(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest listEntries(final AsyncRpcResponse<ListEntriesResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("listEntries", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          ListEntriesResult ret = new ListEntriesResult();
          ret._ret_ = new java.util.HashMap<Integer, com.raritan.idl.event.DataPushService_1_0_2.EntrySettings>() {{
            final JSONArray array0 = result.getJSONArray("_ret_");
            for (int i0 = 0; i0 < array0.length(); i0++) {
              JSONObject elem0 = array0.getJSONObject(i0);
              final Integer key0 = elem0.getInt("key");
              final com.raritan.idl.event.DataPushService_1_0_2.EntrySettings value0 = com.raritan.json_rpc.event.DataPushService_1_0_2.EntrySettings_Codec.decode(elem0.getJSONObject("value"), agent);
              this.put(key0, value0);
            }
          }};
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public PushDataResult pushData(final int entryId) throws Exception {
    JSONObject params = new JSONObject();
    params.put("entryId", entryId);
    final JSONObject result = rpcCall("pushData", params);
    PushDataResult ret = new PushDataResult();
    ret._ret_ = result.getInt("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest pushData(final int entryId, final AsyncRpcResponse<PushDataResult> rsp) {
    return pushData(entryId, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest pushData(final int entryId, final AsyncRpcResponse<PushDataResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("entryId", entryId);
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("pushData", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          PushDataResult ret = new PushDataResult();
          ret._ret_ = result.getInt("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public Void cancelDataPush(final int entryId) throws Exception {
    JSONObject params = new JSONObject();
    params.put("entryId", entryId);
    rpcCall("cancelDataPush", params);
    Void ret = null;
    return ret;
  }

  @Override
  public AsyncRequest cancelDataPush(final int entryId, final AsyncRpcResponse<Void> rsp) {
    return cancelDataPush(entryId, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest cancelDataPush(final int entryId, final AsyncRpcResponse<Void> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("entryId", entryId);
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("cancelDataPush", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          Void ret = null;
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetEntryStatusResult getEntryStatus(final int entryId) throws Exception {
    JSONObject params = new JSONObject();
    params.put("entryId", entryId);
    final JSONObject result = rpcCall("getEntryStatus", params);
    GetEntryStatusResult ret = new GetEntryStatusResult();
    ret._ret_ = result.getInt("_ret_");
    ret.entryStatus = com.raritan.json_rpc.event.DataPushService_1_0_2.EntryStatus_Codec.decode(result.getJSONObject("entryStatus"), agent);
    return ret;
  }

  @Override
  public AsyncRequest getEntryStatus(final int entryId, final AsyncRpcResponse<GetEntryStatusResult> rsp) {
    return getEntryStatus(entryId, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getEntryStatus(final int entryId, final AsyncRpcResponse<GetEntryStatusResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("entryId", entryId);
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("getEntryStatus", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetEntryStatusResult ret = new GetEntryStatusResult();
          ret._ret_ = result.getInt("_ret_");
          ret.entryStatus = com.raritan.json_rpc.event.DataPushService_1_0_2.EntryStatus_Codec.decode(result.getJSONObject("entryStatus"), agent);
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }
}
