// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from EventService.idl.

package com.raritan.json_rpc.event;

import org.json.*;

import com.raritan.idl.*;
import com.raritan.json_rpc.*;
import com.raritan.util.AsyncRequest;

public class Service_1_0_1_Proxy extends ObjectProxy implements com.raritan.idl.event.Service_1_0_1 {

  public Service_1_0_1_Proxy(Agent agent, String rid, TypeInfo typeInfo) {
    super(agent, rid, typeInfo);
  }

  public Service_1_0_1_Proxy(Agent agent, String rid) {
    this(agent, rid, com.raritan.idl.event.Service_1_0_1.typeInfo);
  }

  public static Service_1_0_1_Proxy staticCast(ObjectProxy proxy) {
    return proxy == null ? null : new Service_1_0_1_Proxy(proxy.getAgent(), proxy.getRid(), proxy.getStaticTypeInfo());
  }


  @Override
  public CreateChannelResult createChannel() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("createChannel", params);
    CreateChannelResult ret = new CreateChannelResult();
    ret._ret_ = com.raritan.json_rpc.event.Channel_1_0_1_Proxy.staticCast(ObjectProxy.decode((result.isNull("_ret_") ? null : result.getJSONObject("_ret_")), agent));
    return ret;
  }

  @Override
  public AsyncRequest createChannel(final AsyncRpcResponse<CreateChannelResult> rsp) {
    return createChannel(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest createChannel(final AsyncRpcResponse<CreateChannelResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("createChannel", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          CreateChannelResult ret = new CreateChannelResult();
          ret._ret_ = com.raritan.json_rpc.event.Channel_1_0_1_Proxy.staticCast(ObjectProxy.decode((result.isNull("_ret_") ? null : result.getJSONObject("_ret_")), agent));
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public DestroyChannelResult destroyChannel(final com.raritan.idl.event.Channel_1_0_1 channel) throws Exception {
    JSONObject params = new JSONObject();
    params.put("channel", channel != null ? ((ObjectProxy) channel).encode() : JSONObject.NULL);
    final JSONObject result = rpcCall("destroyChannel", params);
    DestroyChannelResult ret = new DestroyChannelResult();
    ret._ret_ = result.getInt("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest destroyChannel(final com.raritan.idl.event.Channel_1_0_1 channel, final AsyncRpcResponse<DestroyChannelResult> rsp) {
    return destroyChannel(channel, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest destroyChannel(final com.raritan.idl.event.Channel_1_0_1 channel, final AsyncRpcResponse<DestroyChannelResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("channel", channel != null ? ((ObjectProxy) channel).encode() : JSONObject.NULL);
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("destroyChannel", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          DestroyChannelResult ret = new DestroyChannelResult();
          ret._ret_ = result.getInt("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public Void pushEvent(final com.raritan.idl.idl.Event event) throws Exception {
    JSONObject params = new JSONObject();
    params.put("event", ValueObjectCodec.encode(event));
    rpcCall("pushEvent", params);
    Void ret = null;
    return ret;
  }

  @Override
  public AsyncRequest pushEvent(final com.raritan.idl.idl.Event event, final AsyncRpcResponse<Void> rsp) {
    return pushEvent(event, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest pushEvent(final com.raritan.idl.idl.Event event, final AsyncRpcResponse<Void> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("event", ValueObjectCodec.encode(event));
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("pushEvent", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          Void ret = null;
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public Void pushEvents(final java.util.List<com.raritan.idl.idl.Event> events) throws Exception {
    JSONObject params = new JSONObject();
    params.put("events", new JSONArray() {{
      final java.util.List<com.raritan.idl.idl.Event> array0 = events;
      for (int i0 = 0; i0 < array0.size(); i0++) {
        final int i0_f = i0;
        this.put(ValueObjectCodec.encode(array0.get(i0_f)));
      }
    }});
    rpcCall("pushEvents", params);
    Void ret = null;
    return ret;
  }

  @Override
  public AsyncRequest pushEvents(final java.util.List<com.raritan.idl.idl.Event> events, final AsyncRpcResponse<Void> rsp) {
    return pushEvents(events, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest pushEvents(final java.util.List<com.raritan.idl.idl.Event> events, final AsyncRpcResponse<Void> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("events", new JSONArray() {{
        final java.util.List<com.raritan.idl.idl.Event> array0 = events;
        for (int i0 = 0; i0 < array0.size(); i0++) {
          final int i0_f = i0;
          this.put(ValueObjectCodec.encode(array0.get(i0_f)));
        }
      }});
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("pushEvents", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          Void ret = null;
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }
}
