// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from TimerEventManager.idl.

package com.raritan.json_rpc.event;

import org.json.*;

import com.raritan.idl.*;
import com.raritan.json_rpc.*;
import com.raritan.util.AsyncRequest;

public class TimerEventManager_Proxy extends ObjectProxy implements com.raritan.idl.event.TimerEventManager {

  public TimerEventManager_Proxy(Agent agent, String rid, TypeInfo typeInfo) {
    super(agent, rid, typeInfo);
  }

  public TimerEventManager_Proxy(Agent agent, String rid) {
    this(agent, rid, com.raritan.idl.event.TimerEventManager.typeInfo);
  }

  public static TimerEventManager_Proxy staticCast(ObjectProxy proxy) {
    return proxy == null ? null : new TimerEventManager_Proxy(proxy.getAgent(), proxy.getRid(), proxy.getStaticTypeInfo());
  }


  @Override
  public AddTimerEventResult addTimerEvent(final com.raritan.idl.event.TimerEventManager.Schedule schedule) throws Exception {
    JSONObject params = new JSONObject();
    params.put("schedule", com.raritan.json_rpc.event.TimerEventManager.Schedule_Codec.encode(schedule));
    final JSONObject result = rpcCall("addTimerEvent", params);
    AddTimerEventResult ret = new AddTimerEventResult();
    ret._ret_ = result.getInt("_ret_");
    ret.eventId = new java.util.ArrayList<String>() {
      private static final long serialVersionUID = 1L;
      {
        final JSONArray array0 = result.getJSONArray("eventId");
        for (int i0 = 0; i0 < array0.length(); i0++) {
          final int i0_f = i0;
          this.add(array0.getString(i0_f));
        }
      }
    };
    return ret;
  }

  @Override
  public AsyncRequest addTimerEvent(final com.raritan.idl.event.TimerEventManager.Schedule schedule, final AsyncRpcResponse<AddTimerEventResult> rsp) {
    return addTimerEvent(schedule, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest addTimerEvent(final com.raritan.idl.event.TimerEventManager.Schedule schedule, final AsyncRpcResponse<AddTimerEventResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("schedule", com.raritan.json_rpc.event.TimerEventManager.Schedule_Codec.encode(schedule));
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("addTimerEvent", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          AddTimerEventResult ret = new AddTimerEventResult();
          ret._ret_ = result.getInt("_ret_");
          ret.eventId = new java.util.ArrayList<String>() {
            private static final long serialVersionUID = 1L;
            {
              final JSONArray array0 = result.getJSONArray("eventId");
              for (int i0 = 0; i0 < array0.length(); i0++) {
                final int i0_f = i0;
                this.add(array0.getString(i0_f));
              }
            }
          };
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public ModifyTimerEventResult modifyTimerEvent(final java.util.List<String> eventId, final com.raritan.idl.event.TimerEventManager.Schedule schedule) throws Exception {
    JSONObject params = new JSONObject();
    params.put("eventId", new JSONArray() {{
      final java.util.List<String> array0 = eventId;
      for (int i0 = 0; i0 < array0.size(); i0++) {
        final int i0_f = i0;
        this.put(array0.get(i0_f));
      }
    }});
    params.put("schedule", com.raritan.json_rpc.event.TimerEventManager.Schedule_Codec.encode(schedule));
    final JSONObject result = rpcCall("modifyTimerEvent", params);
    ModifyTimerEventResult ret = new ModifyTimerEventResult();
    ret._ret_ = result.getInt("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest modifyTimerEvent(final java.util.List<String> eventId, final com.raritan.idl.event.TimerEventManager.Schedule schedule, final AsyncRpcResponse<ModifyTimerEventResult> rsp) {
    return modifyTimerEvent(eventId, schedule, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest modifyTimerEvent(final java.util.List<String> eventId, final com.raritan.idl.event.TimerEventManager.Schedule schedule, final AsyncRpcResponse<ModifyTimerEventResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("eventId", new JSONArray() {{
        final java.util.List<String> array0 = eventId;
        for (int i0 = 0; i0 < array0.size(); i0++) {
          final int i0_f = i0;
          this.put(array0.get(i0_f));
        }
      }});
      params.put("schedule", com.raritan.json_rpc.event.TimerEventManager.Schedule_Codec.encode(schedule));
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("modifyTimerEvent", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          ModifyTimerEventResult ret = new ModifyTimerEventResult();
          ret._ret_ = result.getInt("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public DeleteTimerEventResult deleteTimerEvent(final java.util.List<String> eventId) throws Exception {
    JSONObject params = new JSONObject();
    params.put("eventId", new JSONArray() {{
      final java.util.List<String> array0 = eventId;
      for (int i0 = 0; i0 < array0.size(); i0++) {
        final int i0_f = i0;
        this.put(array0.get(i0_f));
      }
    }});
    final JSONObject result = rpcCall("deleteTimerEvent", params);
    DeleteTimerEventResult ret = new DeleteTimerEventResult();
    ret._ret_ = result.getInt("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest deleteTimerEvent(final java.util.List<String> eventId, final AsyncRpcResponse<DeleteTimerEventResult> rsp) {
    return deleteTimerEvent(eventId, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest deleteTimerEvent(final java.util.List<String> eventId, final AsyncRpcResponse<DeleteTimerEventResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("eventId", new JSONArray() {{
        final java.util.List<String> array0 = eventId;
        for (int i0 = 0; i0 < array0.size(); i0++) {
          final int i0_f = i0;
          this.put(array0.get(i0_f));
        }
      }});
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("deleteTimerEvent", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          DeleteTimerEventResult ret = new DeleteTimerEventResult();
          ret._ret_ = result.getInt("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public ListTimerEventsResult listTimerEvents() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("listTimerEvents", params);
    ListTimerEventsResult ret = new ListTimerEventsResult();
    ret._ret_ = new java.util.ArrayList<com.raritan.idl.event.TimerEventManager.TimerEvent>() {
      private static final long serialVersionUID = 1L;
      {
        final JSONArray array0 = result.getJSONArray("_ret_");
        for (int i0 = 0; i0 < array0.length(); i0++) {
          final int i0_f = i0;
          this.add(com.raritan.json_rpc.event.TimerEventManager.TimerEvent_Codec.decode(array0.getJSONObject(i0_f), agent));
        }
      }
    };
    return ret;
  }

  @Override
  public AsyncRequest listTimerEvents(final AsyncRpcResponse<ListTimerEventsResult> rsp) {
    return listTimerEvents(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest listTimerEvents(final AsyncRpcResponse<ListTimerEventsResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("listTimerEvents", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          ListTimerEventsResult ret = new ListTimerEventsResult();
          ret._ret_ = new java.util.ArrayList<com.raritan.idl.event.TimerEventManager.TimerEvent>() {
            private static final long serialVersionUID = 1L;
            {
              final JSONArray array0 = result.getJSONArray("_ret_");
              for (int i0 = 0; i0 < array0.length(); i0++) {
                final int i0_f = i0;
                this.add(com.raritan.json_rpc.event.TimerEventManager.TimerEvent_Codec.decode(array0.getJSONObject(i0_f), agent));
              }
            }
          };
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }
}
