// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from Fitness.idl.

package com.raritan.json_rpc.fitness;

import org.json.*;

import com.raritan.idl.*;
import com.raritan.json_rpc.*;
import com.raritan.util.AsyncRequest;

public class Fitness_Proxy extends ObjectProxy implements com.raritan.idl.fitness.Fitness {

  public Fitness_Proxy(Agent agent, String rid, TypeInfo typeInfo) {
    super(agent, rid, typeInfo);
  }

  public Fitness_Proxy(Agent agent, String rid) {
    this(agent, rid, com.raritan.idl.fitness.Fitness.typeInfo);
  }

  public static Fitness_Proxy staticCast(ObjectProxy proxy) {
    return proxy == null ? null : new Fitness_Proxy(proxy.getAgent(), proxy.getRid(), proxy.getStaticTypeInfo());
  }


  @Override
  public GetDataEntriesResult getDataEntries() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getDataEntries", params);
    GetDataEntriesResult ret = new GetDataEntriesResult();
    ret._ret_ = new java.util.ArrayList<com.raritan.idl.fitness.Fitness.DataEntry>() {
      private static final long serialVersionUID = 1L;
      {
        final JSONArray array0 = result.getJSONArray("_ret_");
        for (int i0 = 0; i0 < array0.length(); i0++) {
          final int i0_f = i0;
          this.add(com.raritan.json_rpc.fitness.Fitness.DataEntry_Codec.decode(array0.getJSONObject(i0_f), agent));
        }
      }
    };
    return ret;
  }

  @Override
  public AsyncRequest getDataEntries(final AsyncRpcResponse<GetDataEntriesResult> rsp) {
    return getDataEntries(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getDataEntries(final AsyncRpcResponse<GetDataEntriesResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getDataEntries", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetDataEntriesResult ret = new GetDataEntriesResult();
          ret._ret_ = new java.util.ArrayList<com.raritan.idl.fitness.Fitness.DataEntry>() {
            private static final long serialVersionUID = 1L;
            {
              final JSONArray array0 = result.getJSONArray("_ret_");
              for (int i0 = 0; i0 < array0.length(); i0++) {
                final int i0_f = i0;
                this.add(com.raritan.json_rpc.fitness.Fitness.DataEntry_Codec.decode(array0.getJSONObject(i0_f), agent));
              }
            }
          };
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetErrorLogIndexRangeResult getErrorLogIndexRange() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getErrorLogIndexRange", params);
    GetErrorLogIndexRangeResult ret = new GetErrorLogIndexRangeResult();
    ret.firstIndex = result.getInt("firstIndex");
    ret.entryCount = result.getInt("entryCount");
    return ret;
  }

  @Override
  public AsyncRequest getErrorLogIndexRange(final AsyncRpcResponse<GetErrorLogIndexRangeResult> rsp) {
    return getErrorLogIndexRange(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getErrorLogIndexRange(final AsyncRpcResponse<GetErrorLogIndexRangeResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getErrorLogIndexRange", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetErrorLogIndexRangeResult ret = new GetErrorLogIndexRangeResult();
          ret.firstIndex = result.getInt("firstIndex");
          ret.entryCount = result.getInt("entryCount");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetErrorLogEntriesResult getErrorLogEntries(final int startIndex, final int count) throws Exception {
    JSONObject params = new JSONObject();
    params.put("startIndex", startIndex);
    params.put("count", count);
    final JSONObject result = rpcCall("getErrorLogEntries", params);
    GetErrorLogEntriesResult ret = new GetErrorLogEntriesResult();
    ret._ret_ = new java.util.ArrayList<com.raritan.idl.fitness.Fitness.ErrorLogEntry>() {
      private static final long serialVersionUID = 1L;
      {
        final JSONArray array0 = result.getJSONArray("_ret_");
        for (int i0 = 0; i0 < array0.length(); i0++) {
          final int i0_f = i0;
          this.add(com.raritan.json_rpc.fitness.Fitness.ErrorLogEntry_Codec.decode(array0.getJSONObject(i0_f), agent));
        }
      }
    };
    return ret;
  }

  @Override
  public AsyncRequest getErrorLogEntries(final int startIndex, final int count, final AsyncRpcResponse<GetErrorLogEntriesResult> rsp) {
    return getErrorLogEntries(startIndex, count, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getErrorLogEntries(final int startIndex, final int count, final AsyncRpcResponse<GetErrorLogEntriesResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("startIndex", startIndex);
      params.put("count", count);
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("getErrorLogEntries", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetErrorLogEntriesResult ret = new GetErrorLogEntriesResult();
          ret._ret_ = new java.util.ArrayList<com.raritan.idl.fitness.Fitness.ErrorLogEntry>() {
            private static final long serialVersionUID = 1L;
            {
              final JSONArray array0 = result.getJSONArray("_ret_");
              for (int i0 = 0; i0 < array0.length(); i0++) {
                final int i0_f = i0;
                this.add(com.raritan.json_rpc.fitness.Fitness.ErrorLogEntry_Codec.decode(array0.getJSONObject(i0_f), agent));
              }
            }
          };
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }
}
