// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from Lhx.idl.

package com.raritan.json_rpc.lhxmodel;

import org.json.*;

import com.raritan.idl.*;
import com.raritan.json_rpc.*;
import com.raritan.util.AsyncRequest;

public class Lhx_Proxy extends ObjectProxy implements com.raritan.idl.lhxmodel.Lhx {

  public Lhx_Proxy(Agent agent, String rid, TypeInfo typeInfo) {
    super(agent, rid, typeInfo);
  }

  public Lhx_Proxy(Agent agent, String rid) {
    this(agent, rid, com.raritan.idl.lhxmodel.Lhx.typeInfo);
  }

  public static Lhx_Proxy staticCast(ObjectProxy proxy) {
    return proxy == null ? null : new Lhx_Proxy(proxy.getAgent(), proxy.getRid(), proxy.getStaticTypeInfo());
  }


  @Override
  public GetMetaDataResult getMetaData() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getMetaData", params);
    GetMetaDataResult ret = new GetMetaDataResult();
    ret._ret_ = com.raritan.json_rpc.lhxmodel.Lhx.MetaData_Codec.decode(result.getJSONObject("_ret_"), agent);
    return ret;
  }

  @Override
  public AsyncRequest getMetaData(final AsyncRpcResponse<GetMetaDataResult> rsp) {
    return getMetaData(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getMetaData(final AsyncRpcResponse<GetMetaDataResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getMetaData", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetMetaDataResult ret = new GetMetaDataResult();
          ret._ret_ = com.raritan.json_rpc.lhxmodel.Lhx.MetaData_Codec.decode(result.getJSONObject("_ret_"), agent);
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetSettingsResult getSettings() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getSettings", params);
    GetSettingsResult ret = new GetSettingsResult();
    ret._ret_ = com.raritan.json_rpc.lhxmodel.Lhx.Settings_Codec.decode(result.getJSONObject("_ret_"), agent);
    return ret;
  }

  @Override
  public AsyncRequest getSettings(final AsyncRpcResponse<GetSettingsResult> rsp) {
    return getSettings(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getSettings(final AsyncRpcResponse<GetSettingsResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getSettings", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetSettingsResult ret = new GetSettingsResult();
          ret._ret_ = com.raritan.json_rpc.lhxmodel.Lhx.Settings_Codec.decode(result.getJSONObject("_ret_"), agent);
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public SetSettingsResult setSettings(final com.raritan.idl.lhxmodel.Lhx.Settings settings) throws Exception {
    JSONObject params = new JSONObject();
    params.put("settings", com.raritan.json_rpc.lhxmodel.Lhx.Settings_Codec.encode(settings));
    final JSONObject result = rpcCall("setSettings", params);
    SetSettingsResult ret = new SetSettingsResult();
    ret._ret_ = result.getInt("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest setSettings(final com.raritan.idl.lhxmodel.Lhx.Settings settings, final AsyncRpcResponse<SetSettingsResult> rsp) {
    return setSettings(settings, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest setSettings(final com.raritan.idl.lhxmodel.Lhx.Settings settings, final AsyncRpcResponse<SetSettingsResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("settings", com.raritan.json_rpc.lhxmodel.Lhx.Settings_Codec.encode(settings));
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("setSettings", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          SetSettingsResult ret = new SetSettingsResult();
          ret._ret_ = result.getInt("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetSensorsResult getSensors() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getSensors", params);
    GetSensorsResult ret = new GetSensorsResult();
    ret._ret_ = com.raritan.json_rpc.lhxmodel.Lhx.Sensors_Codec.decode(result.getJSONObject("_ret_"), agent);
    return ret;
  }

  @Override
  public AsyncRequest getSensors(final AsyncRpcResponse<GetSensorsResult> rsp) {
    return getSensors(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getSensors(final AsyncRpcResponse<GetSensorsResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getSensors", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetSensorsResult ret = new GetSensorsResult();
          ret._ret_ = com.raritan.json_rpc.lhxmodel.Lhx.Sensors_Codec.decode(result.getJSONObject("_ret_"), agent);
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetOpStateResult getOpState() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getOpState", params);
    GetOpStateResult ret = new GetOpStateResult();
    ret._ret_ = com.raritan.json_rpc.lhxmodel.Lhx.OpState_Codec.decode(result.getJSONObject("_ret_"), agent);
    return ret;
  }

  @Override
  public AsyncRequest getOpState(final AsyncRpcResponse<GetOpStateResult> rsp) {
    return getOpState(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getOpState(final AsyncRpcResponse<GetOpStateResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getOpState", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetOpStateResult ret = new GetOpStateResult();
          ret._ret_ = com.raritan.json_rpc.lhxmodel.Lhx.OpState_Codec.decode(result.getJSONObject("_ret_"), agent);
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public Void setPowerState(final com.raritan.idl.sensors.Sensor.OnOffState state) throws Exception {
    JSONObject params = new JSONObject();
    params.put("state", com.raritan.json_rpc.sensors.Sensor.OnOffState_Codec.encode(state));
    rpcCall("setPowerState", params);
    Void ret = null;
    return ret;
  }

  @Override
  public AsyncRequest setPowerState(final com.raritan.idl.sensors.Sensor.OnOffState state, final AsyncRpcResponse<Void> rsp) {
    return setPowerState(state, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest setPowerState(final com.raritan.idl.sensors.Sensor.OnOffState state, final AsyncRpcResponse<Void> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("state", com.raritan.json_rpc.sensors.Sensor.OnOffState_Codec.encode(state));
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("setPowerState", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          Void ret = null;
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }
}
