// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from LhxSensor.idl.

package com.raritan.json_rpc.lhxmodel;

import org.json.*;

import com.raritan.idl.*;
import com.raritan.json_rpc.*;
import com.raritan.util.AsyncRequest;

public class Sensor_Proxy extends com.raritan.json_rpc.sensors.Sensor_Proxy implements com.raritan.idl.lhxmodel.Sensor {

  public Sensor_Proxy(Agent agent, String rid, TypeInfo typeInfo) {
    super(agent, rid, typeInfo);
  }

  public Sensor_Proxy(Agent agent, String rid) {
    this(agent, rid, com.raritan.idl.lhxmodel.Sensor.typeInfo);
  }

  public static Sensor_Proxy staticCast(ObjectProxy proxy) {
    return proxy == null ? null : new Sensor_Proxy(proxy.getAgent(), proxy.getRid(), proxy.getStaticTypeInfo());
  }


  @Override
  public GetMetaDataResult getMetaData() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getMetaData", params);
    GetMetaDataResult ret = new GetMetaDataResult();
    ret._ret_ = com.raritan.json_rpc.lhxmodel.Sensor.MetaData_Codec.decode(result.getJSONObject("_ret_"), agent);
    return ret;
  }

  @Override
  public AsyncRequest getMetaData(final AsyncRpcResponse<GetMetaDataResult> rsp) {
    return getMetaData(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getMetaData(final AsyncRpcResponse<GetMetaDataResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getMetaData", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetMetaDataResult ret = new GetMetaDataResult();
          ret._ret_ = com.raritan.json_rpc.lhxmodel.Sensor.MetaData_Codec.decode(result.getJSONObject("_ret_"), agent);
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetThresholdsResult getThresholds() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getThresholds", params);
    GetThresholdsResult ret = new GetThresholdsResult();
    ret._ret_ = com.raritan.json_rpc.lhxmodel.Sensor.NumThresholds_Codec.decode(result.getJSONObject("_ret_"), agent);
    return ret;
  }

  @Override
  public AsyncRequest getThresholds(final AsyncRpcResponse<GetThresholdsResult> rsp) {
    return getThresholds(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getThresholds(final AsyncRpcResponse<GetThresholdsResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getThresholds", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetThresholdsResult ret = new GetThresholdsResult();
          ret._ret_ = com.raritan.json_rpc.lhxmodel.Sensor.NumThresholds_Codec.decode(result.getJSONObject("_ret_"), agent);
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public SetThresholdsResult setThresholds(final com.raritan.idl.lhxmodel.Sensor.NumThresholds thresholds) throws Exception {
    JSONObject params = new JSONObject();
    params.put("thresholds", com.raritan.json_rpc.lhxmodel.Sensor.NumThresholds_Codec.encode(thresholds));
    final JSONObject result = rpcCall("setThresholds", params);
    SetThresholdsResult ret = new SetThresholdsResult();
    ret._ret_ = result.getInt("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest setThresholds(final com.raritan.idl.lhxmodel.Sensor.NumThresholds thresholds, final AsyncRpcResponse<SetThresholdsResult> rsp) {
    return setThresholds(thresholds, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest setThresholds(final com.raritan.idl.lhxmodel.Sensor.NumThresholds thresholds, final AsyncRpcResponse<SetThresholdsResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("thresholds", com.raritan.json_rpc.lhxmodel.Sensor.NumThresholds_Codec.encode(thresholds));
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("setThresholds", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          SetThresholdsResult ret = new SetThresholdsResult();
          ret._ret_ = result.getInt("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetReadingResult getReading() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getReading", params);
    GetReadingResult ret = new GetReadingResult();
    ret._ret_ = com.raritan.json_rpc.lhxmodel.Sensor.Reading_Codec.decode(result.getJSONObject("_ret_"), agent);
    return ret;
  }

  @Override
  public AsyncRequest getReading(final AsyncRpcResponse<GetReadingResult> rsp) {
    return getReading(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getReading(final AsyncRpcResponse<GetReadingResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getReading", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetReadingResult ret = new GetReadingResult();
          ret._ret_ = com.raritan.json_rpc.lhxmodel.Sensor.Reading_Codec.decode(result.getJSONObject("_ret_"), agent);
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }
}
