// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from EventLog.idl.

package com.raritan.json_rpc.logging;

import org.json.*;

import com.raritan.idl.*;
import com.raritan.json_rpc.*;
import com.raritan.util.AsyncRequest;

public class EventLog_2_0_0_Proxy extends ObjectProxy implements com.raritan.idl.logging.EventLog_2_0_0 {

  public EventLog_2_0_0_Proxy(Agent agent, String rid, TypeInfo typeInfo) {
    super(agent, rid, typeInfo);
  }

  public EventLog_2_0_0_Proxy(Agent agent, String rid) {
    this(agent, rid, com.raritan.idl.logging.EventLog_2_0_0.typeInfo);
  }

  public static EventLog_2_0_0_Proxy staticCast(ObjectProxy proxy) {
    return proxy == null ? null : new EventLog_2_0_0_Proxy(proxy.getAgent(), proxy.getRid(), proxy.getStaticTypeInfo());
  }


  @Override
  public Void clear() throws Exception {
    JSONObject params = null;
    rpcCall("clear", params);
    Void ret = null;
    return ret;
  }

  @Override
  public AsyncRequest clear(final AsyncRpcResponse<Void> rsp) {
    return clear(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest clear(final AsyncRpcResponse<Void> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("clear", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          Void ret = null;
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetInfoResult getInfo() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getInfo", params);
    GetInfoResult ret = new GetInfoResult();
    ret._ret_ = com.raritan.json_rpc.logging.LogInfo_Codec.decode(result.getJSONObject("_ret_"), agent);
    return ret;
  }

  @Override
  public AsyncRequest getInfo(final AsyncRpcResponse<GetInfoResult> rsp) {
    return getInfo(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getInfo(final AsyncRpcResponse<GetInfoResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getInfo", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetInfoResult ret = new GetInfoResult();
          ret._ret_ = com.raritan.json_rpc.logging.LogInfo_Codec.decode(result.getJSONObject("_ret_"), agent);
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetChunkResult getChunk(final int refId, final int count, final com.raritan.idl.logging.RangeDirection direction, final java.util.List<String> categories) throws Exception {
    JSONObject params = new JSONObject();
    params.put("refId", refId);
    params.put("count", count);
    params.put("direction", com.raritan.json_rpc.logging.RangeDirection_Codec.encode(direction));
    params.put("categories", new JSONArray() {{
      final java.util.List<String> array0 = categories;
      for (int i0 = 0; i0 < array0.size(); i0++) {
        final int i0_f = i0;
        this.put(array0.get(i0_f));
      }
    }});
    final JSONObject result = rpcCall("getChunk", params);
    GetChunkResult ret = new GetChunkResult();
    ret._ret_ = com.raritan.json_rpc.logging.LogChunk_Codec.decode(result.getJSONObject("_ret_"), agent);
    return ret;
  }

  @Override
  public AsyncRequest getChunk(final int refId, final int count, final com.raritan.idl.logging.RangeDirection direction, final java.util.List<String> categories, final AsyncRpcResponse<GetChunkResult> rsp) {
    return getChunk(refId, count, direction, categories, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getChunk(final int refId, final int count, final com.raritan.idl.logging.RangeDirection direction, final java.util.List<String> categories, final AsyncRpcResponse<GetChunkResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("refId", refId);
      params.put("count", count);
      params.put("direction", com.raritan.json_rpc.logging.RangeDirection_Codec.encode(direction));
      params.put("categories", new JSONArray() {{
        final java.util.List<String> array0 = categories;
        for (int i0 = 0; i0 < array0.size(); i0++) {
          final int i0_f = i0;
          this.put(array0.get(i0_f));
        }
      }});
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("getChunk", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetChunkResult ret = new GetChunkResult();
          ret._ret_ = com.raritan.json_rpc.logging.LogChunk_Codec.decode(result.getJSONObject("_ret_"), agent);
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }
}
