// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from EventLog.idl.

package com.raritan.json_rpc.logging;

import org.json.*;

import com.raritan.idl.*;
import com.raritan.json_rpc.*;
import com.raritan.util.AsyncRequest;

public class EventLog_Proxy extends ObjectProxy implements com.raritan.idl.logging.EventLog {

  public EventLog_Proxy(Agent agent, String rid, TypeInfo typeInfo) {
    super(agent, rid, typeInfo);
  }

  public EventLog_Proxy(Agent agent, String rid) {
    this(agent, rid, com.raritan.idl.logging.EventLog.typeInfo);
  }

  public static EventLog_Proxy staticCast(ObjectProxy proxy) {
    return proxy == null ? null : new EventLog_Proxy(proxy.getAgent(), proxy.getRid(), proxy.getStaticTypeInfo());
  }


  @Override
  public Void clear() throws Exception {
    JSONObject params = null;
    rpcCall("clear", params);
    Void ret = null;
    return ret;
  }

  @Override
  public AsyncRequest clear(final AsyncRpcResponse<Void> rsp) {
    return clear(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest clear(final AsyncRpcResponse<Void> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("clear", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          Void ret = null;
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetFirstIdResult getFirstId() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getFirstId", params);
    GetFirstIdResult ret = new GetFirstIdResult();
    ret._ret_ = result.getInt("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest getFirstId(final AsyncRpcResponse<GetFirstIdResult> rsp) {
    return getFirstId(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getFirstId(final AsyncRpcResponse<GetFirstIdResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getFirstId", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetFirstIdResult ret = new GetFirstIdResult();
          ret._ret_ = result.getInt("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetLastIdResult getLastId() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getLastId", params);
    GetLastIdResult ret = new GetLastIdResult();
    ret._ret_ = result.getInt("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest getLastId(final AsyncRpcResponse<GetLastIdResult> rsp) {
    return getLastId(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getLastId(final AsyncRpcResponse<GetLastIdResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getLastId", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetLastIdResult ret = new GetLastIdResult();
          ret._ret_ = result.getInt("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetEntriesResult getEntries(final int refId, final int count, final com.raritan.idl.logging.RangeDirection direction) throws Exception {
    JSONObject params = new JSONObject();
    params.put("refId", refId);
    params.put("count", count);
    params.put("direction", com.raritan.json_rpc.logging.RangeDirection_Codec.encode(direction));
    final JSONObject result = rpcCall("getEntries", params);
    GetEntriesResult ret = new GetEntriesResult();
    ret.entries = new java.util.ArrayList<com.raritan.idl.logging.LogEntry>() {
      private static final long serialVersionUID = 1L;
      {
        final JSONArray array0 = result.getJSONArray("entries");
        for (int i0 = 0; i0 < array0.length(); i0++) {
          final int i0_f = i0;
          this.add(com.raritan.json_rpc.logging.LogEntry_Codec.decode(array0.getJSONObject(i0_f), agent));
        }
      }
    };
    return ret;
  }

  @Override
  public AsyncRequest getEntries(final int refId, final int count, final com.raritan.idl.logging.RangeDirection direction, final AsyncRpcResponse<GetEntriesResult> rsp) {
    return getEntries(refId, count, direction, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getEntries(final int refId, final int count, final com.raritan.idl.logging.RangeDirection direction, final AsyncRpcResponse<GetEntriesResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("refId", refId);
      params.put("count", count);
      params.put("direction", com.raritan.json_rpc.logging.RangeDirection_Codec.encode(direction));
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("getEntries", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetEntriesResult ret = new GetEntriesResult();
          ret.entries = new java.util.ArrayList<com.raritan.idl.logging.LogEntry>() {
            private static final long serialVersionUID = 1L;
            {
              final JSONArray array0 = result.getJSONArray("entries");
              for (int i0 = 0; i0 < array0.length(); i0++) {
                final int i0_f = i0;
                this.add(com.raritan.json_rpc.logging.LogEntry_Codec.decode(array0.getJSONObject(i0_f), agent));
              }
            }
          };
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }
}
