// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from PortForwardingAutoSetup.idl.

package com.raritan.json_rpc.net;

import org.json.*;

import com.raritan.idl.*;
import com.raritan.json_rpc.*;
import com.raritan.util.AsyncRequest;

public class PortForwardingAutoSetup_Proxy extends ObjectProxy implements com.raritan.idl.net.PortForwardingAutoSetup {

  public PortForwardingAutoSetup_Proxy(Agent agent, String rid, TypeInfo typeInfo) {
    super(agent, rid, typeInfo);
  }

  public PortForwardingAutoSetup_Proxy(Agent agent, String rid) {
    this(agent, rid, com.raritan.idl.net.PortForwardingAutoSetup.typeInfo);
  }

  public static PortForwardingAutoSetup_Proxy staticCast(ObjectProxy proxy) {
    return proxy == null ? null : new PortForwardingAutoSetup_Proxy(proxy.getAgent(), proxy.getRid(), proxy.getStaticTypeInfo());
  }


  @Override
  public StartResult start(final int numberOfExpansionUnits, final String username, final String password, final String newPassword, final boolean disableStrongPasswordReq) throws Exception {
    JSONObject params = new JSONObject();
    params.put("numberOfExpansionUnits", numberOfExpansionUnits);
    params.put("username", username);
    params.put("password", password);
    params.put("newPassword", newPassword);
    params.put("disableStrongPasswordReq", disableStrongPasswordReq);
    final JSONObject result = rpcCall("start", params);
    StartResult ret = new StartResult();
    ret._ret_ = result.getInt("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest start(final int numberOfExpansionUnits, final String username, final String password, final String newPassword, final boolean disableStrongPasswordReq, final AsyncRpcResponse<StartResult> rsp) {
    return start(numberOfExpansionUnits, username, password, newPassword, disableStrongPasswordReq, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest start(final int numberOfExpansionUnits, final String username, final String password, final String newPassword, final boolean disableStrongPasswordReq, final AsyncRpcResponse<StartResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("numberOfExpansionUnits", numberOfExpansionUnits);
      params.put("username", username);
      params.put("password", password);
      params.put("newPassword", newPassword);
      params.put("disableStrongPasswordReq", disableStrongPasswordReq);
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("start", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          StartResult ret = new StartResult();
          ret._ret_ = result.getInt("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetStatusResult getStatus() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getStatus", params);
    GetStatusResult ret = new GetStatusResult();
    ret._ret_ = com.raritan.json_rpc.net.PortForwardingAutoSetupStatus_Codec.decode(result.getJSONObject("_ret_"), agent);
    return ret;
  }

  @Override
  public AsyncRequest getStatus(final AsyncRpcResponse<GetStatusResult> rsp) {
    return getStatus(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getStatus(final AsyncRpcResponse<GetStatusResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getStatus", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetStatusResult ret = new GetStatusResult();
          ret._ret_ = com.raritan.json_rpc.net.PortForwardingAutoSetupStatus_Codec.decode(result.getJSONObject("_ret_"), agent);
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public Void cancel() throws Exception {
    JSONObject params = null;
    rpcCall("cancel", params);
    Void ret = null;
    return ret;
  }

  @Override
  public AsyncRequest cancel(final AsyncRpcResponse<Void> rsp) {
    return cancel(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest cancel(final AsyncRpcResponse<Void> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("cancel", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          Void ret = null;
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }
}
