// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from Ade.idl.

package com.raritan.json_rpc.pdumodel;

import org.json.*;

import com.raritan.idl.*;
import com.raritan.json_rpc.*;
import com.raritan.util.AsyncRequest;

public class Ade_Proxy extends ObjectProxy implements com.raritan.idl.pdumodel.Ade {

  public Ade_Proxy(Agent agent, String rid, TypeInfo typeInfo) {
    super(agent, rid, typeInfo);
  }

  public Ade_Proxy(Agent agent, String rid) {
    this(agent, rid, com.raritan.idl.pdumodel.Ade.typeInfo);
  }

  public static Ade_Proxy staticCast(ObjectProxy proxy) {
    return proxy == null ? null : new Ade_Proxy(proxy.getAgent(), proxy.getRid(), proxy.getStaticTypeInfo());
  }


  @Override
  public GetMetaDataResult getMetaData() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getMetaData", params);
    GetMetaDataResult ret = new GetMetaDataResult();
    ret._ret_ = com.raritan.json_rpc.pdumodel.Ade.MetaData_Codec.decode(result.getJSONObject("_ret_"), agent);
    return ret;
  }

  @Override
  public AsyncRequest getMetaData(final AsyncRpcResponse<GetMetaDataResult> rsp) {
    return getMetaData(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getMetaData(final AsyncRpcResponse<GetMetaDataResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getMetaData", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetMetaDataResult ret = new GetMetaDataResult();
          ret._ret_ = com.raritan.json_rpc.pdumodel.Ade.MetaData_Codec.decode(result.getJSONObject("_ret_"), agent);
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetLatestSampleResult getLatestSample() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getLatestSample", params);
    GetLatestSampleResult ret = new GetLatestSampleResult();
    ret._ret_ = new java.util.ArrayList<com.raritan.idl.pdumodel.Ade.Sample>() {
      private static final long serialVersionUID = 1L;
      {
        final JSONArray array0 = result.getJSONArray("_ret_");
        for (int i0 = 0; i0 < array0.length(); i0++) {
          final int i0_f = i0;
          this.add(com.raritan.json_rpc.pdumodel.Ade.Sample_Codec.decode(array0.getJSONObject(i0_f), agent));
        }
      }
    };
    return ret;
  }

  @Override
  public AsyncRequest getLatestSample(final AsyncRpcResponse<GetLatestSampleResult> rsp) {
    return getLatestSample(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getLatestSample(final AsyncRpcResponse<GetLatestSampleResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getLatestSample", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetLatestSampleResult ret = new GetLatestSampleResult();
          ret._ret_ = new java.util.ArrayList<com.raritan.idl.pdumodel.Ade.Sample>() {
            private static final long serialVersionUID = 1L;
            {
              final JSONArray array0 = result.getJSONArray("_ret_");
              for (int i0 = 0; i0 < array0.length(); i0++) {
                final int i0_f = i0;
                this.add(com.raritan.json_rpc.pdumodel.Ade.Sample_Codec.decode(array0.getJSONObject(i0_f), agent));
              }
            }
          };
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetCalibrationDataResult getCalibrationData() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getCalibrationData", params);
    GetCalibrationDataResult ret = new GetCalibrationDataResult();
    ret._ret_ = new java.util.HashMap<String, Long>() {{
      final JSONArray array0 = result.getJSONArray("_ret_");
      for (int i0 = 0; i0 < array0.length(); i0++) {
        JSONObject elem0 = array0.getJSONObject(i0);
        final String key0 = elem0.getString("key");
        final Long value0 = elem0.getLong("value");
        this.put(key0, value0);
      }
    }};
    return ret;
  }

  @Override
  public AsyncRequest getCalibrationData(final AsyncRpcResponse<GetCalibrationDataResult> rsp) {
    return getCalibrationData(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getCalibrationData(final AsyncRpcResponse<GetCalibrationDataResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getCalibrationData", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetCalibrationDataResult ret = new GetCalibrationDataResult();
          ret._ret_ = new java.util.HashMap<String, Long>() {{
            final JSONArray array0 = result.getJSONArray("_ret_");
            for (int i0 = 0; i0 < array0.length(); i0++) {
              JSONObject elem0 = array0.getJSONObject(i0);
              final String key0 = elem0.getString("key");
              final Long value0 = elem0.getLong("value");
              this.put(key0, value0);
            }
          }};
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public SetCalibrationDataResult setCalibrationData(final java.util.Map<String, Long> regs) throws Exception {
    JSONObject params = new JSONObject();
    params.put("regs", new JSONArray() {{
      java.util.Map<String, Long> map0 = regs;
      for (java.util.Map.Entry<String, Long> entry0 : map0.entrySet()) {
        final java.util.Map.Entry<String, Long> entry0_f = entry0;
        JSONObject elem0 = new JSONObject();
        elem0.put("key", entry0_f.getKey());
        elem0.put("value", entry0_f.getValue());
        this.put(elem0);
      }
    }});
    final JSONObject result = rpcCall("setCalibrationData", params);
    SetCalibrationDataResult ret = new SetCalibrationDataResult();
    ret._ret_ = result.getInt("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest setCalibrationData(final java.util.Map<String, Long> regs, final AsyncRpcResponse<SetCalibrationDataResult> rsp) {
    return setCalibrationData(regs, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest setCalibrationData(final java.util.Map<String, Long> regs, final AsyncRpcResponse<SetCalibrationDataResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("regs", new JSONArray() {{
        java.util.Map<String, Long> map0 = regs;
        for (java.util.Map.Entry<String, Long> entry0 : map0.entrySet()) {
          final java.util.Map.Entry<String, Long> entry0_f = entry0;
          JSONObject elem0 = new JSONObject();
          elem0.put("key", entry0_f.getKey());
          elem0.put("value", entry0_f.getValue());
          this.put(elem0);
        }
      }});
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("setCalibrationData", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          SetCalibrationDataResult ret = new SetCalibrationDataResult();
          ret._ret_ = result.getInt("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }
}
