// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from MemoryMapController.idl.

package com.raritan.json_rpc.pdumodel;

import org.json.*;

import com.raritan.idl.*;
import com.raritan.json_rpc.*;
import com.raritan.util.AsyncRequest;

public class MemoryMapController_3_0_0_Proxy extends com.raritan.json_rpc.pdumodel.Controller_3_0_0_Proxy implements com.raritan.idl.pdumodel.MemoryMapController_3_0_0 {

  public MemoryMapController_3_0_0_Proxy(Agent agent, String rid, TypeInfo typeInfo) {
    super(agent, rid, typeInfo);
  }

  public MemoryMapController_3_0_0_Proxy(Agent agent, String rid) {
    this(agent, rid, com.raritan.idl.pdumodel.MemoryMapController_3_0_0.typeInfo);
  }

  public static MemoryMapController_3_0_0_Proxy staticCast(ObjectProxy proxy) {
    return proxy == null ? null : new MemoryMapController_3_0_0_Proxy(proxy.getAgent(), proxy.getRid(), proxy.getStaticTypeInfo());
  }


  @Override
  public ReadMemoryResult readMemory(final int address, final int size) throws Exception {
    JSONObject params = new JSONObject();
    params.put("address", address);
    params.put("size", size);
    final JSONObject result = rpcCall("readMemory", params);
    ReadMemoryResult ret = new ReadMemoryResult();
    ret._ret_ = result.getInt("_ret_");
    ret.memory = new java.util.ArrayList<Byte>() {
      private static final long serialVersionUID = 1L;
      {
        final JSONArray array0 = result.getJSONArray("memory");
        for (int i0 = 0; i0 < array0.length(); i0++) {
          final int i0_f = i0;
          this.add((byte) array0.getInt(i0_f));
        }
      }
    };
    return ret;
  }

  @Override
  public AsyncRequest readMemory(final int address, final int size, final AsyncRpcResponse<ReadMemoryResult> rsp) {
    return readMemory(address, size, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest readMemory(final int address, final int size, final AsyncRpcResponse<ReadMemoryResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("address", address);
      params.put("size", size);
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("readMemory", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          ReadMemoryResult ret = new ReadMemoryResult();
          ret._ret_ = result.getInt("_ret_");
          ret.memory = new java.util.ArrayList<Byte>() {
            private static final long serialVersionUID = 1L;
            {
              final JSONArray array0 = result.getJSONArray("memory");
              for (int i0 = 0; i0 < array0.length(); i0++) {
                final int i0_f = i0;
                this.add((byte) array0.getInt(i0_f));
              }
            }
          };
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public WriteMemoryResult writeMemory(final int address, final java.util.List<Byte> memory) throws Exception {
    JSONObject params = new JSONObject();
    params.put("address", address);
    params.put("memory", new JSONArray() {{
      final java.util.List<Byte> array0 = memory;
      for (int i0 = 0; i0 < array0.size(); i0++) {
        final int i0_f = i0;
        this.put(array0.get(i0_f));
      }
    }});
    final JSONObject result = rpcCall("writeMemory", params);
    WriteMemoryResult ret = new WriteMemoryResult();
    ret._ret_ = result.getInt("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest writeMemory(final int address, final java.util.List<Byte> memory, final AsyncRpcResponse<WriteMemoryResult> rsp) {
    return writeMemory(address, memory, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest writeMemory(final int address, final java.util.List<Byte> memory, final AsyncRpcResponse<WriteMemoryResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("address", address);
      params.put("memory", new JSONArray() {{
        final java.util.List<Byte> array0 = memory;
        for (int i0 = 0; i0 < array0.size(); i0++) {
          final int i0_f = i0;
          this.put(array0.get(i0_f));
        }
      }});
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("writeMemory", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          WriteMemoryResult ret = new WriteMemoryResult();
          ret._ret_ = result.getInt("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }
}
