// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from OutletGroupManager.idl.

package com.raritan.json_rpc.pdumodel;

import org.json.*;

import com.raritan.idl.*;
import com.raritan.json_rpc.*;
import com.raritan.util.AsyncRequest;

public class OutletGroupManager_Proxy extends ObjectProxy implements com.raritan.idl.pdumodel.OutletGroupManager {

  public OutletGroupManager_Proxy(Agent agent, String rid, TypeInfo typeInfo) {
    super(agent, rid, typeInfo);
  }

  public OutletGroupManager_Proxy(Agent agent, String rid) {
    this(agent, rid, com.raritan.idl.pdumodel.OutletGroupManager.typeInfo);
  }

  public static OutletGroupManager_Proxy staticCast(ObjectProxy proxy) {
    return proxy == null ? null : new OutletGroupManager_Proxy(proxy.getAgent(), proxy.getRid(), proxy.getStaticTypeInfo());
  }


  @Override
  public CreateGroupResult createGroup(final String name, final java.util.List<com.raritan.idl.pdumodel.Outlet_2_1_4> members) throws Exception {
    JSONObject params = new JSONObject();
    params.put("name", name);
    params.put("members", new JSONArray() {{
      final java.util.List<com.raritan.idl.pdumodel.Outlet_2_1_4> array0 = members;
      for (int i0 = 0; i0 < array0.size(); i0++) {
        final int i0_f = i0;
        this.put(array0.get(i0_f) != null ? ((ObjectProxy) array0.get(i0_f)).encode() : JSONObject.NULL);
      }
    }});
    final JSONObject result = rpcCall("createGroup", params);
    CreateGroupResult ret = new CreateGroupResult();
    ret._ret_ = result.getInt("_ret_");
    ret.group = com.raritan.json_rpc.pdumodel.OutletGroup_Proxy.staticCast(ObjectProxy.decode((result.isNull("group") ? null : result.getJSONObject("group")), agent));
    return ret;
  }

  @Override
  public AsyncRequest createGroup(final String name, final java.util.List<com.raritan.idl.pdumodel.Outlet_2_1_4> members, final AsyncRpcResponse<CreateGroupResult> rsp) {
    return createGroup(name, members, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest createGroup(final String name, final java.util.List<com.raritan.idl.pdumodel.Outlet_2_1_4> members, final AsyncRpcResponse<CreateGroupResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("name", name);
      params.put("members", new JSONArray() {{
        final java.util.List<com.raritan.idl.pdumodel.Outlet_2_1_4> array0 = members;
        for (int i0 = 0; i0 < array0.size(); i0++) {
          final int i0_f = i0;
          this.put(array0.get(i0_f) != null ? ((ObjectProxy) array0.get(i0_f)).encode() : JSONObject.NULL);
        }
      }});
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("createGroup", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          CreateGroupResult ret = new CreateGroupResult();
          ret._ret_ = result.getInt("_ret_");
          ret.group = com.raritan.json_rpc.pdumodel.OutletGroup_Proxy.staticCast(ObjectProxy.decode((result.isNull("group") ? null : result.getJSONObject("group")), agent));
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetAllGroupsResult getAllGroups() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getAllGroups", params);
    GetAllGroupsResult ret = new GetAllGroupsResult();
    ret._ret_ = new java.util.HashMap<Integer, com.raritan.idl.pdumodel.OutletGroup>() {{
      final JSONArray array0 = result.getJSONArray("_ret_");
      for (int i0 = 0; i0 < array0.length(); i0++) {
        JSONObject elem0 = array0.getJSONObject(i0);
        final Integer key0 = elem0.getInt("key");
        final com.raritan.idl.pdumodel.OutletGroup value0 = com.raritan.json_rpc.pdumodel.OutletGroup_Proxy.staticCast(ObjectProxy.decode((elem0.isNull("value") ? null : elem0.getJSONObject("value")), agent));
        this.put(key0, value0);
      }
    }};
    return ret;
  }

  @Override
  public AsyncRequest getAllGroups(final AsyncRpcResponse<GetAllGroupsResult> rsp) {
    return getAllGroups(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getAllGroups(final AsyncRpcResponse<GetAllGroupsResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getAllGroups", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetAllGroupsResult ret = new GetAllGroupsResult();
          ret._ret_ = new java.util.HashMap<Integer, com.raritan.idl.pdumodel.OutletGroup>() {{
            final JSONArray array0 = result.getJSONArray("_ret_");
            for (int i0 = 0; i0 < array0.length(); i0++) {
              JSONObject elem0 = array0.getJSONObject(i0);
              final Integer key0 = elem0.getInt("key");
              final com.raritan.idl.pdumodel.OutletGroup value0 = com.raritan.json_rpc.pdumodel.OutletGroup_Proxy.staticCast(ObjectProxy.decode((elem0.isNull("value") ? null : elem0.getJSONObject("value")), agent));
              this.put(key0, value0);
            }
          }};
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetGroupResult getGroup(final int id) throws Exception {
    JSONObject params = new JSONObject();
    params.put("id", id);
    final JSONObject result = rpcCall("getGroup", params);
    GetGroupResult ret = new GetGroupResult();
    ret._ret_ = result.getInt("_ret_");
    ret.group = com.raritan.json_rpc.pdumodel.OutletGroup_Proxy.staticCast(ObjectProxy.decode((result.isNull("group") ? null : result.getJSONObject("group")), agent));
    return ret;
  }

  @Override
  public AsyncRequest getGroup(final int id, final AsyncRpcResponse<GetGroupResult> rsp) {
    return getGroup(id, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getGroup(final int id, final AsyncRpcResponse<GetGroupResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("id", id);
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("getGroup", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetGroupResult ret = new GetGroupResult();
          ret._ret_ = result.getInt("_ret_");
          ret.group = com.raritan.json_rpc.pdumodel.OutletGroup_Proxy.staticCast(ObjectProxy.decode((result.isNull("group") ? null : result.getJSONObject("group")), agent));
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public DeleteGroupResult deleteGroup(final int id) throws Exception {
    JSONObject params = new JSONObject();
    params.put("id", id);
    final JSONObject result = rpcCall("deleteGroup", params);
    DeleteGroupResult ret = new DeleteGroupResult();
    ret._ret_ = result.getInt("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest deleteGroup(final int id, final AsyncRpcResponse<DeleteGroupResult> rsp) {
    return deleteGroup(id, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest deleteGroup(final int id, final AsyncRpcResponse<DeleteGroupResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("id", id);
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("deleteGroup", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          DeleteGroupResult ret = new DeleteGroupResult();
          ret._ret_ = result.getInt("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }
}
