// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from PowerMeterController.idl.

package com.raritan.json_rpc.pdumodel;

import org.json.*;

import com.raritan.idl.*;
import com.raritan.json_rpc.*;
import com.raritan.util.AsyncRequest;

public class PowerMeterController_1_0_1_Proxy extends ObjectProxy implements com.raritan.idl.pdumodel.PowerMeterController_1_0_1 {

  public PowerMeterController_1_0_1_Proxy(Agent agent, String rid, TypeInfo typeInfo) {
    super(agent, rid, typeInfo);
  }

  public PowerMeterController_1_0_1_Proxy(Agent agent, String rid) {
    this(agent, rid, com.raritan.idl.pdumodel.PowerMeterController_1_0_1.typeInfo);
  }

  public static PowerMeterController_1_0_1_Proxy staticCast(ObjectProxy proxy) {
    return proxy == null ? null : new PowerMeterController_1_0_1_Proxy(proxy.getAgent(), proxy.getRid(), proxy.getStaticTypeInfo());
  }


  @Override
  public ScanMeterBoardResult scanMeterBoard(final int powerMeterId) throws Exception {
    JSONObject params = new JSONObject();
    params.put("powerMeterId", powerMeterId);
    final JSONObject result = rpcCall("scanMeterBoard", params);
    ScanMeterBoardResult ret = new ScanMeterBoardResult();
    ret._ret_ = result.getInt("_ret_");
    ret.result = com.raritan.json_rpc.pdumodel.PowerMeterController_1_0_1.ScanResult_Codec.decode(result.getJSONObject("result"), agent);
    return ret;
  }

  @Override
  public AsyncRequest scanMeterBoard(final int powerMeterId, final AsyncRpcResponse<ScanMeterBoardResult> rsp) {
    return scanMeterBoard(powerMeterId, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest scanMeterBoard(final int powerMeterId, final AsyncRpcResponse<ScanMeterBoardResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("powerMeterId", powerMeterId);
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("scanMeterBoard", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          ScanMeterBoardResult ret = new ScanMeterBoardResult();
          ret._ret_ = result.getInt("_ret_");
          ret.result = com.raritan.json_rpc.pdumodel.PowerMeterController_1_0_1.ScanResult_Codec.decode(result.getJSONObject("result"), agent);
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetPowerMetersResult getPowerMeters() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getPowerMeters", params);
    GetPowerMetersResult ret = new GetPowerMetersResult();
    ret._ret_ = new java.util.HashMap<Integer, com.raritan.idl.pdumodel.PowerMeter_1_0_1>() {{
      final JSONArray array0 = result.getJSONArray("_ret_");
      for (int i0 = 0; i0 < array0.length(); i0++) {
        JSONObject elem0 = array0.getJSONObject(i0);
        final Integer key0 = elem0.getInt("key");
        final com.raritan.idl.pdumodel.PowerMeter_1_0_1 value0 = com.raritan.json_rpc.pdumodel.PowerMeter_1_0_1_Proxy.staticCast(ObjectProxy.decode((elem0.isNull("value") ? null : elem0.getJSONObject("value")), agent));
        this.put(key0, value0);
      }
    }};
    return ret;
  }

  @Override
  public AsyncRequest getPowerMeters(final AsyncRpcResponse<GetPowerMetersResult> rsp) {
    return getPowerMeters(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getPowerMeters(final AsyncRpcResponse<GetPowerMetersResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getPowerMeters", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetPowerMetersResult ret = new GetPowerMetersResult();
          ret._ret_ = new java.util.HashMap<Integer, com.raritan.idl.pdumodel.PowerMeter_1_0_1>() {{
            final JSONArray array0 = result.getJSONArray("_ret_");
            for (int i0 = 0; i0 < array0.length(); i0++) {
              JSONObject elem0 = array0.getJSONObject(i0);
              final Integer key0 = elem0.getInt("key");
              final com.raritan.idl.pdumodel.PowerMeter_1_0_1 value0 = com.raritan.json_rpc.pdumodel.PowerMeter_1_0_1_Proxy.staticCast(ObjectProxy.decode((elem0.isNull("value") ? null : elem0.getJSONObject("value")), agent));
              this.put(key0, value0);
            }
          }};
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public CreatePowerMeterResult createPowerMeter(final com.raritan.idl.pdumodel.PowerMeter_1_0_1.Config config, final com.raritan.idl.pdumodel.PowerMeter_1_0_1.Settings settings) throws Exception {
    JSONObject params = new JSONObject();
    params.put("config", com.raritan.json_rpc.pdumodel.PowerMeter_1_0_1.Config_Codec.encode(config));
    params.put("settings", com.raritan.json_rpc.pdumodel.PowerMeter_1_0_1.Settings_Codec.encode(settings));
    final JSONObject result = rpcCall("createPowerMeter", params);
    CreatePowerMeterResult ret = new CreatePowerMeterResult();
    ret._ret_ = result.getInt("_ret_");
    ret.powerMeter = com.raritan.json_rpc.pdumodel.PowerMeter_1_0_1_Proxy.staticCast(ObjectProxy.decode((result.isNull("powerMeter") ? null : result.getJSONObject("powerMeter")), agent));
    return ret;
  }

  @Override
  public AsyncRequest createPowerMeter(final com.raritan.idl.pdumodel.PowerMeter_1_0_1.Config config, final com.raritan.idl.pdumodel.PowerMeter_1_0_1.Settings settings, final AsyncRpcResponse<CreatePowerMeterResult> rsp) {
    return createPowerMeter(config, settings, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest createPowerMeter(final com.raritan.idl.pdumodel.PowerMeter_1_0_1.Config config, final com.raritan.idl.pdumodel.PowerMeter_1_0_1.Settings settings, final AsyncRpcResponse<CreatePowerMeterResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("config", com.raritan.json_rpc.pdumodel.PowerMeter_1_0_1.Config_Codec.encode(config));
      params.put("settings", com.raritan.json_rpc.pdumodel.PowerMeter_1_0_1.Settings_Codec.encode(settings));
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("createPowerMeter", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          CreatePowerMeterResult ret = new CreatePowerMeterResult();
          ret._ret_ = result.getInt("_ret_");
          ret.powerMeter = com.raritan.json_rpc.pdumodel.PowerMeter_1_0_1_Proxy.staticCast(ObjectProxy.decode((result.isNull("powerMeter") ? null : result.getJSONObject("powerMeter")), agent));
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public CreatePanelResult createPanel(final com.raritan.idl.pdumodel.PowerMeter_1_0_1.Config config, final com.raritan.idl.pdumodel.PowerMeter_1_0_1.Settings powerMeterSettings, final com.raritan.idl.pdumodel.Panel_1_0_1.PanelSettings panelSettings) throws Exception {
    JSONObject params = new JSONObject();
    params.put("config", com.raritan.json_rpc.pdumodel.PowerMeter_1_0_1.Config_Codec.encode(config));
    params.put("powerMeterSettings", com.raritan.json_rpc.pdumodel.PowerMeter_1_0_1.Settings_Codec.encode(powerMeterSettings));
    params.put("panelSettings", com.raritan.json_rpc.pdumodel.Panel_1_0_1.PanelSettings_Codec.encode(panelSettings));
    final JSONObject result = rpcCall("createPanel", params);
    CreatePanelResult ret = new CreatePanelResult();
    ret._ret_ = result.getInt("_ret_");
    ret.panel = com.raritan.json_rpc.pdumodel.Panel_1_0_1_Proxy.staticCast(ObjectProxy.decode((result.isNull("panel") ? null : result.getJSONObject("panel")), agent));
    return ret;
  }

  @Override
  public AsyncRequest createPanel(final com.raritan.idl.pdumodel.PowerMeter_1_0_1.Config config, final com.raritan.idl.pdumodel.PowerMeter_1_0_1.Settings powerMeterSettings, final com.raritan.idl.pdumodel.Panel_1_0_1.PanelSettings panelSettings, final AsyncRpcResponse<CreatePanelResult> rsp) {
    return createPanel(config, powerMeterSettings, panelSettings, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest createPanel(final com.raritan.idl.pdumodel.PowerMeter_1_0_1.Config config, final com.raritan.idl.pdumodel.PowerMeter_1_0_1.Settings powerMeterSettings, final com.raritan.idl.pdumodel.Panel_1_0_1.PanelSettings panelSettings, final AsyncRpcResponse<CreatePanelResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("config", com.raritan.json_rpc.pdumodel.PowerMeter_1_0_1.Config_Codec.encode(config));
      params.put("powerMeterSettings", com.raritan.json_rpc.pdumodel.PowerMeter_1_0_1.Settings_Codec.encode(powerMeterSettings));
      params.put("panelSettings", com.raritan.json_rpc.pdumodel.Panel_1_0_1.PanelSettings_Codec.encode(panelSettings));
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("createPanel", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          CreatePanelResult ret = new CreatePanelResult();
          ret._ret_ = result.getInt("_ret_");
          ret.panel = com.raritan.json_rpc.pdumodel.Panel_1_0_1_Proxy.staticCast(ObjectProxy.decode((result.isNull("panel") ? null : result.getJSONObject("panel")), agent));
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public DeletePowerMeterResult deletePowerMeter(final int powerMeterId) throws Exception {
    JSONObject params = new JSONObject();
    params.put("powerMeterId", powerMeterId);
    final JSONObject result = rpcCall("deletePowerMeter", params);
    DeletePowerMeterResult ret = new DeletePowerMeterResult();
    ret._ret_ = result.getInt("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest deletePowerMeter(final int powerMeterId, final AsyncRpcResponse<DeletePowerMeterResult> rsp) {
    return deletePowerMeter(powerMeterId, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest deletePowerMeter(final int powerMeterId, final AsyncRpcResponse<DeletePowerMeterResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("powerMeterId", powerMeterId);
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("deletePowerMeter", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          DeletePowerMeterResult ret = new DeletePowerMeterResult();
          ret._ret_ = result.getInt("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }
}
