// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from GatewaySensorManager.idl.

package com.raritan.json_rpc.peripheral;

import org.json.*;

import com.raritan.idl.*;
import com.raritan.json_rpc.*;
import com.raritan.util.AsyncRequest;

public class GatewaySensorManager_Proxy extends ObjectProxy implements com.raritan.idl.peripheral.GatewaySensorManager {

  public GatewaySensorManager_Proxy(Agent agent, String rid, TypeInfo typeInfo) {
    super(agent, rid, typeInfo);
  }

  public GatewaySensorManager_Proxy(Agent agent, String rid) {
    this(agent, rid, com.raritan.idl.peripheral.GatewaySensorManager.typeInfo);
  }

  public static GatewaySensorManager_Proxy staticCast(ObjectProxy proxy) {
    return proxy == null ? null : new GatewaySensorManager_Proxy(proxy.getAgent(), proxy.getRid(), proxy.getStaticTypeInfo());
  }


  @Override
  public GetConfigurationResult getConfiguration() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getConfiguration", params);
    GetConfigurationResult ret = new GetConfigurationResult();
    ret._ret_ = new java.util.HashMap<String, com.raritan.idl.peripheral.GatewaySensorManager.ConfigurationPackage>() {{
      final JSONArray array0 = result.getJSONArray("_ret_");
      for (int i0 = 0; i0 < array0.length(); i0++) {
        JSONObject elem0 = array0.getJSONObject(i0);
        final String key0 = elem0.getString("key");
        final com.raritan.idl.peripheral.GatewaySensorManager.ConfigurationPackage value0 = com.raritan.json_rpc.peripheral.GatewaySensorManager.ConfigurationPackage_Codec.decode(elem0.getJSONObject("value"), agent);
        this.put(key0, value0);
      }
    }};
    return ret;
  }

  @Override
  public AsyncRequest getConfiguration(final AsyncRpcResponse<GetConfigurationResult> rsp) {
    return getConfiguration(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getConfiguration(final AsyncRpcResponse<GetConfigurationResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getConfiguration", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetConfigurationResult ret = new GetConfigurationResult();
          ret._ret_ = new java.util.HashMap<String, com.raritan.idl.peripheral.GatewaySensorManager.ConfigurationPackage>() {{
            final JSONArray array0 = result.getJSONArray("_ret_");
            for (int i0 = 0; i0 < array0.length(); i0++) {
              JSONObject elem0 = array0.getJSONObject(i0);
              final String key0 = elem0.getString("key");
              final com.raritan.idl.peripheral.GatewaySensorManager.ConfigurationPackage value0 = com.raritan.json_rpc.peripheral.GatewaySensorManager.ConfigurationPackage_Codec.decode(elem0.getJSONObject("value"), agent);
              this.put(key0, value0);
            }
          }};
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public SetConfigurationResult setConfiguration(final java.util.Map<String, com.raritan.idl.peripheral.GatewaySensorManager.ConfigurationPackage> cfg) throws Exception {
    JSONObject params = new JSONObject();
    params.put("cfg", new JSONArray() {{
      java.util.Map<String, com.raritan.idl.peripheral.GatewaySensorManager.ConfigurationPackage> map0 = cfg;
      for (java.util.Map.Entry<String, com.raritan.idl.peripheral.GatewaySensorManager.ConfigurationPackage> entry0 : map0.entrySet()) {
        final java.util.Map.Entry<String, com.raritan.idl.peripheral.GatewaySensorManager.ConfigurationPackage> entry0_f = entry0;
        JSONObject elem0 = new JSONObject();
        elem0.put("key", entry0_f.getKey());
        elem0.put("value", com.raritan.json_rpc.peripheral.GatewaySensorManager.ConfigurationPackage_Codec.encode(entry0_f.getValue()));
        this.put(elem0);
      }
    }});
    final JSONObject result = rpcCall("setConfiguration", params);
    SetConfigurationResult ret = new SetConfigurationResult();
    ret._ret_ = result.getInt("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest setConfiguration(final java.util.Map<String, com.raritan.idl.peripheral.GatewaySensorManager.ConfigurationPackage> cfg, final AsyncRpcResponse<SetConfigurationResult> rsp) {
    return setConfiguration(cfg, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest setConfiguration(final java.util.Map<String, com.raritan.idl.peripheral.GatewaySensorManager.ConfigurationPackage> cfg, final AsyncRpcResponse<SetConfigurationResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("cfg", new JSONArray() {{
        java.util.Map<String, com.raritan.idl.peripheral.GatewaySensorManager.ConfigurationPackage> map0 = cfg;
        for (java.util.Map.Entry<String, com.raritan.idl.peripheral.GatewaySensorManager.ConfigurationPackage> entry0 : map0.entrySet()) {
          final java.util.Map.Entry<String, com.raritan.idl.peripheral.GatewaySensorManager.ConfigurationPackage> entry0_f = entry0;
          JSONObject elem0 = new JSONObject();
          elem0.put("key", entry0_f.getKey());
          elem0.put("value", com.raritan.json_rpc.peripheral.GatewaySensorManager.ConfigurationPackage_Codec.encode(entry0_f.getValue()));
          this.put(elem0);
        }
      }});
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("setConfiguration", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          SetConfigurationResult ret = new SetConfigurationResult();
          ret._ret_ = result.getInt("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetFeedbackResult getFeedback() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getFeedback", params);
    GetFeedbackResult ret = new GetFeedbackResult();
    ret._ret_ = new java.util.ArrayList<com.raritan.idl.peripheral.GatewaySensorManager.Feedback>() {
      private static final long serialVersionUID = 1L;
      {
        final JSONArray array0 = result.getJSONArray("_ret_");
        for (int i0 = 0; i0 < array0.length(); i0++) {
          final int i0_f = i0;
          this.add((com.raritan.idl.peripheral.GatewaySensorManager.Feedback)ValueObjectCodec.decodeAs((array0.isNull(i0_f) ? null : array0.getJSONObject(i0_f)), agent, new TypeInfo("peripheral.GatewaySensorManager.Feedback:1.0.0", null)));
        }
      }
    };
    return ret;
  }

  @Override
  public AsyncRequest getFeedback(final AsyncRpcResponse<GetFeedbackResult> rsp) {
    return getFeedback(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getFeedback(final AsyncRpcResponse<GetFeedbackResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getFeedback", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetFeedbackResult ret = new GetFeedbackResult();
          ret._ret_ = new java.util.ArrayList<com.raritan.idl.peripheral.GatewaySensorManager.Feedback>() {
            private static final long serialVersionUID = 1L;
            {
              final JSONArray array0 = result.getJSONArray("_ret_");
              for (int i0 = 0; i0 < array0.length(); i0++) {
                final int i0_f = i0;
                this.add((com.raritan.idl.peripheral.GatewaySensorManager.Feedback)ValueObjectCodec.decodeAs((array0.isNull(i0_f) ? null : array0.getJSONObject(i0_f)), agent, new TypeInfo("peripheral.GatewaySensorManager.Feedback:1.0.0", null)));
              }
            }
          };
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }
}
