// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from Port.idl.

package com.raritan.json_rpc.portsmodel;

import org.json.*;

import com.raritan.idl.*;
import com.raritan.json_rpc.*;
import com.raritan.util.AsyncRequest;

public class Port_Proxy extends ObjectProxy implements com.raritan.idl.portsmodel.Port {

  public Port_Proxy(Agent agent, String rid, TypeInfo typeInfo) {
    super(agent, rid, typeInfo);
  }

  public Port_Proxy(Agent agent, String rid) {
    this(agent, rid, com.raritan.idl.portsmodel.Port.typeInfo);
  }

  public static Port_Proxy staticCast(ObjectProxy proxy) {
    return proxy == null ? null : new Port_Proxy(proxy.getAgent(), proxy.getRid(), proxy.getStaticTypeInfo());
  }


  @Override
  public GetPropertiesResult getProperties() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getProperties", params);
    GetPropertiesResult ret = new GetPropertiesResult();
    ret._ret_ = com.raritan.json_rpc.portsmodel.Port.Properties_Codec.decode(result.getJSONObject("_ret_"), agent);
    return ret;
  }

  @Override
  public AsyncRequest getProperties(final AsyncRpcResponse<GetPropertiesResult> rsp) {
    return getProperties(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getProperties(final AsyncRpcResponse<GetPropertiesResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getProperties", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetPropertiesResult ret = new GetPropertiesResult();
          ret._ret_ = com.raritan.json_rpc.portsmodel.Port.Properties_Codec.decode(result.getJSONObject("_ret_"), agent);
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public Void setName(final String name) throws Exception {
    JSONObject params = new JSONObject();
    params.put("name", name);
    rpcCall("setName", params);
    Void ret = null;
    return ret;
  }

  @Override
  public AsyncRequest setName(final String name, final AsyncRpcResponse<Void> rsp) {
    return setName(name, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest setName(final String name, final AsyncRpcResponse<Void> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("name", name);
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("setName", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          Void ret = null;
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public SetDetectionModeResult setDetectionMode(final com.raritan.idl.portsmodel.Port.DetectionMode mode) throws Exception {
    JSONObject params = new JSONObject();
    params.put("mode", com.raritan.json_rpc.portsmodel.Port.DetectionMode_Codec.encode(mode));
    final JSONObject result = rpcCall("setDetectionMode", params);
    SetDetectionModeResult ret = new SetDetectionModeResult();
    ret._ret_ = result.getInt("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest setDetectionMode(final com.raritan.idl.portsmodel.Port.DetectionMode mode, final AsyncRpcResponse<SetDetectionModeResult> rsp) {
    return setDetectionMode(mode, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest setDetectionMode(final com.raritan.idl.portsmodel.Port.DetectionMode mode, final AsyncRpcResponse<SetDetectionModeResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("mode", com.raritan.json_rpc.portsmodel.Port.DetectionMode_Codec.encode(mode));
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("setDetectionMode", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          SetDetectionModeResult ret = new SetDetectionModeResult();
          ret._ret_ = result.getInt("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetDetectableDevicesResult getDetectableDevices() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getDetectableDevices", params);
    GetDetectableDevicesResult ret = new GetDetectableDevicesResult();
    ret._ret_ = new java.util.ArrayList<String>() {
      private static final long serialVersionUID = 1L;
      {
        final JSONArray array0 = result.getJSONArray("_ret_");
        for (int i0 = 0; i0 < array0.length(); i0++) {
          final int i0_f = i0;
          this.add(array0.getString(i0_f));
        }
      }
    };
    return ret;
  }

  @Override
  public AsyncRequest getDetectableDevices(final AsyncRpcResponse<GetDetectableDevicesResult> rsp) {
    return getDetectableDevices(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getDetectableDevices(final AsyncRpcResponse<GetDetectableDevicesResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getDetectableDevices", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetDetectableDevicesResult ret = new GetDetectableDevicesResult();
          ret._ret_ = new java.util.ArrayList<String>() {
            private static final long serialVersionUID = 1L;
            {
              final JSONArray array0 = result.getJSONArray("_ret_");
              for (int i0 = 0; i0 < array0.length(); i0++) {
                final int i0_f = i0;
                this.add(array0.getString(i0_f));
              }
            }
          };
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetDeviceResult getDevice() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getDevice", params);
    GetDeviceResult ret = new GetDeviceResult();
    ret._ret_ = ObjectProxy.decode((result.isNull("_ret_") ? null : result.getJSONObject("_ret_")), agent);
    return ret;
  }

  @Override
  public AsyncRequest getDevice(final AsyncRpcResponse<GetDeviceResult> rsp) {
    return getDevice(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getDevice(final AsyncRpcResponse<GetDeviceResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getDevice", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetDeviceResult ret = new GetDeviceResult();
          ret._ret_ = ObjectProxy.decode((result.isNull("_ret_") ? null : result.getJSONObject("_ret_")), agent);
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }
}
