// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from ServiceAuthorization.idl.

package com.raritan.json_rpc.security;

import org.json.*;

import com.raritan.idl.*;
import com.raritan.json_rpc.*;
import com.raritan.util.AsyncRequest;

public class ServiceAuthorization_Proxy extends ObjectProxy implements com.raritan.idl.security.ServiceAuthorization {

  public ServiceAuthorization_Proxy(Agent agent, String rid, TypeInfo typeInfo) {
    super(agent, rid, typeInfo);
  }

  public ServiceAuthorization_Proxy(Agent agent, String rid) {
    this(agent, rid, com.raritan.idl.security.ServiceAuthorization.typeInfo);
  }

  public static ServiceAuthorization_Proxy staticCast(ObjectProxy proxy) {
    return proxy == null ? null : new ServiceAuthorization_Proxy(proxy.getAgent(), proxy.getRid(), proxy.getStaticTypeInfo());
  }


  @Override
  public SetPasswordResult setPassword(final String service, final String password) throws Exception {
    JSONObject params = new JSONObject();
    params.put("service", service);
    params.put("password", password);
    final JSONObject result = rpcCall("setPassword", params);
    SetPasswordResult ret = new SetPasswordResult();
    ret._ret_ = result.getInt("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest setPassword(final String service, final String password, final AsyncRpcResponse<SetPasswordResult> rsp) {
    return setPassword(service, password, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest setPassword(final String service, final String password, final AsyncRpcResponse<SetPasswordResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("service", service);
      params.put("password", password);
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("setPassword", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          SetPasswordResult ret = new SetPasswordResult();
          ret._ret_ = result.getInt("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }
}
