// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from AlertedSensorManager.idl.

package com.raritan.json_rpc.sensors;

import org.json.*;

import com.raritan.idl.*;
import com.raritan.json_rpc.*;
import com.raritan.util.AsyncRequest;

public class AlertedSensorManager_1_0_4_Proxy extends ObjectProxy implements com.raritan.idl.sensors.AlertedSensorManager_1_0_4 {

  public AlertedSensorManager_1_0_4_Proxy(Agent agent, String rid, TypeInfo typeInfo) {
    super(agent, rid, typeInfo);
  }

  public AlertedSensorManager_1_0_4_Proxy(Agent agent, String rid) {
    this(agent, rid, com.raritan.idl.sensors.AlertedSensorManager_1_0_4.typeInfo);
  }

  public static AlertedSensorManager_1_0_4_Proxy staticCast(ObjectProxy proxy) {
    return proxy == null ? null : new AlertedSensorManager_1_0_4_Proxy(proxy.getAgent(), proxy.getRid(), proxy.getStaticTypeInfo());
  }


  @Override
  public GetSensorCountsResult getSensorCounts() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getSensorCounts", params);
    GetSensorCountsResult ret = new GetSensorCountsResult();
    ret._ret_ = com.raritan.json_rpc.sensors.AlertedSensorManager_1_0_4.SensorCounts_Codec.decode(result.getJSONObject("_ret_"), agent);
    return ret;
  }

  @Override
  public AsyncRequest getSensorCounts(final AsyncRpcResponse<GetSensorCountsResult> rsp) {
    return getSensorCounts(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getSensorCounts(final AsyncRpcResponse<GetSensorCountsResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getSensorCounts", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetSensorCountsResult ret = new GetSensorCountsResult();
          ret._ret_ = com.raritan.json_rpc.sensors.AlertedSensorManager_1_0_4.SensorCounts_Codec.decode(result.getJSONObject("_ret_"), agent);
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetAllSensorsResult getAllSensors() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getAllSensors", params);
    GetAllSensorsResult ret = new GetAllSensorsResult();
    ret._ret_ = new java.util.ArrayList<com.raritan.idl.sensors.AlertedSensorManager_1_0_4.SensorData>() {
      private static final long serialVersionUID = 1L;
      {
        final JSONArray array0 = result.getJSONArray("_ret_");
        for (int i0 = 0; i0 < array0.length(); i0++) {
          final int i0_f = i0;
          this.add(com.raritan.json_rpc.sensors.AlertedSensorManager_1_0_4.SensorData_Codec.decode(array0.getJSONObject(i0_f), agent));
        }
      }
    };
    return ret;
  }

  @Override
  public AsyncRequest getAllSensors(final AsyncRpcResponse<GetAllSensorsResult> rsp) {
    return getAllSensors(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getAllSensors(final AsyncRpcResponse<GetAllSensorsResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getAllSensors", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetAllSensorsResult ret = new GetAllSensorsResult();
          ret._ret_ = new java.util.ArrayList<com.raritan.idl.sensors.AlertedSensorManager_1_0_4.SensorData>() {
            private static final long serialVersionUID = 1L;
            {
              final JSONArray array0 = result.getJSONArray("_ret_");
              for (int i0 = 0; i0 < array0.length(); i0++) {
                final int i0_f = i0;
                this.add(com.raritan.json_rpc.sensors.AlertedSensorManager_1_0_4.SensorData_Codec.decode(array0.getJSONObject(i0_f), agent));
              }
            }
          };
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetAlertedSensorsResult getAlertedSensors() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getAlertedSensors", params);
    GetAlertedSensorsResult ret = new GetAlertedSensorsResult();
    ret._ret_ = new java.util.ArrayList<com.raritan.idl.sensors.AlertedSensorManager_1_0_4.SensorData>() {
      private static final long serialVersionUID = 1L;
      {
        final JSONArray array0 = result.getJSONArray("_ret_");
        for (int i0 = 0; i0 < array0.length(); i0++) {
          final int i0_f = i0;
          this.add(com.raritan.json_rpc.sensors.AlertedSensorManager_1_0_4.SensorData_Codec.decode(array0.getJSONObject(i0_f), agent));
        }
      }
    };
    return ret;
  }

  @Override
  public AsyncRequest getAlertedSensors(final AsyncRpcResponse<GetAlertedSensorsResult> rsp) {
    return getAlertedSensors(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getAlertedSensors(final AsyncRpcResponse<GetAlertedSensorsResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getAlertedSensors", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetAlertedSensorsResult ret = new GetAlertedSensorsResult();
          ret._ret_ = new java.util.ArrayList<com.raritan.idl.sensors.AlertedSensorManager_1_0_4.SensorData>() {
            private static final long serialVersionUID = 1L;
            {
              final JSONArray array0 = result.getJSONArray("_ret_");
              for (int i0 = 0; i0 < array0.length(); i0++) {
                final int i0_f = i0;
                this.add(com.raritan.json_rpc.sensors.AlertedSensorManager_1_0_4.SensorData_Codec.decode(array0.getJSONObject(i0_f), agent));
              }
            }
          };
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }
}
