// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from SerialPort.idl.

package com.raritan.json_rpc.serial;

import org.json.*;

import com.raritan.idl.*;
import com.raritan.json_rpc.*;
import com.raritan.util.AsyncRequest;

public class SerialPort_2_0_0_Proxy extends ObjectProxy implements com.raritan.idl.serial.SerialPort_2_0_0 {

  public SerialPort_2_0_0_Proxy(Agent agent, String rid, TypeInfo typeInfo) {
    super(agent, rid, typeInfo);
  }

  public SerialPort_2_0_0_Proxy(Agent agent, String rid) {
    this(agent, rid, com.raritan.idl.serial.SerialPort_2_0_0.typeInfo);
  }

  public static SerialPort_2_0_0_Proxy staticCast(ObjectProxy proxy) {
    return proxy == null ? null : new SerialPort_2_0_0_Proxy(proxy.getAgent(), proxy.getRid(), proxy.getStaticTypeInfo());
  }


  @Override
  public GetSettingsResult getSettings() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getSettings", params);
    GetSettingsResult ret = new GetSettingsResult();
    ret._ret_ = com.raritan.json_rpc.serial.SerialPort_2_0_0.Settings_Codec.decode(result.getJSONObject("_ret_"), agent);
    return ret;
  }

  @Override
  public AsyncRequest getSettings(final AsyncRpcResponse<GetSettingsResult> rsp) {
    return getSettings(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getSettings(final AsyncRpcResponse<GetSettingsResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getSettings", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetSettingsResult ret = new GetSettingsResult();
          ret._ret_ = com.raritan.json_rpc.serial.SerialPort_2_0_0.Settings_Codec.decode(result.getJSONObject("_ret_"), agent);
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public SetSettingsResult setSettings(final com.raritan.idl.serial.SerialPort_2_0_0.Settings settings) throws Exception {
    JSONObject params = new JSONObject();
    params.put("settings", com.raritan.json_rpc.serial.SerialPort_2_0_0.Settings_Codec.encode(settings));
    final JSONObject result = rpcCall("setSettings", params);
    SetSettingsResult ret = new SetSettingsResult();
    ret._ret_ = result.getInt("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest setSettings(final com.raritan.idl.serial.SerialPort_2_0_0.Settings settings, final AsyncRpcResponse<SetSettingsResult> rsp) {
    return setSettings(settings, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest setSettings(final com.raritan.idl.serial.SerialPort_2_0_0.Settings settings, final AsyncRpcResponse<SetSettingsResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("settings", com.raritan.json_rpc.serial.SerialPort_2_0_0.Settings_Codec.encode(settings));
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("setSettings", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          SetSettingsResult ret = new SetSettingsResult();
          ret._ret_ = result.getInt("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetStateResult getState() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getState", params);
    GetStateResult ret = new GetStateResult();
    ret._ret_ = com.raritan.json_rpc.serial.SerialPort_2_0_0.State_Codec.decode(result.getJSONObject("_ret_"), agent);
    return ret;
  }

  @Override
  public AsyncRequest getState(final AsyncRpcResponse<GetStateResult> rsp) {
    return getState(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getState(final AsyncRpcResponse<GetStateResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getState", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetStateResult ret = new GetStateResult();
          ret._ret_ = com.raritan.json_rpc.serial.SerialPort_2_0_0.State_Codec.decode(result.getJSONObject("_ret_"), agent);
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetModemResult getModem() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getModem", params);
    GetModemResult ret = new GetModemResult();
    ret._ret_ = ObjectProxy.decode((result.isNull("_ret_") ? null : result.getJSONObject("_ret_")), agent);
    return ret;
  }

  @Override
  public AsyncRequest getModem(final AsyncRpcResponse<GetModemResult> rsp) {
    return getModem(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getModem(final AsyncRpcResponse<GetModemResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getModem", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetModemResult ret = new GetModemResult();
          ret._ret_ = ObjectProxy.decode((result.isNull("_ret_") ? null : result.getJSONObject("_ret_")), agent);
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }
}
