// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from KeypadManager.idl.

package com.raritan.json_rpc.smartlock;

import org.json.*;

import com.raritan.idl.*;
import com.raritan.json_rpc.*;
import com.raritan.util.AsyncRequest;

public class KeypadManager_Proxy extends ObjectProxy implements com.raritan.idl.smartlock.KeypadManager {

  public KeypadManager_Proxy(Agent agent, String rid, TypeInfo typeInfo) {
    super(agent, rid, typeInfo);
  }

  public KeypadManager_Proxy(Agent agent, String rid) {
    this(agent, rid, com.raritan.idl.smartlock.KeypadManager.typeInfo);
  }

  public static KeypadManager_Proxy staticCast(ObjectProxy proxy) {
    return proxy == null ? null : new KeypadManager_Proxy(proxy.getAgent(), proxy.getRid(), proxy.getStaticTypeInfo());
  }


  @Override
  public GetKeypadsResult getKeypads() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getKeypads", params);
    GetKeypadsResult ret = new GetKeypadsResult();
    ret._ret_ = new java.util.ArrayList<com.raritan.idl.smartlock.Keypad>() {
      private static final long serialVersionUID = 1L;
      {
        final JSONArray array0 = result.getJSONArray("_ret_");
        for (int i0 = 0; i0 < array0.length(); i0++) {
          final int i0_f = i0;
          this.add(com.raritan.json_rpc.smartlock.Keypad_Proxy.staticCast(ObjectProxy.decode((array0.isNull(i0_f) ? null : array0.getJSONObject(i0_f)), agent)));
        }
      }
    };
    return ret;
  }

  @Override
  public AsyncRequest getKeypads(final AsyncRpcResponse<GetKeypadsResult> rsp) {
    return getKeypads(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getKeypads(final AsyncRpcResponse<GetKeypadsResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getKeypads", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetKeypadsResult ret = new GetKeypadsResult();
          ret._ret_ = new java.util.ArrayList<com.raritan.idl.smartlock.Keypad>() {
            private static final long serialVersionUID = 1L;
            {
              final JSONArray array0 = result.getJSONArray("_ret_");
              for (int i0 = 0; i0 < array0.length(); i0++) {
                final int i0_f = i0;
                this.add(com.raritan.json_rpc.smartlock.Keypad_Proxy.staticCast(ObjectProxy.decode((array0.isNull(i0_f) ? null : array0.getJSONObject(i0_f)), agent)));
              }
            }
          };
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetKeypadByIdResult getKeypadById(final String keypadId) throws Exception {
    JSONObject params = new JSONObject();
    params.put("keypadId", keypadId);
    final JSONObject result = rpcCall("getKeypadById", params);
    GetKeypadByIdResult ret = new GetKeypadByIdResult();
    ret._ret_ = com.raritan.json_rpc.smartlock.Keypad_Proxy.staticCast(ObjectProxy.decode((result.isNull("_ret_") ? null : result.getJSONObject("_ret_")), agent));
    return ret;
  }

  @Override
  public AsyncRequest getKeypadById(final String keypadId, final AsyncRpcResponse<GetKeypadByIdResult> rsp) {
    return getKeypadById(keypadId, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getKeypadById(final String keypadId, final AsyncRpcResponse<GetKeypadByIdResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("keypadId", keypadId);
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("getKeypadById", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetKeypadByIdResult ret = new GetKeypadByIdResult();
          ret._ret_ = com.raritan.json_rpc.smartlock.Keypad_Proxy.staticCast(ObjectProxy.decode((result.isNull("_ret_") ? null : result.getJSONObject("_ret_")), agent));
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public SetKeypadSettingsResult setKeypadSettings(final String position, final com.raritan.idl.smartlock.KeypadManager.KeypadSettings setting) throws Exception {
    JSONObject params = new JSONObject();
    params.put("position", position);
    params.put("setting", com.raritan.json_rpc.smartlock.KeypadManager.KeypadSettings_Codec.encode(setting));
    final JSONObject result = rpcCall("setKeypadSettings", params);
    SetKeypadSettingsResult ret = new SetKeypadSettingsResult();
    ret._ret_ = result.getInt("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest setKeypadSettings(final String position, final com.raritan.idl.smartlock.KeypadManager.KeypadSettings setting, final AsyncRpcResponse<SetKeypadSettingsResult> rsp) {
    return setKeypadSettings(position, setting, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest setKeypadSettings(final String position, final com.raritan.idl.smartlock.KeypadManager.KeypadSettings setting, final AsyncRpcResponse<SetKeypadSettingsResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("position", position);
      params.put("setting", com.raritan.json_rpc.smartlock.KeypadManager.KeypadSettings_Codec.encode(setting));
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("setKeypadSettings", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          SetKeypadSettingsResult ret = new SetKeypadSettingsResult();
          ret._ret_ = result.getInt("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetAllKeypadSettingsResult getAllKeypadSettings() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getAllKeypadSettings", params);
    GetAllKeypadSettingsResult ret = new GetAllKeypadSettingsResult();
    ret._ret_ = new java.util.HashMap<String, com.raritan.idl.smartlock.KeypadManager.KeypadSettings>() {{
      final JSONArray array0 = result.getJSONArray("_ret_");
      for (int i0 = 0; i0 < array0.length(); i0++) {
        JSONObject elem0 = array0.getJSONObject(i0);
        final String key0 = elem0.getString("key");
        final com.raritan.idl.smartlock.KeypadManager.KeypadSettings value0 = com.raritan.json_rpc.smartlock.KeypadManager.KeypadSettings_Codec.decode(elem0.getJSONObject("value"), agent);
        this.put(key0, value0);
      }
    }};
    return ret;
  }

  @Override
  public AsyncRequest getAllKeypadSettings(final AsyncRpcResponse<GetAllKeypadSettingsResult> rsp) {
    return getAllKeypadSettings(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getAllKeypadSettings(final AsyncRpcResponse<GetAllKeypadSettingsResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getAllKeypadSettings", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetAllKeypadSettingsResult ret = new GetAllKeypadSettingsResult();
          ret._ret_ = new java.util.HashMap<String, com.raritan.idl.smartlock.KeypadManager.KeypadSettings>() {{
            final JSONArray array0 = result.getJSONArray("_ret_");
            for (int i0 = 0; i0 < array0.length(); i0++) {
              JSONObject elem0 = array0.getJSONObject(i0);
              final String key0 = elem0.getString("key");
              final com.raritan.idl.smartlock.KeypadManager.KeypadSettings value0 = com.raritan.json_rpc.smartlock.KeypadManager.KeypadSettings_Codec.decode(elem0.getJSONObject("value"), agent);
              this.put(key0, value0);
            }
          }};
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }
}
