// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from System.idl.

package com.raritan.json_rpc.sys;

import org.json.*;

import com.raritan.idl.*;
import com.raritan.json_rpc.*;
import com.raritan.util.AsyncRequest;

public class System_Proxy extends ObjectProxy implements com.raritan.idl.sys.System {

  public System_Proxy(Agent agent, String rid, TypeInfo typeInfo) {
    super(agent, rid, typeInfo);
  }

  public System_Proxy(Agent agent, String rid) {
    this(agent, rid, com.raritan.idl.sys.System.typeInfo);
  }

  public static System_Proxy staticCast(ObjectProxy proxy) {
    return proxy == null ? null : new System_Proxy(proxy.getAgent(), proxy.getRid(), proxy.getStaticTypeInfo());
  }


  @Override
  public IsDaemonRunningResult isDaemonRunning(final String name) throws Exception {
    JSONObject params = new JSONObject();
    params.put("name", name);
    final JSONObject result = rpcCall("isDaemonRunning", params);
    IsDaemonRunningResult ret = new IsDaemonRunningResult();
    ret._ret_ = result.getBoolean("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest isDaemonRunning(final String name, final AsyncRpcResponse<IsDaemonRunningResult> rsp) {
    return isDaemonRunning(name, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest isDaemonRunning(final String name, final AsyncRpcResponse<IsDaemonRunningResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("name", name);
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("isDaemonRunning", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          IsDaemonRunningResult ret = new IsDaemonRunningResult();
          ret._ret_ = result.getBoolean("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public Void restartDaemon(final String name) throws Exception {
    JSONObject params = new JSONObject();
    params.put("name", name);
    rpcCall("restartDaemon", params);
    Void ret = null;
    return ret;
  }

  @Override
  public AsyncRequest restartDaemon(final String name, final AsyncRpcResponse<Void> rsp) {
    return restartDaemon(name, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest restartDaemon(final String name, final AsyncRpcResponse<Void> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("name", name);
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("restartDaemon", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          Void ret = null;
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }
}
