// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from TestUnit.idl.

package com.raritan.json_rpc.test;

import org.json.*;

import com.raritan.idl.*;
import com.raritan.json_rpc.*;
import com.raritan.util.AsyncRequest;

public class Unit_Proxy extends ObjectProxy implements com.raritan.idl.test.Unit {

  public Unit_Proxy(Agent agent, String rid, TypeInfo typeInfo) {
    super(agent, rid, typeInfo);
  }

  public Unit_Proxy(Agent agent, String rid) {
    this(agent, rid, com.raritan.idl.test.Unit.typeInfo);
  }

  public static Unit_Proxy staticCast(ObjectProxy proxy) {
    return proxy == null ? null : new Unit_Proxy(proxy.getAgent(), proxy.getRid(), proxy.getStaticTypeInfo());
  }


  @Override
  public GetDisplaysResult getDisplays() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getDisplays", params);
    GetDisplaysResult ret = new GetDisplaysResult();
    ret._ret_ = new java.util.ArrayList<com.raritan.idl.test.Display>() {
      private static final long serialVersionUID = 1L;
      {
        final JSONArray array0 = result.getJSONArray("_ret_");
        for (int i0 = 0; i0 < array0.length(); i0++) {
          final int i0_f = i0;
          this.add(com.raritan.json_rpc.test.Display_Proxy.staticCast(ObjectProxy.decode((array0.isNull(i0_f) ? null : array0.getJSONObject(i0_f)), agent)));
        }
      }
    };
    return ret;
  }

  @Override
  public AsyncRequest getDisplays(final AsyncRpcResponse<GetDisplaysResult> rsp) {
    return getDisplays(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getDisplays(final AsyncRpcResponse<GetDisplaysResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getDisplays", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetDisplaysResult ret = new GetDisplaysResult();
          ret._ret_ = new java.util.ArrayList<com.raritan.idl.test.Display>() {
            private static final long serialVersionUID = 1L;
            {
              final JSONArray array0 = result.getJSONArray("_ret_");
              for (int i0 = 0; i0 < array0.length(); i0++) {
                final int i0_f = i0;
                this.add(com.raritan.json_rpc.test.Display_Proxy.staticCast(ObjectProxy.decode((array0.isNull(i0_f) ? null : array0.getJSONObject(i0_f)), agent)));
              }
            }
          };
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetButtonStatesResult getButtonStates() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getButtonStates", params);
    GetButtonStatesResult ret = new GetButtonStatesResult();
    ret._ret_ = new java.util.ArrayList<Boolean>() {
      private static final long serialVersionUID = 1L;
      {
        final JSONArray array0 = result.getJSONArray("_ret_");
        for (int i0 = 0; i0 < array0.length(); i0++) {
          final int i0_f = i0;
          this.add(array0.getBoolean(i0_f));
        }
      }
    };
    return ret;
  }

  @Override
  public AsyncRequest getButtonStates(final AsyncRpcResponse<GetButtonStatesResult> rsp) {
    return getButtonStates(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getButtonStates(final AsyncRpcResponse<GetButtonStatesResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getButtonStates", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetButtonStatesResult ret = new GetButtonStatesResult();
          ret._ret_ = new java.util.ArrayList<Boolean>() {
            private static final long serialVersionUID = 1L;
            {
              final JSONArray array0 = result.getJSONArray("_ret_");
              for (int i0 = 0; i0 < array0.length(); i0++) {
                final int i0_f = i0;
                this.add(array0.getBoolean(i0_f));
              }
            }
          };
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public Void setBuzzer(final boolean isOn) throws Exception {
    JSONObject params = new JSONObject();
    params.put("isOn", isOn);
    rpcCall("setBuzzer", params);
    Void ret = null;
    return ret;
  }

  @Override
  public AsyncRequest setBuzzer(final boolean isOn, final AsyncRpcResponse<Void> rsp) {
    return setBuzzer(isOn, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest setBuzzer(final boolean isOn, final AsyncRpcResponse<Void> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("isOn", isOn);
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("setBuzzer", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          Void ret = null;
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }
}
