// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from TfwEventChannel.idl.

package com.raritan.json_rpc.tfw;

import org.json.*;

import com.raritan.idl.*;
import com.raritan.json_rpc.*;
import com.raritan.util.AsyncRequest;

public class EventChannel_Proxy extends ObjectProxy implements com.raritan.idl.tfw.EventChannel {

  public EventChannel_Proxy(Agent agent, String rid, TypeInfo typeInfo) {
    super(agent, rid, typeInfo);
  }

  public EventChannel_Proxy(Agent agent, String rid) {
    this(agent, rid, com.raritan.idl.tfw.EventChannel.typeInfo);
  }

  public static EventChannel_Proxy staticCast(ObjectProxy proxy) {
    return proxy == null ? null : new EventChannel_Proxy(proxy.getAgent(), proxy.getRid(), proxy.getStaticTypeInfo());
  }


  @Override
  public PollNextEventsResult pollNextEvents() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("pollNextEvents", params);
    PollNextEventsResult ret = new PollNextEventsResult();
    ret._ret_ = result.getBoolean("_ret_");
    ret.events = new java.util.ArrayList<com.raritan.idl.tfw.Event>() {
      private static final long serialVersionUID = 1L;
      {
        final JSONArray array0 = result.getJSONArray("events");
        for (int i0 = 0; i0 < array0.length(); i0++) {
          final int i0_f = i0;
          this.add(com.raritan.json_rpc.tfw.Event_Codec.decode(array0.getJSONObject(i0_f), agent));
        }
      }
    };
    return ret;
  }

  @Override
  public AsyncRequest pollNextEvents(final AsyncRpcResponse<PollNextEventsResult> rsp) {
    return pollNextEvents(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest pollNextEvents(final AsyncRpcResponse<PollNextEventsResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("pollNextEvents", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          PollNextEventsResult ret = new PollNextEventsResult();
          ret._ret_ = result.getBoolean("_ret_");
          ret.events = new java.util.ArrayList<com.raritan.idl.tfw.Event>() {
            private static final long serialVersionUID = 1L;
            {
              final JSONArray array0 = result.getJSONArray("events");
              for (int i0 = 0; i0 < array0.length(); i0++) {
                final int i0_f = i0;
                this.add(com.raritan.json_rpc.tfw.Event_Codec.decode(array0.getJSONObject(i0_f), agent));
              }
            }
          };
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public Void demandEventType(final com.raritan.idl.tfw.EventType evttype) throws Exception {
    JSONObject params = new JSONObject();
    params.put("evttype", com.raritan.json_rpc.tfw.EventType_Codec.encode(evttype));
    rpcCall("demandEventType", params);
    Void ret = null;
    return ret;
  }

  @Override
  public AsyncRequest demandEventType(final com.raritan.idl.tfw.EventType evttype, final AsyncRpcResponse<Void> rsp) {
    return demandEventType(evttype, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest demandEventType(final com.raritan.idl.tfw.EventType evttype, final AsyncRpcResponse<Void> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("evttype", com.raritan.json_rpc.tfw.EventType_Codec.encode(evttype));
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("demandEventType", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          Void ret = null;
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public Void demandEventTypes(final java.util.List<com.raritan.idl.tfw.EventType> evttypes) throws Exception {
    JSONObject params = new JSONObject();
    params.put("evttypes", new JSONArray() {{
      final java.util.List<com.raritan.idl.tfw.EventType> array0 = evttypes;
      for (int i0 = 0; i0 < array0.size(); i0++) {
        final int i0_f = i0;
        this.put(com.raritan.json_rpc.tfw.EventType_Codec.encode(array0.get(i0_f)));
      }
    }});
    rpcCall("demandEventTypes", params);
    Void ret = null;
    return ret;
  }

  @Override
  public AsyncRequest demandEventTypes(final java.util.List<com.raritan.idl.tfw.EventType> evttypes, final AsyncRpcResponse<Void> rsp) {
    return demandEventTypes(evttypes, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest demandEventTypes(final java.util.List<com.raritan.idl.tfw.EventType> evttypes, final AsyncRpcResponse<Void> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("evttypes", new JSONArray() {{
        final java.util.List<com.raritan.idl.tfw.EventType> array0 = evttypes;
        for (int i0 = 0; i0 < array0.size(); i0++) {
          final int i0_f = i0;
          this.put(com.raritan.json_rpc.tfw.EventType_Codec.encode(array0.get(i0_f)));
        }
      }});
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("demandEventTypes", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          Void ret = null;
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public DemandEventResult demandEvent(final com.raritan.idl.tfw.EventType evttype, final Object src) throws Exception {
    JSONObject params = new JSONObject();
    params.put("evttype", com.raritan.json_rpc.tfw.EventType_Codec.encode(evttype));
    params.put("src", src != null ? ((ObjectProxy) src).encode() : JSONObject.NULL);
    final JSONObject result = rpcCall("demandEvent", params);
    DemandEventResult ret = new DemandEventResult();
    ret._ret_ = result.getInt("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest demandEvent(final com.raritan.idl.tfw.EventType evttype, final Object src, final AsyncRpcResponse<DemandEventResult> rsp) {
    return demandEvent(evttype, src, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest demandEvent(final com.raritan.idl.tfw.EventType evttype, final Object src, final AsyncRpcResponse<DemandEventResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("evttype", com.raritan.json_rpc.tfw.EventType_Codec.encode(evttype));
      params.put("src", src != null ? ((ObjectProxy) src).encode() : JSONObject.NULL);
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("demandEvent", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          DemandEventResult ret = new DemandEventResult();
          ret._ret_ = result.getInt("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public DemandEventsResult demandEvents(final java.util.List<com.raritan.idl.tfw.Event> events) throws Exception {
    JSONObject params = new JSONObject();
    params.put("events", new JSONArray() {{
      final java.util.List<com.raritan.idl.tfw.Event> array0 = events;
      for (int i0 = 0; i0 < array0.size(); i0++) {
        final int i0_f = i0;
        this.put(com.raritan.json_rpc.tfw.Event_Codec.encode(array0.get(i0_f)));
      }
    }});
    final JSONObject result = rpcCall("demandEvents", params);
    DemandEventsResult ret = new DemandEventsResult();
    ret._ret_ = result.getInt("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest demandEvents(final java.util.List<com.raritan.idl.tfw.Event> events, final AsyncRpcResponse<DemandEventsResult> rsp) {
    return demandEvents(events, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest demandEvents(final java.util.List<com.raritan.idl.tfw.Event> events, final AsyncRpcResponse<DemandEventsResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("events", new JSONArray() {{
        final java.util.List<com.raritan.idl.tfw.Event> array0 = events;
        for (int i0 = 0; i0 < array0.size(); i0++) {
          final int i0_f = i0;
          this.put(com.raritan.json_rpc.tfw.Event_Codec.encode(array0.get(i0_f)));
        }
      }});
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("demandEvents", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          DemandEventsResult ret = new DemandEventsResult();
          ret._ret_ = result.getInt("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public Void cancelEventType(final com.raritan.idl.tfw.EventType evttype) throws Exception {
    JSONObject params = new JSONObject();
    params.put("evttype", com.raritan.json_rpc.tfw.EventType_Codec.encode(evttype));
    rpcCall("cancelEventType", params);
    Void ret = null;
    return ret;
  }

  @Override
  public AsyncRequest cancelEventType(final com.raritan.idl.tfw.EventType evttype, final AsyncRpcResponse<Void> rsp) {
    return cancelEventType(evttype, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest cancelEventType(final com.raritan.idl.tfw.EventType evttype, final AsyncRpcResponse<Void> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("evttype", com.raritan.json_rpc.tfw.EventType_Codec.encode(evttype));
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("cancelEventType", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          Void ret = null;
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public Void cancelEventTypes(final java.util.List<com.raritan.idl.tfw.EventType> evttypes) throws Exception {
    JSONObject params = new JSONObject();
    params.put("evttypes", new JSONArray() {{
      final java.util.List<com.raritan.idl.tfw.EventType> array0 = evttypes;
      for (int i0 = 0; i0 < array0.size(); i0++) {
        final int i0_f = i0;
        this.put(com.raritan.json_rpc.tfw.EventType_Codec.encode(array0.get(i0_f)));
      }
    }});
    rpcCall("cancelEventTypes", params);
    Void ret = null;
    return ret;
  }

  @Override
  public AsyncRequest cancelEventTypes(final java.util.List<com.raritan.idl.tfw.EventType> evttypes, final AsyncRpcResponse<Void> rsp) {
    return cancelEventTypes(evttypes, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest cancelEventTypes(final java.util.List<com.raritan.idl.tfw.EventType> evttypes, final AsyncRpcResponse<Void> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("evttypes", new JSONArray() {{
        final java.util.List<com.raritan.idl.tfw.EventType> array0 = evttypes;
        for (int i0 = 0; i0 < array0.size(); i0++) {
          final int i0_f = i0;
          this.put(com.raritan.json_rpc.tfw.EventType_Codec.encode(array0.get(i0_f)));
        }
      }});
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("cancelEventTypes", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          Void ret = null;
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public Void cancelEvent(final com.raritan.idl.tfw.EventType evttype, final Object src) throws Exception {
    JSONObject params = new JSONObject();
    params.put("evttype", com.raritan.json_rpc.tfw.EventType_Codec.encode(evttype));
    params.put("src", src != null ? ((ObjectProxy) src).encode() : JSONObject.NULL);
    rpcCall("cancelEvent", params);
    Void ret = null;
    return ret;
  }

  @Override
  public AsyncRequest cancelEvent(final com.raritan.idl.tfw.EventType evttype, final Object src, final AsyncRpcResponse<Void> rsp) {
    return cancelEvent(evttype, src, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest cancelEvent(final com.raritan.idl.tfw.EventType evttype, final Object src, final AsyncRpcResponse<Void> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("evttype", com.raritan.json_rpc.tfw.EventType_Codec.encode(evttype));
      params.put("src", src != null ? ((ObjectProxy) src).encode() : JSONObject.NULL);
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("cancelEvent", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          Void ret = null;
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public Void cancelEvents(final java.util.List<com.raritan.idl.tfw.Event> events) throws Exception {
    JSONObject params = new JSONObject();
    params.put("events", new JSONArray() {{
      final java.util.List<com.raritan.idl.tfw.Event> array0 = events;
      for (int i0 = 0; i0 < array0.size(); i0++) {
        final int i0_f = i0;
        this.put(com.raritan.json_rpc.tfw.Event_Codec.encode(array0.get(i0_f)));
      }
    }});
    rpcCall("cancelEvents", params);
    Void ret = null;
    return ret;
  }

  @Override
  public AsyncRequest cancelEvents(final java.util.List<com.raritan.idl.tfw.Event> events, final AsyncRpcResponse<Void> rsp) {
    return cancelEvents(events, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest cancelEvents(final java.util.List<com.raritan.idl.tfw.Event> events, final AsyncRpcResponse<Void> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("events", new JSONArray() {{
        final java.util.List<com.raritan.idl.tfw.Event> array0 = events;
        for (int i0 = 0; i0 < array0.size(); i0++) {
          final int i0_f = i0;
          this.put(com.raritan.json_rpc.tfw.Event_Codec.encode(array0.get(i0_f)));
        }
      }});
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("cancelEvents", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          Void ret = null;
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }
}
