// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2025 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from WebcamChannel.idl.

package com.raritan.json_rpc.webcam;

import org.json.*;

import com.raritan.idl.*;
import com.raritan.json_rpc.*;
import com.raritan.util.AsyncRequest;

public class Channel_Proxy extends ObjectProxy implements com.raritan.idl.webcam.Channel {

  public Channel_Proxy(Agent agent, String rid, TypeInfo typeInfo) {
    super(agent, rid, typeInfo);
  }

  public Channel_Proxy(Agent agent, String rid) {
    this(agent, rid, com.raritan.idl.webcam.Channel.typeInfo);
  }

  public static Channel_Proxy staticCast(ObjectProxy proxy) {
    return proxy == null ? null : new Channel_Proxy(proxy.getAgent(), proxy.getRid(), proxy.getStaticTypeInfo());
  }


  @Override
  public GetClientTypeResult getClientType() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getClientType", params);
    GetClientTypeResult ret = new GetClientTypeResult();
    ret._ret_ = result.getString("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest getClientType(final AsyncRpcResponse<GetClientTypeResult> rsp) {
    return getClientType(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getClientType(final AsyncRpcResponse<GetClientTypeResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getClientType", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetClientTypeResult ret = new GetClientTypeResult();
          ret._ret_ = result.getString("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetWebcamResult getWebcam() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getWebcam", params);
    GetWebcamResult ret = new GetWebcamResult();
    ret._ret_ = com.raritan.json_rpc.webcam.Webcam_2_0_0_Proxy.staticCast(ObjectProxy.decode((result.isNull("_ret_") ? null : result.getJSONObject("_ret_")), agent));
    return ret;
  }

  @Override
  public AsyncRequest getWebcam(final AsyncRpcResponse<GetWebcamResult> rsp) {
    return getWebcam(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getWebcam(final AsyncRpcResponse<GetWebcamResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getWebcam", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetWebcamResult ret = new GetWebcamResult();
          ret._ret_ = com.raritan.json_rpc.webcam.Webcam_2_0_0_Proxy.staticCast(ObjectProxy.decode((result.isNull("_ret_") ? null : result.getJSONObject("_ret_")), agent));
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public IsAvailableResult isAvailable() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("isAvailable", params);
    IsAvailableResult ret = new IsAvailableResult();
    ret._ret_ = result.getBoolean("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest isAvailable(final AsyncRpcResponse<IsAvailableResult> rsp) {
    return isAvailable(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest isAvailable(final AsyncRpcResponse<IsAvailableResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("isAvailable", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          IsAvailableResult ret = new IsAvailableResult();
          ret._ret_ = result.getBoolean("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public Void release() throws Exception {
    JSONObject params = null;
    rpcCall("release", params);
    Void ret = null;
    return ret;
  }

  @Override
  public AsyncRequest release(final AsyncRpcResponse<Void> rsp) {
    return release(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest release(final AsyncRpcResponse<Void> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("release", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          Void ret = null;
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public CaptureImageResult captureImage() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("captureImage", params);
    CaptureImageResult ret = new CaptureImageResult();
    ret._ret_ = result.getInt("_ret_");
    ret.image = com.raritan.json_rpc.webcam.Image_2_0_0_Codec.decode(result.getJSONObject("image"), agent);
    return ret;
  }

  @Override
  public AsyncRequest captureImage(final AsyncRpcResponse<CaptureImageResult> rsp) {
    return captureImage(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest captureImage(final AsyncRpcResponse<CaptureImageResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("captureImage", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          CaptureImageResult ret = new CaptureImageResult();
          ret._ret_ = result.getInt("_ret_");
          ret.image = com.raritan.json_rpc.webcam.Image_2_0_0_Codec.decode(result.getJSONObject("image"), agent);
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public TriggerCaptureResult triggerCapture() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("triggerCapture", params);
    TriggerCaptureResult ret = new TriggerCaptureResult();
    ret._ret_ = result.getInt("_ret_");
    ret.captureToken = result.getString("captureToken");
    return ret;
  }

  @Override
  public AsyncRequest triggerCapture(final AsyncRpcResponse<TriggerCaptureResult> rsp) {
    return triggerCapture(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest triggerCapture(final AsyncRpcResponse<TriggerCaptureResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("triggerCapture", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          TriggerCaptureResult ret = new TriggerCaptureResult();
          ret._ret_ = result.getInt("_ret_");
          ret.captureToken = result.getString("captureToken");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }
}
